/*
 * 
 */
package gov.va.med.mpn.codedcontrol.model;

import gov.va.med.mpn.entity.pojo.CodedControlData;

import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;


/** 
 * The Class UserResponse.  A Class UserResponse manages response and data for each coded control
 * request call. The Boolean attribute defaulted to success indicates a successfull call and message includes
 * error messages as well as system messages and codedControls List contains the list of controls returned from database.
 * <p> 
 * <A HREF="http://www.hp.com"> Hewlett-Packard Enterprise Services</A> 
 * </p> 
 * 
 * @author <a href="mailto:pratap.chilukuri@hp.com">Pratap Chilukuri</a> 
 */

@XmlRootElement
@XmlAccessorType(XmlAccessType.FIELD)
public class UserResponse
{
	
	/** The coded controls. */
	private List<CodedControlData> codedControls;
	
	/** The message. */
	private String message;
	
	/** The success. */
	private Boolean success = true;

	/**
	 * Gets the coded controls.
	 *
	 * @return the coded controls
	 */
	public List<CodedControlData> getCodedControls()
	{
		return codedControls;
	}

	/**
	 * Sets the coded controls.
	 *
	 * @param codedControls the new coded controls
	 */
	public void setCodedControls(List<CodedControlData> codedControls)
	{
		this.codedControls = codedControls;
	}

	/**
	 * Checks if is success.
	 *
	 * @return the boolean
	 */
	public Boolean isSuccess()
	{
		return success;
	}

	/**
	 * Sets the success.
	 *
	 * @param success the new success
	 */
	public void setSuccess(Boolean success)
	{
		this.success = success;
	}

	/**
	 * Gets the message.
	 *
	 * @return the message
	 */
	public String getMessage()
	{
		return message;
	}

	/**
	 * Sets the message.
	 *
	 * @param message the new message
	 */
	public void setMessage(String message)
	{
		this.message = message;
	}
}
