@echo off
REM ###########################################################################
REM Script generated by HP Fortify SCA Scan Wizard (c) HP Fortify 2011
REM Created on 2015/02/07 22:27:31
REM ###########################################################################
REM Generated for the following languages:
REM 	Java
REM 	XML
REM ###########################################################################
REM DEBUG - if set to true, runs SCA in debug mode
REM SOURCEANALYZER - the name of the SCA executable
REM BUILDID - the SCA build id
REM LAUNCHERSWITCHES - the launcher settings that are used to invoke SCA
REM ARGFILE - the name of the argument file that's extracted and passed to SCA
REM MEMORY - the memory settings for SCA
REM OLDFILENUMBER - this defines the file which contains the number of files within the project, it is automatically generated
REM FILENOMAXDIFF - this is the percentage of difference between the number of files which will trigger a warning by the script
REM ###########################################################################

set DEBUG=false
set SOURCEANALYZER=sourceanalyzer
set FPR="..\scanResults\Fortifycodedcontrolservice.fpr"
set BUILDID="codedcontrolservice"
set ARGFILE="Fortifycodedcontrolservice.bat.args"
set MEMORY=-Xmx2048M -Xms2048M -Xss128M 
set LAUNCHERSWITCHES=""
set OLDFILENUMBER=Fortifycodedcontrolservice.bat.fileno
set FILENOMAXDIFF=10

set PROJECTROOT0="..\..\codedcontrolservice"
IF NOT EXIST %PROJECTROOT0% (
   ECHO  ERROR: This script is being run on a different machine than it was
   ECHO         generated on or the targeted project has been moved. This script is 
   ECHO         configured to locate files at
   ECHO            %PROJECTROOT0%
   ECHO         Please modify the %%PROJECTROOT0%% variable found
   ECHO         at the top of this script to point to the corresponding directory
   ECHO         located on this machine.
   GOTO :FINISHED
)

IF %DEBUG%==true set LAUNCHERSWITCHES=-debug %LAUNCHERSWITCHES%
echo Extracting Arguments File


echo. >Fortifycodedcontrolservice.bat.args
SETLOCAL ENABLEDELAYEDEXPANSION
IF EXIST %0 (
   set SCAScriptFile=%0
) ELSE (
  set SCAScriptFile=%0.bat
)

set PROJECTROOT0=%PROJECTROOT0:)=^)%
FOR /f "delims=" %%a IN ('findstr /B /C:"REM ARGS" %SCAScriptFile%' ) DO (
   set argVal=%%a
   set argVal=!argVal:PROJECTROOT0_MARKER=%PROJECTROOT0:~1,-1%!
   echo !argVal:~9! >> %ARGFILE%
)
ENDLOCAL

REM ###########################################################################
echo Cleaning previous scan artifacts
%SOURCEANALYZER% %MEMORY% %LAUNCHERSWITCHES% -b %BUILDID% -clean 
IF %ERRORLEVEL%==1 (
echo Sourceanalyzer failed, exiting
GOTO :FINISHED
)
REM ###########################################################################
echo Translating files
%SOURCEANALYZER% %MEMORY% %LAUNCHERSWITCHES% -b %BUILDID% @%ARGFILE%
IF %ERRORLEVEL%==1 (
echo Sourceanalyzer failed, exiting
GOTO :FINISHED
)
REM ###########################################################################
echo Testing Difference between Translations
SETLOCAL
FOR /F "delims=" %%A in ('%SOURCEANALYZER% -b %BUILDID% -show-files ^| findstr /R /N "^" ^| find /C ":" ') DO SET FILENUMBER=%%A
IF NOT EXIST %OLDFILENUMBER% (
	ECHO It appears to be the first time running this script, setting %OLDFILENUMBER% to %FILENUMBER%
	ECHO %FILENUMBER% > %OLDFILENUMBER%
	GOTO TESTENDED
)

FOR /F "delims=" %%i IN (%OLDFILENUMBER%) DO SET OLDFILENO=%%i
set /a DIFF=%OLDFILENO% * %FILENOMAXDIFF%
set /a DIFF /=  100
set /a MAX=%OLDFILENO% + %DIFF%
set /a MIN=%OLDFILENO% - %DIFF%

IF %FILENUMBER% LSS %MIN% set SHOWWARNING=true
IF %FILENUMBER% GTR %MAX% set SHOWWARNING=true

IF DEFINED SHOWWARNING (
	ECHO WARNING: The number of files has changed by over %FILENOMAXDIFF%%%, it is recommended 
	ECHO          that this script is regenerated with the ScanWizard
)
:TESTENDED
ENDLOCAL

REM ###########################################################################
echo Starting scan
%SOURCEANALYZER% %MEMORY% %LAUNCHERSWITCHES% -b %BUILDID% -scan -f %FPR%
IF %ERRORLEVEL%==1 (
echo Sourceanalyzer failed, exiting
GOTO :FINISHED
)
REM ###########################################################################
echo Finished
:FINISHED
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\persistence\dao\target\classes\gov\va\med\mpn\dao\CategoryDAOImpl.class;PROJECTROOT0_MARKER\persistence\dao\target\classes\gov\va\med\mpn\dao\ClassificationDAOImpl.class;PROJECTROOT0_MARKER\persistence\dao\target\classes\gov\va\med\mpn\dao\CodedControlDataDAOImpl.class;PROJECTROOT0_MARKER\persistence\dao\target\classes\gov\va\med\mpn\dao\constants\CategoryConstants.class;PROJECTROOT0_MARKER\persistence\dao\target\classes\gov\va\med\mpn\dao\constants\ClassificationConstants.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\persistence\dao\target\classes\gov\va\med\mpn\dao\constants\CodedControlDataConstants.class;PROJECTROOT0_MARKER\persistence\dao\target\classes\gov\va\med\mpn\dao\core\CategoryDAOCoreImpl.class;PROJECTROOT0_MARKER\persistence\dao\target\classes\gov\va\med\mpn\dao\core\ClassificationDAOCoreImpl.class;PROJECTROOT0_MARKER\persistence\dao\target\classes\gov\va\med\mpn\dao\core\CodedControlDataDAOCoreImpl.class;PROJECTROOT0_MARKER\persistence\dao\target\classes\gov\va\med\mpn\dao\core\interfaces\CategoryDAOCore.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\persistence\dao\target\classes\gov\va\med\mpn\dao\core\interfaces\ClassificationDAOCore.class;PROJECTROOT0_MARKER\persistence\dao\target\classes\gov\va\med\mpn\dao\core\interfaces\CodedControlDataDAOCore.class;PROJECTROOT0_MARKER\persistence\dao\target\classes\gov\va\med\mpn\dao\interfaces\CategoryDAO.class;PROJECTROOT0_MARKER\persistence\dao\target\classes\gov\va\med\mpn\dao\interfaces\ClassificationDAO.class;PROJECTROOT0_MARKER\persistence\dao\target\classes\gov\va\med\mpn\dao\interfaces\CodedControlDataDAO.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\persistence\dao\target\classes\gov\va\med\mpn\entity\pojo\Category.class;PROJECTROOT0_MARKER\persistence\dao\target\classes\gov\va\med\mpn\entity\pojo\CategoryCore.class;PROJECTROOT0_MARKER\persistence\dao\target\classes\gov\va\med\mpn\entity\pojo\Classification.class;PROJECTROOT0_MARKER\persistence\dao\target\classes\gov\va\med\mpn\entity\pojo\ClassificationCore.class;PROJECTROOT0_MARKER\persistence\dao\target\classes\gov\va\med\mpn\entity\pojo\CodedControlData.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\persistence\dao\target\classes\gov\va\med\mpn\entity\pojo\CodedControlDataCore.class;PROJECTROOT0_MARKER\persistence\dao\target\dependency\va-dao-core\gov\va\med\dao\core\GenericHibernateDAOImpl.class;PROJECTROOT0_MARKER\persistence\dao\target\dependency\va-dao-core\gov\va\med\dao\core\interfaces\GenericDAO.class;PROJECTROOT0_MARKER\persistence\dao\target\mpn-dao-1.00-SNAPSHOT.jar;PROJECTROOT0_MARKER\persistence\dao\target\test-classes\gov\va\med\mpn\AbstractTestDAO.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\persistence\dao\target\test-classes\gov\va\med\mpn\CategoryTest.class;PROJECTROOT0_MARKER\persistence\dao\target\test-classes\gov\va\med\mpn\ClassesTest.class;PROJECTROOT0_MARKER\persistence\dao\target\test-classes\gov\va\med\mpn\CodedControlDataTest.class;PROJECTROOT0_MARKER\persistence\hbm\target\mpn-hbm-1.00-SNAPSHOT.jar;PROJECTROOT0_MARKER\persistence\pojo\target\classes\gov\va\med\mpn\entity\pojo\Category.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\persistence\pojo\target\classes\gov\va\med\mpn\entity\pojo\CategoryCore.class;PROJECTROOT0_MARKER\persistence\pojo\target\classes\gov\va\med\mpn\entity\pojo\Classification.class;PROJECTROOT0_MARKER\persistence\pojo\target\classes\gov\va\med\mpn\entity\pojo\ClassificationCore.class;PROJECTROOT0_MARKER\persistence\pojo\target\classes\gov\va\med\mpn\entity\pojo\CodedControlData.class;PROJECTROOT0_MARKER\persistence\pojo\target\classes\gov\va\med\mpn\entity\pojo\CodedControlDataCore.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\persistence\pojo\target\mpn-pojo-1.00-SNAPSHOT.jar;PROJECTROOT0_MARKER\ws\target\classes\gov\va\med\mpn\codedcontrol\CodedControl.class;PROJECTROOT0_MARKER\ws\target\classes\gov\va\med\mpn\codedcontrol\impl\CodedControlService.class;PROJECTROOT0_MARKER\ws\target\classes\gov\va\med\mpn\codedcontrol\model\Category.class;PROJECTROOT0_MARKER\ws\target\classes\gov\va\med\mpn\codedcontrol\model\Classification.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\ws\target\classes\gov\va\med\mpn\codedcontrol\model\Control.class;PROJECTROOT0_MARKER\ws\target\classes\gov\va\med\mpn\codedcontrol\model\UserResponse.class;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\classes\gov\va\med\mpn\codedcontrol\CodedControl.class;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\classes\gov\va\med\mpn\codedcontrol\impl\CodedControlService.class;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\classes\gov\va\med\mpn\codedcontrol\model\Category.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\classes\gov\va\med\mpn\codedcontrol\model\Classification.class;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\classes\gov\va\med\mpn\codedcontrol\model\Control.class;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\classes\gov\va\med\mpn\codedcontrol\model\UserResponse.class;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\antlr-2.7.7.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\aopalliance-1.0.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\asm-3.3.1.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\commons-dbcp-1.2.2.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\commons-lang-2.6.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\commons-lang3-3.1.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\commons-logging-1.1.3.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\commons-pool-1.6.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\cxf-core-3.0.0.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\cxf-rt-frontend-jaxrs-3.0.0.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\cxf-rt-rs-client-3.0.0.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\cxf-rt-rs-extension-providers-3.0.0.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\cxf-rt-rs-extension-search-3.0.0.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\cxf-rt-transports-http-3.0.0.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\dom4j-1.6.1.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\gson-1.7.1.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\hibernate-commons-annotations-4.0.5.Final.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\hibernate-core-4.3.6.Final.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\hibernate-entitymanager-4.3.6.Final.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\hibernate-jpa-2.1-api-1.0.0.Final.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\jandex-1.1.0.Final.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\javassist-3.18.1-GA.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\javax.annotation-api-1.2.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\javax.ws.rs-api-2.0.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\jboss-logging-3.1.3.GA.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\jboss-logging-annotations-1.2.0.Beta1.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\jboss-transaction-api_1.2_spec-1.0.0.Final.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\jcl-over-slf4j-1.7.7.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\jettison-1.3.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\jtds-1.3.1.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\log4j-1.2.17.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\mpn-dao-1.00-SNAPSHOT.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\mpn-pojo-1.00-SNAPSHOT.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\slf4j-api-1.7.7.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\slf4j-log4j12-1.7.7.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\spring-aop-4.0.5.RELEASE.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\spring-beans-4.0.5.RELEASE.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\spring-context-4.0.5.RELEASE.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\spring-core-4.0.5.RELEASE.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\spring-expression-4.0.5.RELEASE.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\spring-jdbc-4.0.5.RELEASE.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\spring-jmx-2.0.8.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\spring-orm-4.0.5.RELEASE.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\spring-tx-4.0.5.RELEASE.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\spring-web-4.0.5.RELEASE.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\stax-api-1.0.1.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\stax2-api-3.1.4.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\va-dao-core-1.00.000-SNAPSHOT.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\va-pojo-core-1.00.000-SNAPSHOT.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\woodstox-core-asl-4.3.0.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\xml-apis-1.0.b2.jar;PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\lib\xmlschema-core-2.1.0.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\ws\target\test-classes\gov\va\med\mpn\codedcontrols\CodedControlsServiceTest.class"
REM ARGS "-source"
REM ARGS "1.7"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\dao\target\classes\va-dao.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\dao\target\dependency\mpn-hbm\META-INF\maven\gov.va.med.mpn.codedcontrolservice\mpn-hbm\pom.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\dao\target\dependency\mpn-hbm\va-dao.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\dao\target\dependency\va-dao-core\META-INF\maven\gov.va.med.persistence\va-dao-core\pom.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\dao\target\maven-archiver\pom.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\dao\target\test-classes\va-dao.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\hbm\target\classes\va-dao.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\hbm\target\maven-archiver\pom.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\pojo\target\dependency\mpn-hbm\META-INF\maven\gov.va.med.mpn.codedcontrolservice\mpn-hbm\pom.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\pojo\target\dependency\mpn-hbm\va-dao.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\pojo\target\dependency\va-pojo-core\META-INF\maven\gov.va.med.persistence\va-pojo-core\pom.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\pojo\target\generated-sources\hibernate-tools\resources\messages.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\pojo\target\maven-archiver\pom.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\ws\target\maven-archiver\pom.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\pom.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\pom.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\dao\pom.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\dao\target\classes\META-INF\persistence.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\dao\target\classes\mpn-dao-spring-beans.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\dao\target\classes\spring-beans-dao-test.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\dao\target\dependency\mpn-hbm\gov\va\med\mpn\entity\pojo\Category.hbm.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\dao\target\dependency\mpn-hbm\gov\va\med\mpn\entity\pojo\Classification.hbm.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\dao\target\dependency\mpn-hbm\gov\va\med\mpn\entity\pojo\CodedControlData.hbm.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\dao\target\dependency\mpn-hbm\META-INF\maven\gov.va.med.mpn.codedcontrolservice\mpn-hbm\pom.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\dao\target\dependency\va-dao-core\META-INF\maven\gov.va.med.persistence\va-dao-core\pom.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\dao\target\generated-test-resources\hibernate-tools\xml\META-INF\mpn-dao-easymock-spring-beans.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\dao\target\surefire-reports\TEST-gov.va.med.mpn.CategoryTest.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\dao\target\surefire-reports\TEST-gov.va.med.mpn.ClassesTest.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\dao\target\surefire-reports\TEST-gov.va.med.mpn.CodedControlDataTest.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\dao\target\test-classes\log4j.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\dao\target\test-classes\mpn-dao-spring-beans-test.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\dao\target\test-classes\spring-beans-test-bkup.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\hbm\pom.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\hbm\target\classes\gov\va\med\mpn\entity\pojo\Category.hbm.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\hbm\target\classes\gov\va\med\mpn\entity\pojo\Classification.hbm.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\hbm\target\classes\gov\va\med\mpn\entity\pojo\CodedControlData.hbm.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\pojo\pom.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\pojo\target\antrun\build-main.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\pojo\target\dependency\mpn-hbm\gov\va\med\mpn\entity\pojo\Category.hbm.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\pojo\target\dependency\mpn-hbm\gov\va\med\mpn\entity\pojo\Classification.hbm.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\pojo\target\dependency\mpn-hbm\gov\va\med\mpn\entity\pojo\CodedControlData.hbm.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\pojo\target\dependency\mpn-hbm\META-INF\maven\gov.va.med.mpn.codedcontrolservice\mpn-hbm\pom.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\persistence\pojo\target\dependency\va-pojo-core\META-INF\maven\gov.va.med.persistence\va-pojo-core\pom.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\ws\pom.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\ws\target\classes\log4j.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\ws\target\classes\mpn-service-spring-beans.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\classes\log4j.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\classes\mpn-service-spring-beans.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\ws\target\codedcontrols\WEB-INF\web.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\ws\target\surefire-reports\TEST-gov.va.med.mpn.codedcontrols.CodedControlsServiceTest.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\ws\target\test-classes\log4j.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\ws\target\test-classes\mpn-service-spring-beans-test.xml"
REM ARGS "PROJECTROOT0_MARKER"
