@echo off
REM ###########################################################################
REM Script generated by HP Fortify SCA Scan Wizard (c) HP Fortify 2011
REM Created on 2015/02/07 22:36:09
REM ###########################################################################
REM Generated for the following languages:
REM 	Java
REM 	XML
REM ###########################################################################
REM DEBUG - if set to true, runs SCA in debug mode
REM SOURCEANALYZER - the name of the SCA executable
REM BUILDID - the SCA build id
REM LAUNCHERSWITCHES - the launcher settings that are used to invoke SCA
REM ARGFILE - the name of the argument file that's extracted and passed to SCA
REM MEMORY - the memory settings for SCA
REM OLDFILENUMBER - this defines the file which contains the number of files within the project, it is automatically generated
REM FILENOMAXDIFF - this is the percentage of difference between the number of files which will trigger a warning by the script
REM ###########################################################################

set DEBUG=false
set SOURCEANALYZER=sourceanalyzer
set FPR="..\scanresults\Fortifyextract.fpr"
set BUILDID="extract"
set ARGFILE="Fortifyextract.bat.args"
set MEMORY=-Xmx2048M -Xms2048M -Xss128M 
set LAUNCHERSWITCHES=""
set OLDFILENUMBER=Fortifyextract.bat.fileno
set FILENOMAXDIFF=10

set PROJECTROOT0="..\..\extract"
IF NOT EXIST %PROJECTROOT0% (
   ECHO  ERROR: This script is being run on a different machine than it was
   ECHO         generated on or the targeted project has been moved. This script is 
   ECHO         configured to locate files at
   ECHO            %PROJECTROOT0%
   ECHO         Please modify the %%PROJECTROOT0%% variable found
   ECHO         at the top of this script to point to the corresponding directory
   ECHO         located on this machine.
   GOTO :FINISHED
)

IF %DEBUG%==true set LAUNCHERSWITCHES=-debug %LAUNCHERSWITCHES%
echo Extracting Arguments File


echo. >Fortifyextract.bat.args
SETLOCAL ENABLEDELAYEDEXPANSION
IF EXIST %0 (
   set SCAScriptFile=%0
) ELSE (
  set SCAScriptFile=%0.bat
)

set PROJECTROOT0=%PROJECTROOT0:)=^)%
FOR /f "delims=" %%a IN ('findstr /B /C:"REM ARGS" %SCAScriptFile%' ) DO (
   set argVal=%%a
   set argVal=!argVal:PROJECTROOT0_MARKER=%PROJECTROOT0:~1,-1%!
   echo !argVal:~9! >> %ARGFILE%
)
ENDLOCAL

REM ###########################################################################
echo Cleaning previous scan artifacts
%SOURCEANALYZER% %MEMORY% %LAUNCHERSWITCHES% -b %BUILDID% -clean 
IF %ERRORLEVEL%==1 (
echo Sourceanalyzer failed, exiting
GOTO :FINISHED
)
REM ###########################################################################
echo Translating files
%SOURCEANALYZER% %MEMORY% %LAUNCHERSWITCHES% -b %BUILDID% @%ARGFILE%
IF %ERRORLEVEL%==1 (
echo Sourceanalyzer failed, exiting
GOTO :FINISHED
)
REM ###########################################################################
echo Testing Difference between Translations
SETLOCAL
FOR /F "delims=" %%A in ('%SOURCEANALYZER% -b %BUILDID% -show-files ^| findstr /R /N "^" ^| find /C ":" ') DO SET FILENUMBER=%%A
IF NOT EXIST %OLDFILENUMBER% (
	ECHO It appears to be the first time running this script, setting %OLDFILENUMBER% to %FILENUMBER%
	ECHO %FILENUMBER% > %OLDFILENUMBER%
	GOTO TESTENDED
)

FOR /F "delims=" %%i IN (%OLDFILENUMBER%) DO SET OLDFILENO=%%i
set /a DIFF=%OLDFILENO% * %FILENOMAXDIFF%
set /a DIFF /=  100
set /a MAX=%OLDFILENO% + %DIFF%
set /a MIN=%OLDFILENO% - %DIFF%

IF %FILENUMBER% LSS %MIN% set SHOWWARNING=true
IF %FILENUMBER% GTR %MAX% set SHOWWARNING=true

IF DEFINED SHOWWARNING (
	ECHO WARNING: The number of files has changed by over %FILENOMAXDIFF%%%, it is recommended 
	ECHO          that this script is regenerated with the ScanWizard
)
:TESTENDED
ENDLOCAL

REM ###########################################################################
echo Starting scan
%SOURCEANALYZER% %MEMORY% %LAUNCHERSWITCHES% -b %BUILDID% -scan -f %FPR%
IF %ERRORLEVEL%==1 (
echo Sourceanalyzer failed, exiting
GOTO :FINISHED
)
REM ###########################################################################
echo Finished
:FINISHED
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\classes\gov\va\med\mpn\extract\ExtractService.class;PROJECTROOT0_MARKER\target\extract\WEB-INF\classes\gov\va\med\mpn\extract\ExtractService.class;PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\aopalliance-1.0.jar;PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\bcmail-jdk14-136.jar;PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\bcprov-jdk14-136.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\commons-lang3-3.1.jar;PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\commons-logging-1.1.3.jar;PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\cxf-core-3.0.0.jar;PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\cxf-rt-frontend-jaxrs-3.0.0.jar;PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\cxf-rt-rs-client-3.0.0.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\cxf-rt-rs-extension-providers-3.0.0.jar;PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\cxf-rt-rs-extension-search-3.0.0.jar;PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\cxf-rt-transports-http-3.0.0.jar;PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\fontbox-0.1.0.jar;PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\javax.annotation-api-1.2.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\javax.ws.rs-api-2.0.jar;PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\jempbox-0.2.0.jar;PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\log4j-1.2.17.jar;PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\pdfbox-0.7.3.jar;PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\slf4j-api-1.7.7.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\slf4j-log4j12-1.7.7.jar;PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\spring-aop-4.0.5.RELEASE.jar;PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\spring-beans-4.0.5.RELEASE.jar;PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\spring-context-4.0.5.RELEASE.jar;PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\spring-core-4.0.5.RELEASE.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\spring-expression-4.0.5.RELEASE.jar;PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\spring-web-4.0.5.RELEASE.jar;PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\stax2-api-3.1.4.jar;PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\woodstox-core-asl-4.3.0.jar;PROJECTROOT0_MARKER\target\extract\WEB-INF\lib\xmlschema-core-2.1.0.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\test-classes\gov\va\med\mpn\extract\ExtractServiceTest.class"
REM ARGS "-source"
REM ARGS "1.7"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\maven-archiver\pom.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\classes\applicationContext.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\classes\log4j.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\extract\WEB-INF\classes\applicationContext.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\extract\WEB-INF\classes\log4j.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\extract\WEB-INF\web.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\surefire-reports\TEST-gov.va.med.mpn.extract.ExtractServiceTest.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\applicationContext-test.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\applicationContext_test.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\hypertension_dbq.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\log4j.xml"
REM ARGS "PROJECTROOT0_MARKER"
