@echo off
REM ###########################################################################
REM Script generated by HP Fortify SCA Scan Wizard (c) HP Fortify 2011
REM Created on 2015/02/07 23:03:56
REM ###########################################################################
REM Generated for the following languages:
REM 	Javascript
REM ###########################################################################
REM DEBUG - if set to true, runs SCA in debug mode
REM SOURCEANALYZER - the name of the SCA executable
REM BUILDID - the SCA build id
REM LAUNCHERSWITCHES - the launcher settings that are used to invoke SCA
REM ARGFILE - the name of the argument file that's extracted and passed to SCA
REM MEMORY - the memory settings for SCA
REM OLDFILENUMBER - this defines the file which contains the number of files within the project, it is automatically generated
REM FILENOMAXDIFF - this is the percentage of difference between the number of files which will trigger a warning by the script
REM ###########################################################################

set DEBUG=false
set SOURCEANALYZER=sourceanalyzer
set FPR="..\scanresults\Fortifyforms_JS.fpr"
set BUILDID="forms"
set ARGFILE="Fortifyforms_JS.bat.args"
set MEMORY=-Xmx8192M -Xms8192M -Xss256M 
set LAUNCHERSWITCHES=""
set OLDFILENUMBER=Fortifyforms_JS.bat.fileno
set FILENOMAXDIFF=10

set PROJECTROOT0="..\..\forms"
IF NOT EXIST %PROJECTROOT0% (
   ECHO  ERROR: This script is being run on a different machine than it was
   ECHO         generated on or the targeted project has been moved. This script is 
   ECHO         configured to locate files at
   ECHO            %PROJECTROOT0%
   ECHO         Please modify the %%PROJECTROOT0%% variable found
   ECHO         at the top of this script to point to the corresponding directory
   ECHO         located on this machine.
   GOTO :FINISHED
)

IF %DEBUG%==true set LAUNCHERSWITCHES=-debug %LAUNCHERSWITCHES%
echo Extracting Arguments File


echo. >Fortifyforms_JS.bat.args
SETLOCAL ENABLEDELAYEDEXPANSION
IF EXIST %0 (
   set SCAScriptFile=%0
) ELSE (
  set SCAScriptFile=%0.bat
)

set PROJECTROOT0=%PROJECTROOT0:)=^)%
FOR /f "delims=" %%a IN ('findstr /B /C:"REM ARGS" %SCAScriptFile%' ) DO (
   set argVal=%%a
   set argVal=!argVal:PROJECTROOT0_MARKER=%PROJECTROOT0:~1,-1%!
   echo !argVal:~9! >> %ARGFILE%
)
ENDLOCAL

REM ###########################################################################
echo Cleaning previous scan artifacts
%SOURCEANALYZER% %MEMORY% %LAUNCHERSWITCHES% -b %BUILDID% -clean 
IF %ERRORLEVEL%==1 (
echo Sourceanalyzer failed, exiting
GOTO :FINISHED
)
REM ###########################################################################
echo Translating files
%SOURCEANALYZER% %MEMORY% %LAUNCHERSWITCHES% -b %BUILDID% @%ARGFILE%
IF %ERRORLEVEL%==1 (
echo Sourceanalyzer failed, exiting
GOTO :FINISHED
)
REM ###########################################################################
echo Testing Difference between Translations
SETLOCAL
FOR /F "delims=" %%A in ('%SOURCEANALYZER% -b %BUILDID% -show-files ^| findstr /R /N "^" ^| find /C ":" ') DO SET FILENUMBER=%%A
IF NOT EXIST %OLDFILENUMBER% (
	ECHO It appears to be the first time running this script, setting %OLDFILENUMBER% to %FILENUMBER%
	ECHO %FILENUMBER% > %OLDFILENUMBER%
	GOTO TESTENDED
)

FOR /F "delims=" %%i IN (%OLDFILENUMBER%) DO SET OLDFILENO=%%i
set /a DIFF=%OLDFILENO% * %FILENOMAXDIFF%
set /a DIFF /=  100
set /a MAX=%OLDFILENO% + %DIFF%
set /a MIN=%OLDFILENO% - %DIFF%

IF %FILENUMBER% LSS %MIN% set SHOWWARNING=true
IF %FILENUMBER% GTR %MAX% set SHOWWARNING=true

IF DEFINED SHOWWARNING (
	ECHO WARNING: The number of files has changed by over %FILENOMAXDIFF%%%, it is recommended 
	ECHO          that this script is regenerated with the ScanWizard
)
:TESTENDED
ENDLOCAL

REM ###########################################################################
echo Starting scan
%SOURCEANALYZER% %MEMORY% %LAUNCHERSWITCHES% -b %BUILDID% -scan -f %FPR%
IF %ERRORLEVEL%==1 (
echo Sourceanalyzer failed, exiting
GOTO :FINISHED
)
REM ###########################################################################
echo Finished
:FINISHED
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\activation-1.1.1.jar;PROJECTROOT0_MARKER\lib\ant-1_6_5.jar;PROJECTROOT0_MARKER\lib\ant-contrib-1.0b3.jar;PROJECTROOT0_MARKER\lib\ant-jsch-1_6_5.jar;PROJECTROOT0_MARKER\lib\ant-junit-1.7.1.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\apache-mime4j-0.6.jar;PROJECTROOT0_MARKER\lib\avalon-framework-4_2_0.jar;PROJECTROOT0_MARKER\lib\avalon-framework-cvs-20020315.jar;PROJECTROOT0_MARKER\lib\axis_1_2_1-axis.jar;PROJECTROOT0_MARKER\lib\axis_1_2_1-jaxrpc.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\axis_1_2_1-saaj.jar;PROJECTROOT0_MARKER\lib\axis_1_2_1-wsdl4j-1.5.1.jar;PROJECTROOT0_MARKER\lib\barcode4j-1.0.jar;PROJECTROOT0_MARKER\lib\batic-dependency-xmlgraphics-commons-1.4.jar;PROJECTROOT0_MARKER\lib\batik-all-1_7.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\bsf-2_2.jar;PROJECTROOT0_MARKER\lib\castor-0_9_4_3-xml.jar;PROJECTROOT0_MARKER\lib\classes12.jar;PROJECTROOT0_MARKER\lib\commons-beanutils-1_5.jar;PROJECTROOT0_MARKER\lib\commons-cli-1_0.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\commons-codec-1.6.jar;PROJECTROOT0_MARKER\lib\commons-collections-3.2.1.jar;PROJECTROOT0_MARKER\lib\commons-dbcp-1.1.jar;PROJECTROOT0_MARKER\lib\commons-digester-1_5.jar;PROJECTROOT0_MARKER\lib\commons-discovery-0.4.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\commons-exec-1.1-sources.jar;PROJECTROOT0_MARKER\lib\commons-exec-1.1.jar;PROJECTROOT0_MARKER\lib\commons-fileupload-1.2.2.jar;PROJECTROOT0_MARKER\lib\commons-io-2.0.1.jar;PROJECTROOT0_MARKER\lib\commons-lang3-3.1.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\commons-pool-1.6.jar;PROJECTROOT0_MARKER\lib\commons-validator-1.4.0.jar;PROJECTROOT0_MARKER\lib\dom4j-1_6_1-src.jar;PROJECTROOT0_MARKER\lib\dom4j-1_6_1.jar;PROJECTROOT0_MARKER\lib\ehcache-core-2.6.3.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\ejb-2_0.jar;PROJECTROOT0_MARKER\lib\exist-1_4_1_dev_orbeon_20110104.jar;PROJECTROOT0_MARKER\lib\exist-dependency-antlr-2.7.7.jar;PROJECTROOT0_MARKER\lib\exist-dependency-jgroups-all-2.2.6.jar;PROJECTROOT0_MARKER\lib\exist-dependency-jta-1.1.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\exist-dependency-lucene-core-2.9.2.jar;PROJECTROOT0_MARKER\lib\exist-dependency-lucene-regex-2.9.2.jar;PROJECTROOT0_MARKER\lib\exist-dependency-quartz-1.6.6.jar;PROJECTROOT0_MARKER\lib\exist-dependency-resolver-1.2.jar;PROJECTROOT0_MARKER\lib\exist-dependency-stax-api-1.0.1.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\exist-dependency-ws-commons-util-1.0.2.jar;PROJECTROOT0_MARKER\lib\exist-dependency-xmldb.jar;PROJECTROOT0_MARKER\lib\exist-dependency-xmlrpc-client-3.1.2.jar;PROJECTROOT0_MARKER\lib\exist-dependency-xmlrpc-common-3.1.2.jar;PROJECTROOT0_MARKER\lib\exist-dependency-xmlrpc-server-3.1.2.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\exist-lucene-module-1_4_1_dev_orbeon_20110104.jar;PROJECTROOT0_MARKER\lib\exist-modules-1_4_1_dev_orbeon_20110104.jar;PROJECTROOT0_MARKER\lib\exist-ngram-module-1_4_1_dev_orbeon_20110104.jar;PROJECTROOT0_MARKER\lib\exist-optional-1_4_1_dev_orbeon_20110104.jar;PROJECTROOT0_MARKER\lib\exist-xqj-1.0.1.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\fluent-hc-4.3.5.jar;PROJECTROOT0_MARKER\lib\flying-saucer-core-9.0.2-20140523.jar;PROJECTROOT0_MARKER\lib\flying-saucer-dependency-itext-2.1.7.jar;PROJECTROOT0_MARKER\lib\flying-saucer-pdf-9.0.2-20140523.jar;PROJECTROOT0_MARKER\lib\fop-1_0.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\guava-13.0.1.jar;PROJECTROOT0_MARKER\lib\hamcrest-core-1.3.jar;PROJECTROOT0_MARKER\lib\httpclient-4.3.5.jar;PROJECTROOT0_MARKER\lib\httpclient-cache-4.3.5.jar;PROJECTROOT0_MARKER\lib\httpcore-4.3.2.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\httpmime-4.3.5.jar;PROJECTROOT0_MARKER\lib\ironjacamar-jdbc-1.0.9.Final.jar;PROJECTROOT0_MARKER\lib\itext-bcmail-jdk14-138.jar;PROJECTROOT0_MARKER\lib\itext-bcprov-jdk14-138.jar;PROJECTROOT0_MARKER\lib\jakarta-poi-1.11.0-dev-20030610.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\jarjar-1.3.jar;PROJECTROOT0_MARKER\lib\jaxen-1_1_beta_9.jar;PROJECTROOT0_MARKER\lib\jboss-common-jdbc-wrapper.jar;PROJECTROOT0_MARKER\lib\jcifs-1.3.14.jar;PROJECTROOT0_MARKER\lib\jcl-over-slf4j-1.7.7.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\jfreechart-1.0.9.jar;PROJECTROOT0_MARKER\lib\jfreechart-dependency-jcommon-1.0.12.jar;PROJECTROOT0_MARKER\lib\jgraph-1_0_4.jar;PROJECTROOT0_MARKER\lib\jms-api-1_1.jar;PROJECTROOT0_MARKER\lib\joda-convert-1.2.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\joda-time-2.1.jar;PROJECTROOT0_MARKER\lib\jsch-0.1.42.jar;PROJECTROOT0_MARKER\lib\json-20090211.jar;PROJECTROOT0_MARKER\lib\jtidy-8.0-20060801.131059-3.jar;PROJECTROOT0_MARKER\lib\junit-4.11.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\liferay-portal-service-6.1.1.jar;PROJECTROOT0_MARKER\lib\log4j-1.2.17.jar;PROJECTROOT0_MARKER\lib\looks-1_1_2.jar;PROJECTROOT0_MARKER\lib\mail-1_3_2.jar;PROJECTROOT0_MARKER\lib\metadata-extractor-2.7.0.SNAPSHOT.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\metadata-extractor-dependency-xmpcore-5.1.2.jar;PROJECTROOT0_MARKER\lib\mockito-all-1.8.5.jar;PROJECTROOT0_MARKER\lib\mongo-2.5.3.jar;PROJECTROOT0_MARKER\lib\mongo-casbah-commons_2.8.1-2.1.2.jar;PROJECTROOT0_MARKER\lib\mongo-casbah-core_2.8.1-2.1.2.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\mongo-casbah-gridfs_2.8.1-2.1.2.jar;PROJECTROOT0_MARKER\lib\mongo-casbah-query_2.8.1-2.1.2.jar;PROJECTROOT0_MARKER\lib\mongo-scalaj-collection_2.8.0-1.0.jar;PROJECTROOT0_MARKER\lib\mongo-time_2.8.1-0.3.jar;PROJECTROOT0_MARKER\lib\msv-20081113-orbeon.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\mysql-2_0_12.jar;PROJECTROOT0_MARKER\lib\mysql-connector-java-5.1.26-bin.jar;PROJECTROOT0_MARKER\lib\oracle\ojdbc6_g.jar;PROJECTROOT0_MARKER\lib\oracle\xdb.jar;PROJECTROOT0_MARKER\lib\oracle\xmlparserv2.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\oracle-weblogic-7.0.jar;PROJECTROOT0_MARKER\lib\orbeon-errorified-20130923.jar;PROJECTROOT0_MARKER\lib\parboiled-core-1.1.4-sources.jar;PROJECTROOT0_MARKER\lib\parboiled-core-1.1.4.jar;PROJECTROOT0_MARKER\lib\parboiled-scala_2.10-1.1.4-sources.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\parboiled-scala_2.10-1.1.4.jar;PROJECTROOT0_MARKER\lib\pdfbox-0_7_1.jar;PROJECTROOT0_MARKER\lib\portlet-api_2.0.jar;PROJECTROOT0_MARKER\lib\proguard-5.0.beta2.jar;PROJECTROOT0_MARKER\lib\resolver-xerces_2_6_2_orbeon.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\rhino-1.7R2.jar;PROJECTROOT0_MARKER\lib\saxon-9-1-0-8_orbeon_20131113.jar;PROJECTROOT0_MARKER\lib\saxpath-dev_orbeon.jar;PROJECTROOT0_MARKER\lib\sbinary_2.10-0.4.1.jar;PROJECTROOT0_MARKER\lib\scala-compiler-2.10.3.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\scala-library-2.10.3.jar;PROJECTROOT0_MARKER\lib\scala-reflect-2.10.3.jar;PROJECTROOT0_MARKER\lib\scalatest_2.10-2.0.M5b.jar;PROJECTROOT0_MARKER\lib\selenium-java-2.43.1-srcs.jar;PROJECTROOT0_MARKER\lib\selenium-java-2.43.1.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\servlet-2_3-4_0_4.jar;PROJECTROOT0_MARKER\lib\simplecaptcha-1.2.1.jar;PROJECTROOT0_MARKER\lib\slf4j-api-1.7.7.jar;PROJECTROOT0_MARKER\lib\slf4j-log4j12-1.7.7.jar;PROJECTROOT0_MARKER\lib\spray-json_2.10-1.2.3-sources.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\spray-json_2.10-1.2.3.jar;PROJECTROOT0_MARKER\lib\sqljdbc4.jar;PROJECTROOT0_MARKER\lib\src\metadata-extractor-2.7.0.SNAPSHOT-src.jar;PROJECTROOT0_MARKER\lib\src\msv-20081113_orbeon_20081209.jar;PROJECTROOT0_MARKER\lib\src\msv-isorelax-20070407.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\src\msv-relaxngDatatype-20070407.jar;PROJECTROOT0_MARKER\lib\src\msv-xsdlib-20070407_orbeon_20120712.jar;PROJECTROOT0_MARKER\lib\src\scala-library-src-2.10.1.jar;PROJECTROOT0_MARKER\lib\src\scalatest_2.9.0-2.0.M5b-sources.jar;PROJECTROOT0_MARKER\lib\src\xerces-resolver-2.11.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\src\xerces-serializer-2.11.jar;PROJECTROOT0_MARKER\lib\src\xerces-xercesImpl-2.11.jar;PROJECTROOT0_MARKER\lib\tagsoup-1.2.jar;PROJECTROOT0_MARKER\lib\tomcat-5_5-naming-factory-dbcp.jar;PROJECTROOT0_MARKER\lib\typesafe-config-2.10.1.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\tyrex-1.0.jar;PROJECTROOT0_MARKER\lib\xerces-2.11-orbeon.jar;PROJECTROOT0_MARKER\lib\xqj2-0.0.1.jar;PROJECTROOT0_MARKER\lib\xqjapi.jar;PROJECTROOT0_MARKER\lib\xsu12.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\lib\yui-compressor-ant-task-0.5.jar;PROJECTROOT0_MARKER\lib\yuicompressor-2.4.7.jar;PROJECTROOT0_MARKER\src\resources-packaged\ops\opensign\OpenSign-bootstrapped.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\activation-1.1.1.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\activation-1.1.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\ant-1_6_5.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\ant-jsch-1_6_5.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\antlr-2.7.6.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\aopalliance-1.0.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\apache-mime4j-0.6.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\asm-3.1.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\AuthServicesLib-4.1.0-SNAPSHOT.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\avalon-framework-4_2_0.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\axis_1_2_1-axis.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\axis_1_2_1-jaxrpc.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\axis_1_2_1-saaj.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\axis_1_2_1-wsdl4j-1.5.1.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\barcode4j-1.0.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\batic-dependency-xmlgraphics-commons-1.4.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\batik-all-1_7.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\castor-0_9_4_3-xml.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\cglib-2.2.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\cglib-nodep-2.2.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\commons-beanutils-1.8.3.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\commons-cli-1_0.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\commons-codec-1.6.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\commons-collections-3.2.1.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\commons-digester-1_5.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\commons-discovery-0.4.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\commons-fileupload-1.2.2.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\commons-io-2.1.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\commons-lang-2.6.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\commons-lang3-3.1.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\commons-logging-1.1.3.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\commons-math-1.2.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\commons-pool-1.6.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\commons-validator-1.4.0.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\dom4j-1.6.1.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\ehcache-core-2.6.3.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\flying-saucer-core-9.0.2-20140523.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\flying-saucer-dependency-itext-2.1.7.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\flying-saucer-pdf-9.0.2-20140523.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\fop-1_0.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\guava-13.0.1.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\HealthAdapterLib-0.1.0-SNAPSHOT.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\hibernate-annotations-3.5.6-Final.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\hibernate-commons-annotations-3.2.0.Final.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\hibernate-core-3.5.6-Final.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\hibernate-entitymanager-3.5.6-Final.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\hibernate-jpa-2.0-api-1.0.0.Final.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\httpclient-4.3.5.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\httpcore-4.3.2.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\httpmime-4.3.5.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\itext-bcmail-jdk14-138.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\itext-bcprov-jdk14-138.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jackson-annotations-2.4.0.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jackson-core-2.4.1.1.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jackson-core-asl-1.9.2.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jackson-databind-2.4.1.3.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jackson-jaxrs-1.9.2.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jackson-mapper-asl-1.9.2.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jackson-xc-1.9.2.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jakarta-poi-1.11.0-dev-20030610.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\javassist-3.9.0.GA.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jaxb-api-2.2.2.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jaxb-impl-2.2.3-1.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jaxen-1_1_beta_9.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jcifs-1.3.14.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jcl-over-slf4j-1.6.1.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jcl-over-slf4j-1.7.7.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jdom-1.0.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jersey-client-1.12.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jersey-core-1.12.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jersey-json-1.12.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jettison-1.1.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jfreechart-1.0.9.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jfreechart-dependency-jcommon-1.0.12.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jms-api-1_1.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\joda-time-2.1.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jsch-0.1.42.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jsr311-api-1.1.1.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jstl-1.2.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jta-1.1.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\jtidy-8.0-20060801.131059-3.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\log4j-1.2.17.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\mail-1_3_2.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\metadata-extractor-2.7.0.SNAPSHOT.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\metadata-extractor-dependency-xmpcore-5.1.2.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\mongo-java-driver-2.10.1.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\mpn-app-ext-1.19-SNAPSHOT.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\mpn-app-form-builder.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\mpn-app-form-runner.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\mpn-app-resources-private.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\mpn-app-resources-public.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\mpn-app-xforms-filter.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\mpn-app.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\mpn-auth-1.19-SNAPSHOT.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\msv-20081113-orbeon.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\orbeon-errorified-20130923.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\parboiled-core-1.1.4.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\parboiled-scala_2.10-1.1.4.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\pdfbox-0_7_1.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\rhino-1.7R2.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\rome-0.9.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\saxon-9-1-0-8_orbeon_20131113.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\saxpath-dev_orbeon.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\sbinary_2.10-0.4.1.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\scala-library-2.10.3.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\simplecaptcha-1.2.1.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\slf4j-api-1.7.7.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\slf4j-log4j12-1.7.7.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\spray-json_2.10-1.2.3.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\spring-aop-4.0.5.RELEASE.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\spring-beans-4.0.5.RELEASE.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\spring-context-4.0.5.RELEASE.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\spring-core-4.0.5.RELEASE.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\spring-expression-4.0.5.RELEASE.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\spring-jdbc-3.0.5.RELEASE.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\spring-security-config-3.2.4.RELEASE.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\spring-security-core-3.2.4.RELEASE.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\spring-security-oauth2-1.0.4.RELEASE.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\spring-security-web-3.2.4.RELEASE.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\spring-tx-3.1.1.RELEASE.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\spring-web-4.0.5.RELEASE.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\spring-webmvc-4.0.5.RELEASE.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\stax-api-1.0-2.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\stax-api-1.0.1.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\tagsoup-1.2.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\xerces-2.11-orbeon.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\xml-apis-1.3.04.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\xmlpull-1.1.3.1.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\xpp3_min-1.1.4c.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\xqj2-0.0.1.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\xqjapi.jar;PROJECTROOT0_MARKER\target\mpn\WEB-INF\lib\xstream-1.4.2.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\biz\taoconsulting\oxf\processor\converter\FromPdfConverter.class;PROJECTROOT0_MARKER\build\classes\biz\taoconsulting\oxf\processor\converter\PdfMetadataXMLReceiver.class;PROJECTROOT0_MARKER\build\classes\gov\va\med\mpn\constants\ContextParameterNames.class;PROJECTROOT0_MARKER\build\classes\gov\va\med\mpn\constants\SessionAttributeNames.class;PROJECTROOT0_MARKER\build\classes\gov\va\med\mpn\xpl\processor\MpnProcessorUtils.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\gov\va\med\mpn\xpl\processor\SessionLogoutProcessor.class;PROJECTROOT0_MARKER\build\classes\gov\va\med\mpn\xpl\processor\SessionPropertiesProcessor.class;PROJECTROOT0_MARKER\build\classes\gov\va\med\mpn\xpl\processor\SessionTimeoutWarningProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$attribute$1$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$attribute$1$$anonfun$apply$7.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$attribute$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$attribute$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$className$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$className$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$combinator$1$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$combinator$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$combinator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$combinator$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$dimension$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$dimension$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$escape$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$escape$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$expression$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$expression$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$filters$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$filters$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$functionalPseudo$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$functionalPseudo$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$hash$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$hash$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$ident$1$$anonfun$apply$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$ident$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$ident$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$minus$1$$anonfun$apply$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$minus$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$minus$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$namespacePrefix$1$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$namespacePrefix$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$namespacePrefix$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$negation$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$negation$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$negationArg$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$negationArg$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$NewLine$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$NewLine$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$nmchar$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$nmchar$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$nmstart$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$nmstart$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$nonascii$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$nonascii$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$number$1$$anonfun$apply$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$number$1$$anonfun$apply$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$number$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$number$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$OptWhiteSpace$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$OptWhiteSpace$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$plus$1$$anonfun$apply$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$plus$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$plus$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$pseudo$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$pseudo$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$selector$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$selector$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$selectorsGroup$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$selectorsGroup$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$simpleSelectorSequence$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$simpleSelectorSequence$1$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$simpleSelectorSequence$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$simpleSelectorSequence$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$string$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$string$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$string1$1$$anonfun$apply$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$string1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$string1$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$string2$1$$anonfun$apply$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$string2$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$string2$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$typeSelector$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$typeSelector$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$unicode$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$unicode$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$universal$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$universal$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$WhiteSpace$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$$anonfun$WhiteSpace$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$AttributeFilter$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$AttributeFilter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$AttributePredicate$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$AttributePredicate.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$ChildCombinator$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$ClassFilter$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$ClassFilter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$Combinator$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$Combinator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$DescendantCombinator$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$DimensionExpr$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$DimensionExpr.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$ElementWithFiltersSelector$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$ElementWithFiltersSelector.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$Expr.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$Filter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$FollowingCombinator$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$FunctionalPseudoClassFilter$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$FunctionalPseudoClassFilter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$IdentExpr$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$IdentExpr.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$IdFilter$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$IdFilter.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$ImmediatelyFollowingCombinator$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$MinusExpr$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$NegationFilter$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$NegationFilter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$NumberExpr$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$NumberExpr.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$PlusExpr$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$PseudoClassFilter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$Selector$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$Selector.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$SelectorNode.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$SimpleElementSelector.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$SimplePseudoClassFilter$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$SimplePseudoClassFilter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$StringExpr$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$StringExpr.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$TypeSelector$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$TypeSelector.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$UniversalSelector$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser$UniversalSelector.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\css\CSSSelectorParser.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\exception\OrbeonFormatter$$anonfun$getAllLocationData$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\exception\OrbeonFormatter$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\exception\OrbeonFormatter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\Cache.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\Cacheable.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\CacheEntry.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\CacheKey.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\CacheKeyImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\CacheLinkedList$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\CacheLinkedList$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\CacheLinkedList$ListEntry.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\CacheLinkedList.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\CacheStatistics.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\CacheUtils.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\CompoundInputCacheKey.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\CompoundOutputCacheKey.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\InputCacheKey.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\InternalCacheKey.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\MemoryCacheImpl$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\MemoryCacheImpl$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\MemoryCacheImpl$MemoryCacheStatistics.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\MemoryCacheImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\ObjectCache.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\OutputCacheKey.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\SimpleOutputCacheKey.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\SoftCacheImpl$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\SoftCacheImpl$Action.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\SoftCacheImpl$Entry.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\SoftCacheImpl$EntryCache$ObjectIterator.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\SoftCacheImpl$EntryCache.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\SoftCacheImpl$Key$Comparator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\SoftCacheImpl$Key.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\SoftCacheImpl$LocalStats.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\SoftCacheImpl$SequenceIterator.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\SoftCacheImpl$SmartReference.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\SoftCacheImpl$SoftEntry.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\SoftCacheImpl$Stats.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\SoftCacheImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\cache\SoftMemoryCacheImpl.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\CEVersion$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\CEVersion$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\CEVersion.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\Defaults$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\Defaults.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\OrbeonLocationException$$anonfun$getAllLocationData$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\OrbeonLocationException$$anonfun$org$orbeon$oxf$common$OrbeonLocationException$$getLocationData$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\OrbeonLocationException$$anonfun$wrapException$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\OrbeonLocationException$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\OrbeonLocationException.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\OXFException.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$$anonfun$dateFromVersionNumber$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$$anonfun$dateFromVersionNumber$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$$anonfun$fromResourceManager$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$$anonfun$licenseError$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$$anonfun$liftedTree1$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$$anonfun$liftedTree1$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$$anonfun$org$orbeon$oxf$common$PEVersion$$fromHomeDirectory$1$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$$anonfun$org$orbeon$oxf$common$PEVersion$$fromHomeDirectory$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$$anonfun$tryGetSignedData$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$$anonfun$tryGetSignedData$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$$anonfun$tryReadLicense$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$LicenseInfo$$anonfun$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$LicenseInfo$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$LicenseInfo$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$LicenseInfo$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$LicenseInfo$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$LicenseInfo$$anonfun$7.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$LicenseInfo$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$LicenseInfo$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$LicenseInfo$$anonfun$formattedBuildDate$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$LicenseInfo$$anonfun$formattedExpiration$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$LicenseInfo$$anonfun$formattedSubscriptionEnd$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$LicenseInfo$$anonfun$isBadVersion$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$LicenseInfo$$anonfun$isBuildAfterSubscriptionEnd$1$$anonfun$apply$mcZJ$sp$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$LicenseInfo$$anonfun$isBuildAfterSubscriptionEnd$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$LicenseInfo$$anonfun$isExpired$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$LicenseInfo$$anonfun$tryApply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$LicenseInfo$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion$LicenseInfo.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\PEVersion.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\ValidationException$$anonfun$$init$$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\ValidationException$$anonfun$$init$$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\ValidationException$$anonfun$addLocationData$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\ValidationException.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\Version$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\Version$$anonfun$fromContextClassLoaderOpt$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\Version$$anonfun$instance$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\Version$$anonfun$org$orbeon$oxf$common$Version$$logContextClassLoaderIssue$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\Version$$anonfun$versionStringIfAllowed$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\Version$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\common\Version.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$$anonfun$alreadyAuthorized$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$$anonfun$alreadyAuthorized$1$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$$anonfun$alreadyAuthorized$1$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$$anonfun$applicationToken$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$$anonfun$authorizedWithDelegate$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$$anonfun$authorizedWithDelegate$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$$anonfun$authorizedWithDelegate$11.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$$anonfun$authorizedWithDelegate$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$$anonfun$authorizedWithDelegate$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$$anonfun$authorizedWithDelegate$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$$anonfun$authorizedWithDelegate$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$$anonfun$authorizedWithDelegate$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$$anonfun$authorizedWithDelegate$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$$anonfun$authorizedWithDelegate$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$$anonfun$authorizedWithDelegate$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$$anonfun$authorizedWithToken$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$$anonfun$authorizedWithToken$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$$anonfun$delegateAbsoluteBaseURIOpt$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$$anonfun$rememberAuthorized$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\Authorizer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\AuthorizerServlet.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\DigestedProcessor$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\DigestedProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$1$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$10$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$11$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$12$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$15$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$15.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$16.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$6$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$6$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$6$1$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$6$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$6$2$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$6$2$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$6$2$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$6$2$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$6$2$5$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$6$2$5$2$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$6$2$5$2$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$6$2$5$2$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$6$2$5$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$6$2$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$6$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$6$3$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$6$3$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$6$3$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$6$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$7$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$7$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$7$1$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$7$1$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$7$1$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$7$1$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$7$1$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$7$1$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$7$1$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$7$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$7$2$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$7$2$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$7$2$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$7$2$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$7$2$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$7$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$8$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$9.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorCall.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$1$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$1$2$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$1$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$4$1$1$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$4$1$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$4$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$4$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$2$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$2$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$3$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$3$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$4$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$4$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$4$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$5$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$5$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$5$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$6$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$6$2$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$6$2$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$6$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$7$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$7$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1$7.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder$StepProcessorContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerBuilder.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anon$3$$anon$1$$anon$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anon$3$$anon$1$$anon$5$$anon$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anon$3$$anon$1$$anon$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anon$3$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anon$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anon$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$14.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$15.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$16$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$16.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$8.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$compilePattern$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$controllerPropertyQName$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$getPath$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$getPath$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$handler$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$handler$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$handler$1$3$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$handler$1$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$logError$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$logError$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$logError$1$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$logError$1$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$logNotFound$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$logNotFound$1$2$$anonfun$apply$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$logNotFound$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$logUnauthorized$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$logUnauthorized$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$org$orbeon$oxf$controller$PageFlowControllerProcessor$$compile$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$org$orbeon$oxf$controller$PageFlowControllerProcessor$$compile$1$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$org$orbeon$oxf$controller$PageFlowControllerProcessor$$controllerProperty$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$org$orbeon$oxf$controller$PageFlowControllerProcessor$$rootResource$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$org$orbeon$oxf$controller$PageFlowControllerProcessor$$rootResource$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$runNotFoundRoute$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$start$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$start$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$start$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$$anonfun$start$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$Authorization$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$Authorization.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$FileElement$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$FileElement$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$FileElement$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$FileElement$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$FileElement.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$FileRoute$$anonfun$process$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$FileRoute$$anonfun$process$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$FileRoute$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$FileRoute.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$PageFlow$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$PageFlow.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$PageOrServiceElement$$anonfun$apply$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$PageOrServiceElement$$anonfun$localPublicMethods$1$1$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$PageOrServiceElement$$anonfun$localPublicMethods$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$PageOrServiceElement$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$PageOrServiceElement.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$PageOrServiceRoute$$anonfun$17.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$PageOrServiceRoute$$anonfun$process$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$PageOrServiceRoute$$anonfun$process$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$PageOrServiceRoute$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$PageOrServiceRoute.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$Route$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$Route.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor$RouteElement.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\controller\PageFlowControllerProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\AsyncRequest.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\ExternalContextOps$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\ExternalContextOps$RequestOps$$anonfun$getFirstHeader$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\ExternalContextOps$RequestOps$$anonfun$getFirstParamAsString$1$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\ExternalContextOps$RequestOps$$anonfun$getFirstParamAsString$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\ExternalContextOps$RequestOps.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\ExternalContextOps.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\ExternalContextToHttpServletRequestWrapper$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\ExternalContextToHttpServletRequestWrapper.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\ExternalContextToHttpServletResponseWrapper$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\ExternalContextToHttpServletResponseWrapper.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\ExternalContextToPortletRenderRequestWrapper.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\ExternalContextToPortletRenderResponseWrapper.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\ExternalContextWrapper.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalByteArrayOutputStream.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalExternalContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalRequest$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalRequest$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalRequest$$anonfun$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalRequest$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalRequest$$anonfun$allHeadersLowercaseIterator$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalRequest$$anonfun$allHeadersLowercaseIterator$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalRequest$$anonfun$allHeadersLowercaseIterator$1$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalRequest$$anonfun$bodyParameters$1$1$$anonfun$applyOrElse$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalRequest$$anonfun$bodyParameters$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalRequest$$anonfun$getAttributesMap$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalRequest$$anonfun$getContentLength$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalRequest$$anonfun$getContentLength$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalRequest$$anonfun$getInputStream$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalRequest$$anonfun$getInputStream$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalRequest$$anonfun$org$orbeon$oxf$externalcontext$LocalRequest$$bodyHeadersIterator$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalRequest$$anonfun$org$orbeon$oxf$externalcontext$LocalRequest$$bodyHeadersIterator$1$2$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalRequest$$anonfun$org$orbeon$oxf$externalcontext$LocalRequest$$bodyHeadersIterator$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalRequest$$anonfun$org$orbeon$oxf$externalcontext$LocalRequest$$userGroupRoleHeadersIterator$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalRequest$$anonfun$queryParameters$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalRequest$$anonfun$queryParameters$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalRequest$$anonfun$_queryAndBodyParameters$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalRequest$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalRequest.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalResponse$$anonfun$addHeader$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalResponse$$anonfun$capitalizedHeaders$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\LocalResponse.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\PortletToExternalContextRequestDispatcherWrapper.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\RequestAdapter.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\RequestWrapper.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\ResponseAdapter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\ResponseWrapper.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\ServletToExternalContextRequestDispatcherWrapper.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\ServletURLRewriter.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\URLRewriter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\WSRPURLRewriter$$anonfun$$init$$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\WSRPURLRewriter$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\WSRPURLRewriter$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\WSRPURLRewriter$$anonfun$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\WSRPURLRewriter$$anonfun$getPathMatchers$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\WSRPURLRewriter$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\externalcontext\WSRPURLRewriter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$10.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$7.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$9$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$attributeValidations$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$elementValidations$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$findAlertForId$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$fromElement$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$messagesForAllLangs$1$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$messagesForAllLangs$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$org$orbeon$oxf$fb$AlertsAndConstraintsOps$$alertOrPlaceholder$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$org$orbeon$oxf$fb$AlertsAndConstraintsOps$$alertOrPlaceholder$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$readDefaultAlertAsXML$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$readDefaultAlertAsXML$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$readValidationsAsXML$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$writeAlerts$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$writeAlertsAndValidationsAsXML$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$writeAlertsAndValidationsAsXML$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$writeAlertsAndValidationsAsXML$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$writeAlertsAndValidationsAsXML$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$$anonfun$writeAlertsAndValidationsAsXML$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$AlertDetails$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$AlertDetails$$anonfun$22.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$AlertDetails$$anonfun$23$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$AlertDetails$$anonfun$23$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$AlertDetails$$anonfun$23.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$AlertDetails$$anonfun$24$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$AlertDetails$$anonfun$24$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$AlertDetails$$anonfun$24.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$AlertDetails$$anonfun$25.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$AlertDetails$$anonfun$alertOpt$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$AlertDetails$$anonfun$attValueOrNone$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$AlertDetails$$anonfun$fromForm$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$AlertDetails$$anonfun$org$orbeon$oxf$fb$AlertsAndConstraintsOps$AlertDetails$$alertFromElement$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$AlertDetails$$anonfun$toXML$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$AlertDetails$$anonfun$toXML$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$AlertDetails$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$AlertDetails.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$ConstraintValidation$$anonfun$20.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$ConstraintValidation$$anonfun$fromForm$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$ConstraintValidation$$anonfun$fromXML$1$$anonfun$21.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$ConstraintValidation$$anonfun$fromXML$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$ConstraintValidation$$anonfun$toXML$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$ConstraintValidation$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$ConstraintValidation.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$DatatypeValidation$$anonfun$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$DatatypeValidation$$anonfun$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$DatatypeValidation$$anonfun$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$DatatypeValidation$$anonfun$15.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$DatatypeValidation$$anonfun$16.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$DatatypeValidation$$anonfun$17.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$DatatypeValidation$$anonfun$18.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$DatatypeValidation$$anonfun$19.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$DatatypeValidation$$anonfun$fromForm$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$DatatypeValidation$$anonfun$fromForm$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$DatatypeValidation$$anonfun$renameControlIfNeeded$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$DatatypeValidation$$anonfun$renameControlIfNeeded$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$DatatypeValidation$$anonfun$renameControlIfNeeded$3$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$DatatypeValidation$$anonfun$renameControlIfNeeded$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$DatatypeValidation$$anonfun$toXML$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$DatatypeValidation$$anonfun$toXML$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$DatatypeValidation$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$DatatypeValidation.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$RequiredValidation$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$RequiredValidation$$anonfun$fromForm$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$RequiredValidation$$anonfun$fromForm$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$RequiredValidation$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$RequiredValidation.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$Validation$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps$Validation.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\AlertsAndConstraintsOps.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BaseOps$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BaseOps$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BaseOps$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BaseOps$$anonfun$debugDumpDocument$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BaseOps$$anonfun$debugDumpDocument$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BaseOps$$anonfun$elementIdsFromIndex$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BaseOps$$anonfun$elementIdsFromXPath$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BaseOps$$anonfun$elementIdsFromXPath$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BaseOps$$anonfun$findAllIds$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BaseOps$$anonfun$getFormModel$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BaseOps$$anonfun$getFormModel$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BaseOps$$anonfun$nextIds$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BaseOps$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BaseOps.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BindingOps$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BindingOps$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BindingOps$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BindingOps$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BindingOps$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BindingOps$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BindingOps$$anonfun$bindingForControlElement$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BindingOps$$anonfun$controlElementHasEditor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BindingOps$$anonfun$findBindAttributesTemplate$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BindingOps$$anonfun$findBindAttributesTemplate$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BindingOps$$anonfun$newElementName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BindingOps$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\BindingOps.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$2$$anonfun$apply$4$$anonfun$apply$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$2$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$deleteContainer$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$deleteContainer$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$deleteContainer$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$deleteSectionTemplateContentHolders$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$findCurrentBindingByName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$findCurrentBindingByName$2$$anonfun$apply$15.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$findCurrentBindingByName$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$findSiblingsWithName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$findSiblingsWithName$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$firstControl$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$hasCustomIterationName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$moveContainer$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$moveContainer$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$moveContainer$2$$anonfun$apply$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$moveContainer$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$moveContainer$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$moveContainer$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$renameTemplate$1$$anonfun$apply$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$renameTemplate$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$sectionsWithTemplates$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$setRepeatProperties$1$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$setRepeatProperties$1$$anonfun$apply$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$setRepeatProperties$1$$anonfun$apply$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$setRepeatProperties$1$$anonfun$apply$12.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$setRepeatProperties$1$$anonfun$apply$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$setRepeatProperties$1$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$setRepeatProperties$1$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$setRepeatProperties$1$$anonfun$apply$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$setRepeatProperties$1$$anonfun$apply$9.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$setRepeatProperties$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$tryToMoveHolders$1$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$tryToMoveHolders$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$updateTemplates$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$updateTemplates$2$$anonfun$apply$16.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$updateTemplates$2$$anonfun$apply$17.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$$anonfun$updateTemplates$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ContainerOps.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$14.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$15$$anonfun$16.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$15$$anonfun$17$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$15$$anonfun$17.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$15.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$18.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$21.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$22.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$23.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$24.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$25.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$9$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$buildFormBuilderControlAbsoluteIdOrEmpty$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$buildFormBuilderControlEffectiveId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$deleteCellContent$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$deleteCellContent$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$existingNSMapping$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$findConcreteControlByName$1$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$findConcreteControlByName$1$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$findConcreteControlByName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$findDataHolders$1$$anonfun$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$findDataHolders$1$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$findDataHolders$1$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$findDataHolders$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$findDataHolders$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$findStaticControlByName$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$findStaticControlByName$2$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$findStaticControlByName$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$getAllControlNames$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$getAllControlNames$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$getAllControlNamesXPath$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$getAllControlsWithIds$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$insertHolders$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$insertHolders$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$insertHolders$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$insertHolders$3$$anonfun$19.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$insertHolders$3$$anonfun$20$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$insertHolders$3$$anonfun$20.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$insertHolders$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$newNSMapping$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$precedingControlNameInSectionForControl$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$precedingControlNameInSectionForGrid$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$readMipAsAttributeOnly$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$renameBinds$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$renameControl$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$renameControlByElement$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$renameControlByElement$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$renameControlByElement$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$renameControlByElement$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$renameControlByElement$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$renameControlByElement$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$renameControlByElement$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$renameControlByElement$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$renameControlByElement$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$renameControlIfNeeded$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$renameControlIfNeeded$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$renameControlIterationIfNeeded$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$renameControlIterationIfNeeded$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$resourceNamesInUseForControl$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$setHTMLMediatype$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$suffix$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$updateMipAsAttributeOnly$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$$anonfun$valueNamespaceMappingScopeIfNeeded$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ControlOps.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\DataModel$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\DataModel$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\DataModel$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\DataModel$$anonfun$dataModelFromBinds$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\DataModel$$anonfun$foreachBindWithName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\DataModel$$anonfun$getBindRef$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\DataModel$$anonfun$isAllowedBindingExpression$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\DataModel$$anonfun$isAllowedBindingExpression$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\DataModel$$anonfun$isAllowedBoundItem$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\DataModel$$anonfun$isAllowedBoundItem$2$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\DataModel$$anonfun$isAllowedBoundItem$2$$anonfun$apply$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\DataModel$$anonfun$isAllowedBoundItem$2$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\DataModel$$anonfun$isAllowedBoundItem$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\DataModel$$anonfun$isAllowedValueBindingExpression$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\DataModel$$anonfun$org$orbeon$oxf$fb$DataModel$$update$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\DataModel$$anonfun$setBindRef$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\DataModel$$anonfun$updateBindsForAutomatic$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\DataModel$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\DataModel.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\FormBuilder$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\FormBuilder.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$13.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$annotate$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$controlsInCol$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$controlsInCol$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$controlsInCol$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$deleteCol$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$deleteCol$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$deleteGridById$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$deleteRow$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$deleteRow$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$deleteRow$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$ensureEmptyTd$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$findNewTdToSelect$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$findNewTdToSelect$2$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$findNewTdToSelect$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$getAllRowCells$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$getColTds$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$getNormalizedMax$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$getNormalizedMax$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$getNormalizedMin$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$getNormalizedMin$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$getNormalizedMin$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$getRowCells$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$initializeGrids$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$insertColLeft$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$insertColRight$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$insertRowBelow$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$minMaxForAttribute$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$minMaxForAttribute$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$newRow$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$org$orbeon$oxf$fb$GridOps$$getNormalizedRowspan$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$org$orbeon$oxf$fb$GridOps$$getNormalizedRowspan$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$org$orbeon$oxf$fb$GridOps$$newCellsRow$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$$anonfun$org$orbeon$oxf$fb$GridOps$$newCellsRow$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$Cell$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$Cell.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\GridOps.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\PermissionsOps$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\PermissionsOps$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\PermissionsOps$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\PermissionsOps$$anonfun$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\PermissionsOps$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\PermissionsOps$$anonfun$findAppElement$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\PermissionsOps$$anonfun$findFormElement$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\PermissionsOps$$anonfun$formBuilderPermissions$1$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\PermissionsOps$$anonfun$formBuilderPermissions$1$$anonfun$7.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\PermissionsOps$$anonfun$formBuilderPermissions$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\PermissionsOps$$anonfun$formBuilderPermissions$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\PermissionsOps$$anonfun$formBuilderPermissionsAsXML$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\PermissionsOps$$anonfun$formBuilderPermissionsAsXML$2$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\PermissionsOps$$anonfun$formBuilderPermissionsAsXML$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\PermissionsOps$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\PermissionsOps.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\PublishOps$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\PublishOps.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$4$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$6$$anonfun$apply$6$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$6$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$emptyItemElem$1$1$$anonfun$apply$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$emptyItemElem$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$ensureResourceHoldersForLang$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$ensureResourceHoldersForLangs$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$findResourceHolderForLang$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$findResourceHolderForLang$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$findResourceHolders$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$findResourceHoldersWithLang$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$findResourceHoldersWithLang$2$$anonfun$apply$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$findResourceHoldersWithLang$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$getControlItemsGroupedByValue$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$getControlResourceOrEmpty$1$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$getControlResourceOrEmpty$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$getControlResourceOrEmpty$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$getControlResources$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$getControlResourcesWithLang$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$hasBlankOrMissingLHHAForAllLangsUseDoc$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$hasItemHintEditor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$holderItemForValue$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$iterateSelfAndDescendantBindsResourceHolders$1$$anonfun$apply$12$$anonfun$apply$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$iterateSelfAndDescendantBindsResourceHolders$1$$anonfun$apply$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$iterateSelfAndDescendantBindsResourceHolders$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$lhhaForLangAndValue$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$lhhaForLangAndValue$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$lhhaHoldersForAllLangsUseDoc$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$lhhaHoldersForAllLangsUseDoc$2$$anonfun$apply$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$lhhaHoldersForAllLangsUseDoc$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$resourcesInLang$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$resourcesInLang$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$setControlItems$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$setControlItems$2$$anonfun$7$$anonfun$apply$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$setControlItems$2$$anonfun$7$$anonfun$apply$9.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$setControlItems$2$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$setControlItems$2$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$setControlItems$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$setControlResources$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$setControlResourcesWithLang$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$setControlResourcesWithLang$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$setControlResourcesWithLang$3$$anonfun$apply$2$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$setControlResourcesWithLang$3$$anonfun$apply$2$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$setControlResourcesWithLang$3$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$$anonfun$setControlResourcesWithLang$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ResourcesOps.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SchemaOps$$anonfun$findSchemaNamespace$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SchemaOps$$anonfun$findSchemaNamespace$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SchemaOps$$anonfun$findSchemaNamespace$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SchemaOps$$anonfun$findSchemaPrefix$1$$anonfun$apply$3$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SchemaOps$$anonfun$findSchemaPrefix$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SchemaOps$$anonfun$findSchemaPrefix$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SchemaOps$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SchemaOps.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SectionOps$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SectionOps$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SectionOps$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SectionOps$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SectionOps$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SectionOps$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SectionOps$$anonfun$canMoveRight$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SectionOps$$anonfun$deleteSectionById$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SectionOps$$anonfun$findSectionName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SectionOps$$anonfun$findSectionName$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SectionOps$$anonfun$findSectionName$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SectionOps$$anonfun$moveSectionDown$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SectionOps$$anonfun$moveSectionLeft$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SectionOps$$anonfun$moveSectionRight$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SectionOps$$anonfun$moveSectionUp$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SectionOps$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\SectionOps.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$$anonfun$1$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$$anonfun$1$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$$anonfun$1$$anonfun$4$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$$anonfun$1$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$$anonfun$copyToClipboard$1$$anonfun$8.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$$anonfun$copyToClipboard$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$$anonfun$copyToClipboard$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$$anonfun$insertNewRepeat$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$$anonfun$insertNewSectionTemplate$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$$anonfun$insertNewSectionTemplate$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$$anonfun$pasteFromClipboard$1$$anonfun$apply$3$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$$anonfun$pasteFromClipboard$1$$anonfun$apply$3$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$$anonfun$pasteFromClipboard$1$$anonfun$apply$3$$anonfun$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$$anonfun$pasteFromClipboard$1$$anonfun$apply$3$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$$anonfun$pasteFromClipboard$1$$anonfun$apply$3$$anonfun$apply$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$$anonfun$pasteFromClipboard$1$$anonfun$apply$3$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$$anonfun$pasteFromClipboard$1$$anonfun$apply$3$$anonfun$apply$6$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$$anonfun$pasteFromClipboard$1$$anonfun$apply$3$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$$anonfun$pasteFromClipboard$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$$anonfun$pasteFromClipboard$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fb\ToolboxOps.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$formRunnerHomePath$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$formRunnerPath$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$formRunnerPath$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$formRunnerPath$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$headersToForward$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$headersToForward$2$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$headersToForward$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$proxyPage$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$proxyResource$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$proxyResource$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$proxyResource$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$proxyServletResources$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$proxyServletResources$2$$anonfun$2$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$proxyServletResources$2$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$proxyServletResources$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$requestHeaders$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$requestHeaders$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$writeResponseBody$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$$anonfun$writeResponseBody$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$Private$$anonfun$getOrCreateCookieStore$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport$Private$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\APISupport.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\Edit$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\Edit.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\EmbeddingContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\EmbeddingContextWithResponse.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\EmbeddingSettings$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\EmbeddingSettings.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\Mode.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\New$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\New.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\RequestDetails$$anonfun$contentType$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\RequestDetails$$anonfun$contentTypeHeader$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\RequestDetails$$anonfun$headersMapWithContentType$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\RequestDetails$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\RequestDetails.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\API$$anonfun$embedPage$1$$anonfun$apply$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\API$$anonfun$embedPage$1$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\API$$anonfun$embedPage$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\API$$anonfun$embedPage$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\API$$anonfun$embedPageJava$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\API$$anonfun$embedPageJava$2$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\API$$anonfun$embedPageJava$2$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\API$$anonfun$embedPageJava$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\API$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\API.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\ServletEmbeddingContext.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\ServletEmbeddingContextWithResponse$$anonfun$decodeURL$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\ServletEmbeddingContextWithResponse$$anonfun$decodeURL$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\ServletEmbeddingContextWithResponse$$anonfun$decodeURL$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\ServletEmbeddingContextWithResponse$$anonfun$outputStream$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\ServletEmbeddingContextWithResponse$$anonfun$outputStream$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\ServletEmbeddingContextWithResponse$$anonfun$path$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\ServletEmbeddingContextWithResponse$$anonfun$path$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\ServletEmbeddingContextWithResponse$$anonfun$setHeader$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\ServletEmbeddingContextWithResponse$$anonfun$setStatusCode$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\ServletEmbeddingContextWithResponse$$anonfun$writer$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\ServletEmbeddingContextWithResponse$$anonfun$writer$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\ServletEmbeddingContextWithResponse.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\ServletFilter$$anonfun$destroy$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\ServletFilter$$anonfun$doFilter$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\ServletFilter$$anonfun$doFilter$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\ServletFilter$$anonfun$init$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\ServletFilter$$anonfun$init$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\ServletFilter$$anonfun$init$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\servlet\ServletFilter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\View$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\embedding\View.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunner$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunner.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerBaseOps$$anonfun$booleanFormRunnerProperty$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerBaseOps$$anonfun$booleanFormRunnerProperty$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerBaseOps$$anonfun$findFRBodyElement$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerBaseOps$$anonfun$findInViewTryIndex$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerBaseOps$$anonfun$findInViewTryIndex$2$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerBaseOps$$anonfun$findInViewTryIndex$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerBaseOps$$anonfun$findModelElement$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerBaseOps$$anonfun$findTopLevelBind$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerBaseOps$$anonfun$formRunnerProperty$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerBaseOps$$anonfun$instanceElement$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerBaseOps$$anonfun$isEmbeddable$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerBaseOps$$anonfun$isEmbeddable$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerBaseOps$$anonfun$templateInstanceElements$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerBaseOps$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerBaseOps$FormRunnerParams$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerBaseOps$FormRunnerParams.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerBaseOps.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerContainerOps$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerContainerOps$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerContainerOps$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerContainerOps$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerContainerOps$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerContainerOps$$anonfun$6$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerContainerOps$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerContainerOps$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerContainerOps$$anonfun$findRepeatIterationName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerContainerOps$$anonfun$findRepeatIterationName$2$$anonfun$apply$2$$anonfun$apply$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerContainerOps$$anonfun$findRepeatIterationName$2$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerContainerOps$$anonfun$findRepeatIterationName$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerContainerOps$$anonfun$findRepeatIterationNameOrEmpty$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerContainerOps$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerContainerOps.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerControlOps$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerControlOps$$anonfun$bindRefOrNodeset$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerControlOps$$anonfun$findBindByName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerControlOps$$anonfun$findBindForSource$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerControlOps$$anonfun$findBindNodeForSource$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerControlOps$$anonfun$findControlByName$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerControlOps$$anonfun$findControlByName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerControlOps$$anonfun$findControlIdByName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerControlOps$$anonfun$findRepeatedControlsForTarget$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerControlOps$$anonfun$findRepeatedControlsForTarget$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerControlOps$$anonfun$fromBind$1$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerControlOps$$anonfun$fromBind$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerControlOps$$anonfun$fromControl$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerControlOps$$anonfun$getControlNameOpt$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerControlOps$$anonfun$hasHTMLMediatype$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerControlOps$$anonfun$resolveTargetRelativeToActionSource$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerControlOps$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerControlOps.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerErrorSummary$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerErrorSummary$$anonfun$controlSortString$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerErrorSummary$$anonfun$controlSortString$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerErrorSummary$$anonfun$controlSortString$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerErrorSummary$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerErrorSummary.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$canNavigateNew$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$canNavigateSummary$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$canPublishLocal$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$canPublishLocalToRemote$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$canPublishRemote$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$canPublishRemoteToLocal$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$canSelectLocalNewer$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$canSelectPublishedLocal$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$canSelectPublishedRemote$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$canSelectRemoteNewer$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$canSelectUnpublishedLocal$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$canSelectUnpublishedRemote$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$canUnpublishLocal$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$canUnpublishRemote$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$canUpgradeLocal$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$canUpgradeRemote$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$collectForms$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$collectForms$default$2$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$createIndex$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$formsForSelection$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$fromCompatibility$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$fromEither$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$fromEither$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$fromJSON$1$1$$anonfun$apply$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$fromJSON$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$isLocalAvailable$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$isLocalUnavailable$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$isRemoteAvailable$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$isRemoteUnavailable$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$joinLocalAndRemoteMetadata$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$joinLocalAndRemoteMetadata$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$org$orbeon$oxf$fr$FormRunnerHome$$remoteServerFromCompatibilityProperty$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$org$orbeon$oxf$fr$FormRunnerHome$$remoteServerFromCompatibilityProperty$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$org$orbeon$oxf$fr$FormRunnerHome$$remoteServersFromJSONProperty$1$$anonfun$apply$5$$anonfun$apply$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$org$orbeon$oxf$fr$FormRunnerHome$$remoteServersFromJSONProperty$1$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$org$orbeon$oxf$fr$FormRunnerHome$$remoteServersFromJSONProperty$1$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$org$orbeon$oxf$fr$FormRunnerHome$$remoteServersFromJSONProperty$1$$anonfun$apply$8$$anonfun$apply$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$org$orbeon$oxf$fr$FormRunnerHome$$remoteServersFromJSONProperty$1$$anonfun$apply$8$$anonfun$apply$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$org$orbeon$oxf$fr$FormRunnerHome$$remoteServersFromJSONProperty$1$$anonfun$apply$8.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$org$orbeon$oxf$fr$FormRunnerHome$$remoteServersFromJSONProperty$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$tryRemoteServersFromJSON$1$$anonfun$apply$1$$anonfun$stringValueOrThrow$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$tryRemoteServersFromJSON$1$$anonfun$apply$1$$anonfun$stringValueOrThrow$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$tryRemoteServersFromJSON$1$$anonfun$apply$1$$anonfun$stringValueOrThrow$1$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$tryRemoteServersFromJSON$1$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$tryRemoteServersFromJSON$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$tryRemoteServersFromString$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$$anonfun$tryRemoteServersFromString$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$AvailableAndTime$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$AvailableAndTime.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$Form$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$Form$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$Form$$anonfun$isLocalAvailable$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$Form$$anonfun$isLocalUnavailable$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$Form$$anonfun$isRemoteAvailable$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$Form$$anonfun$isRemoteUnavailable$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$Form$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome$Form.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerHome.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang$$anonfun$findRequestedLang$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang$$anonfun$findRequestedLang$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang$$anonfun$findRequestedLang$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang$$anonfun$findRequestedLang$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang$$anonfun$formResourcesInLang$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang$$anonfun$formResourcesInLang$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang$$anonfun$fromHeader$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang$$anonfun$fromRequest$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang$$anonfun$getAppForm$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang$$anonfun$getDefaultLang$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang$$anonfun$getDefaultLang$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang$$anonfun$getFormLangSelection$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang$$anonfun$isAllowedLang$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang$$anonfun$selectLangUseDefault$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang$$anonfun$selectLangUseDefault$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang$$anonfun$stringFromSession$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang$$anonfun$stringFromSession$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang$AppForm$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang$AppForm.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerLang.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$11$$anonfun$apply$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$3$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$4$$anonfun$apply$2$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$4$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$9$$anonfun$apply$4$$anonfun$apply$5$$anonfun$apply$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$9$$anonfun$apply$4$$anonfun$apply$5$$anonfun$apply$7$$anonfun$apply$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$9$$anonfun$apply$4$$anonfun$apply$5$$anonfun$apply$7$$anonfun$apply$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$9$$anonfun$apply$4$$anonfun$apply$5$$anonfun$apply$7$$anonfun$apply$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$9$$anonfun$apply$4$$anonfun$apply$5$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$9$$anonfun$apply$4$$anonfun$apply$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$9$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$instanceInScope$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$isBoundToFormDataInScope$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$isBoundToFormDataInScope$1$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$$anonfun$iterateResources$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerMetadata.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPDF$$anonfun$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPDF$$anonfun$1$$anonfun$apply$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPDF$$anonfun$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPDF$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPDF$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPDF$$anonfun$3$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPDF$$anonfun$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPDF$$anonfun$ancestorContainers$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPDF$$anonfun$buildPDFFieldNameFromHTML$1$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPDF$$anonfun$buildPDFFieldNameFromHTML$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPDF$$anonfun$findControlName$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPDF$$anonfun$hyperlinkURLs$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPDF$$anonfun$hyperlinkURLs$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPDF$$anonfun$isContainer$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPDF$$anonfun$propertiesStartingWith$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPDF$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPDF.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$13.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$5$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$5$$anonfun$apply$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$9.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$authorizedOperationsBasedOnRoles$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$authorizedOperationsBasedOnRoles$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$authorizedOperationsBasedOnRoles$2$$anonfun$apply$4$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$authorizedOperationsBasedOnRoles$2$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$authorizedOperationsBasedOnRoles$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$authorizedOperationsBasedOnRoles$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$filterFormsAndAnnotateWithOperations$1$$anonfun$14$$anonfun$apply$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$filterFormsAndAnnotateWithOperations$1$$anonfun$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$filterFormsAndAnnotateWithOperations$1$$anonfun$15.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$filterFormsAndAnnotateWithOperations$1$$anonfun$16.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$filterFormsAndAnnotateWithOperations$1$$anonfun$apply$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$filterFormsAndAnnotateWithOperations$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$getUserGroupRolesAsHeaders$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$headerOption$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$operations$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$operations$1$2$$anonfun$apply$6$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$operations$1$2$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$operations$1$2$$anonfun$apply$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$operations$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$operations$1$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$orbeonRoles$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$orbeonRoles$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$$anonfun$orbeonRolesSequence$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPermissions.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistence$$anonfun$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistence$$anonfun$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistence$$anonfun$1$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistence$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistence$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistence$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistence$$anonfun$4$$anonfun$apply$5$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistence$$anonfun$4$$anonfun$apply$5$$anonfun$apply$6$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistence$$anonfun$4$$anonfun$apply$5$$anonfun$apply$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistence$$anonfun$4$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistence$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistence$$anonfun$collectAttachments$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistence$$anonfun$collectAttachments$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistence$$anonfun$collectAttachments$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistence$$anonfun$collectAttachments$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistence$$anonfun$putWithAttachments$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistence$$anonfun$putWithAttachments$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistence$$anonfun$readDocument$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistence$$anonfun$saveAttachments$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistence$$anonfun$updatePaths$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistence$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistence.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistenceProxy$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistenceProxy$$anonfun$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistenceProxy$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistenceProxy$$anonfun$4$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistenceProxy$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistenceProxy$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistenceProxy$$anonfun$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistenceProxy$$anonfun$7$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistenceProxy$$anonfun$7$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistenceProxy$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistenceProxy$$anonfun$providersUsedInPropertiesForFormDefinition$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistenceProxy$$anonfun$providersUsedInPropertiesForFormDefinition$1$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistenceProxy$$anonfun$proxyRequest$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistenceProxy$$anonfun$proxyRequest$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistenceProxy$$anonfun$proxyRequest$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerPersistenceProxy.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerSummary$$anonfun$htmlFieldLabel$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerSummary$$anonfun$resourceLabelOpt$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerSummary$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\FormRunnerSummary.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$retrieveAttachment$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$retrieveDocument$1$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$retrieveDocument$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$retrieveForm$1$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$retrieveForm$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$retrieveFormAttachment$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$search$1$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$search$1$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$search$1$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$search$1$$anonfun$4$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$search$1$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$search$1$$anonfun$apply$8.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$search$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$storeAttachment$1$$anonfun$apply$2$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$storeAttachment$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$storeAttachment$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$storeDocument$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$storeDocument$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$storeDocument$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$storeForm$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$storeFormAttachment$1$$anonfun$apply$5$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$storeFormAttachment$1$$anonfun$apply$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$storeFormAttachment$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$withCollection$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence$$anonfun$withFS$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\mongodb\MongoDBPersistence.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\Names$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\Names.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$15.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$16.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$17$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$17.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$18.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$19.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$20.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$21.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$22$$anonfun$apply$7.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$22.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$AllowedFormRunnerActions$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$AllowedFormRunnerActions$10.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$AllowedFormRunnerActions$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$AllowedFormRunnerActions$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$AllowedFormRunnerActions$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$AllowedFormRunnerActions$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$AllowedFormRunnerActions$15.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$AllowedFormRunnerActions$16.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$AllowedFormRunnerActions$17.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$AllowedFormRunnerActions$18.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$AllowedFormRunnerActions$19.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$AllowedFormRunnerActions$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$AllowedFormRunnerActions$20.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$AllowedFormRunnerActions$21.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$AllowedFormRunnerActions$22.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$AllowedFormRunnerActions$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$AllowedFormRunnerActions$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$AllowedFormRunnerActions$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$AllowedFormRunnerActions$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$AllowedFormRunnerActions$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$AllowedFormRunnerActions$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$AllowedFormRunnerActions$9.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$fromResource$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$org$orbeon$oxf$fr$process$FormRunnerActions$$messageFromResourceOrParam$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$org$orbeon$oxf$fr$process$FormRunnerActions$$prependCommonFormRunnerParameters$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$org$orbeon$oxf$fr$process$FormRunnerActions$$tryChangeMode$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$org$orbeon$oxf$fr$process$FormRunnerActions$$tryChangeMode$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$org$orbeon$oxf$fr$process$FormRunnerActions$$tryNavigateTo$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$pdfURLInstanceRootElementOpt$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryCaptcha$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryCollapseSections$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryConfirm$1$$anonfun$message$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryConfirm$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryCreatePDFIfNeeded$1$$anonfun$apply$mcV$sp$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryCreatePDFIfNeeded$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryErrorMessage$1$$anonfun$apply$mcV$sp$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryErrorMessage$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryExpandSections$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryNavigate$1$$anonfun$23$$anonfun$apply$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryNavigate$1$$anonfun$23.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryNavigate$1$$anonfun$24.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryNavigate$1$$anonfun$apply$10.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryNavigate$1$$anonfun$apply$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryNavigate$1$$anonfun$apply$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryNavigate$1$$anonfun$fromParams$1$1$$anonfun$apply$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryNavigate$1$$anonfun$fromParams$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryNavigate$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryNavigate$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryNavigateToEdit$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryNavigateToEdit$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryNavigateToReview$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryNavigateToReview$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryOpenPDF$1$$anonfun$25.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryOpenPDF$1$$anonfun$26.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryOpenPDF$1$$anonfun$apply$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryOpenPDF$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryOpenPDF$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryPendingUploads$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySaveAttachmentsAndData$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySaveAttachmentsAndData$2$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySaveAttachmentsAndData$2$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySaveAttachmentsAndData$2$$anonfun$9.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySaveAttachmentsAndData$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySaveAttachmentsAndData$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySaveAttachmentsAndData$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySend$1$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySend$1$$anonfun$12$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySend$1$$anonfun$12$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySend$1$$anonfun$12$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySend$1$$anonfun$12$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySend$1$$anonfun$12$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySend$1$$anonfun$12.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySend$1$$anonfun$13$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySend$1$$anonfun$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySend$1$$anonfun$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySend$1$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySend$1$$anonfun$org$orbeon$oxf$fr$process$FormRunnerActions$class$$anonfun$$findParamValue$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySend$1$$anonfun$org$orbeon$oxf$fr$process$FormRunnerActions$class$$anonfun$$findParamValue$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySend$1$$anonfun$org$orbeon$oxf$fr$process$FormRunnerActions$class$$anonfun$$fromProperty$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySend$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySendEmail$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySetDataStatus$1$$anonfun$10.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySetDataStatus$1$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySetDataStatus$1$$anonfun$apply$mcV$sp$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySetDataStatus$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryShowResultDialog$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySuccessMessage$1$$anonfun$apply$mcV$sp$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$trySuccessMessage$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryToggleNoscript$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryToggleNoscript$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryUnvisitAll$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryValidate$1$$anonfun$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryValidate$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryVisitAll$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryWizardNext$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$$anonfun$tryWizardPrev$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\FormRunnerActions.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$afterProcess$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$beforeProcess$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$booleanParamByName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$booleanParamByName$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$org$orbeon$oxf$fr$process$ProcessInterpreter$$rawProcessByName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$paramByNameOrDefault$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$requiredParamByName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$runningProcessId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$runProcess$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$runProcess$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$runProcess$3$$anonfun$apply$11$$anonfun$apply$12$$anonfun$apply$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$runProcess$3$$anonfun$apply$11$$anonfun$apply$12$$anonfun$apply$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$runProcess$3$$anonfun$apply$11$$anonfun$apply$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$runProcess$3$$anonfun$apply$11$$anonfun$apply$15.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$runProcess$3$$anonfun$apply$11$$anonfun$apply$2$$anonfun$applyOrElse$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$runProcess$3$$anonfun$apply$11$$anonfun$apply$2$$anonfun$applyOrElse$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$runProcess$3$$anonfun$apply$11$$anonfun$apply$2$$anonfun$applyOrElse$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$runProcess$3$$anonfun$apply$11$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$runProcess$3$$anonfun$apply$11.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$runProcess$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$tryAbort$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$tryProcess$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$tryProcess$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$tryProcess$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$trySuccess$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$trySuspend$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$$anonfun$trySuspend$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$11$$anonfun$apply$1$$anonfun$applyOrElse$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$11$$anonfun$apply$1$$anonfun$applyOrElse$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$11$$anonfun$apply$1$$anonfun$applyOrElse$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$11$$anonfun$apply$1$$anonfun$applyOrElse$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$11$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$11$$anonfun$apply$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$11$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$11$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$11$$anonfun$apply$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$11$$anonfun$apply$9.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$9$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$9.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$parseProcess$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$runAction$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$runAction$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$runAction$1$3$$anonfun$10$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$runAction$1$3$$anonfun$10.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$runAction$1$3$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$runAction$1$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$runCondition$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$runCondition$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$runGroup$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$runSubProcess$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$$anonfun$runSubProcess$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$Process$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$Process.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$StackFrame$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter$ProcessRuntime$StackFrame.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessInterpreter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Action$1$$anonfun$apply$2$$anonfun$apply$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Action$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Action$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Action$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Character$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Character$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Combinator$1$$anonfun$apply$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Combinator$1$$anonfun$apply$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Combinator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Combinator$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$CombinatorActionPair$1$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$CombinatorActionPair$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$CombinatorActionPair$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Condition$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Condition$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$ElseBranch$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$ElseBranch$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$EscapedChar$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$EscapedChar$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Expr$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Expr$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$GroupContent$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$GroupContent$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$HexDigit$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$HexDigit$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Name$1$$anonfun$apply$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Name$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Name$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$NameAfter$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$NameAfter$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$NameStart$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$NameStart$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$NormalChar$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$NormalChar$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$OptWhiteSpace$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$OptWhiteSpace$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Param$1$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Param$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Param$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$ParenthesizedGroup$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$ParenthesizedGroup$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Process$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Process$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$ThenBranch$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$ThenBranch$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Unicode$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$Unicode$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$ValueString1$1$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$ValueString1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$ValueString1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$ValueString2$1$$anonfun$apply$7.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$ValueString2$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$ValueString2$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$WhiteSpace$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$$anonfun$WhiteSpace$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$ActionNode$$anonfun$serializeParams$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$ActionNode$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$ActionNode.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$Combinator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$ConditionNode$$anonfun$serializeElse$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$ConditionNode$$anonfun$serializeElse$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$ConditionNode$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$ConditionNode.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$ExprNode.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$GroupNode$$anonfun$serializeRest$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$GroupNode$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$GroupNode.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$RecoverCombinator$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser$ThenCombinator$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\ProcessParser.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\SimpleProcess$$anonfun$beforeProcess$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\SimpleProcess$$anonfun$findProcessByName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\SimpleProcess$$anonfun$stringPropertySet$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\SimpleProcess$$anonfun$xpathContext$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\SimpleProcess$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\SimpleProcess.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\XFormsActions$$anonfun$AllowedXFormsActions$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\XFormsActions$$anonfun$AllowedXFormsActions$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\XFormsActions$$anonfun$AllowedXFormsActions$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\XFormsActions$$anonfun$AllowedXFormsActions$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\XFormsActions$$anonfun$org$orbeon$oxf$fr$process$XFormsActions$$collectCustomProperties$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\XFormsActions$$anonfun$trySetvalue$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\XFormsActions$$anonfun$trySetvalue$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\XFormsActions$$anonfun$trySetvalue$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\XFormsActions$$anonfun$tryShowDialog$1$$anonfun$apply$mcV$sp$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\XFormsActions$$anonfun$tryShowDialog$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\XFormsActions$$anonfun$tryXFormsDispatch$1$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\XFormsActions$$anonfun$tryXFormsDispatch$1$$anonfun$apply$mcV$sp$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\XFormsActions$$anonfun$tryXFormsDispatch$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\XFormsActions$$anonfun$tryXFormsSend$1$$anonfun$apply$mcV$sp$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\XFormsActions$$anonfun$tryXFormsSend$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\XFormsActions$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\process\XFormsActions.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Common$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Common$$anonfun$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Common$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Common$$anonfun$idColumns$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Common$$anonfun$idColumns$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Common$$anonfun$idColumns$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Common$$anonfun$idColumns$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Common$$anonfun$idColumns$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Common$$anonfun$joinColumns$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Common$$anonfun$readFormMetadata$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Common$$anonfun$readFormMetadata$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Common$$anonfun$requestedFormVersion$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Common$$anonfun$requestedFormVersion$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Common$$anonfun$requestedFormVersion$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Common$$anonfun$requestedFormVersion$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Common$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Common.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$10$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$11$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$11.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$12$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$14$$anonfun$apply$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$14.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$15.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$16$$anonfun$apply$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$16.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$17$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$17.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$18.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$19$$anonfun$apply$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$19.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$20.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$21$$anonfun$apply$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$21.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$22.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$23$$anonfun$apply$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$23.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$24.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$25$$anonfun$apply$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$25.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$26.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$27$$anonfun$apply$14.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$27.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$28$$anonfun$apply$16.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$28.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$29$$anonfun$apply$15.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$29.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$30$$anonfun$apply$18.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$30$$anonfun$apply$19$$anonfun$apply$20.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$30$$anonfun$apply$19.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$30.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$31$$anonfun$apply$17.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$31.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$32$$anonfun$apply$22.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$32$$anonfun$apply$23$$anonfun$apply$24.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$32$$anonfun$apply$23.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$32.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$33$$anonfun$apply$21.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$33.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$34$$anonfun$apply$26.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$34.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$35$$anonfun$apply$25.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$35.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$36.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$37.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$38.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$39.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$40.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$41.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$7$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$7$$anonfun$apply$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$8$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$change$1$$anonfun$existingVersion$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$change$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$org$orbeon$oxf$fr$relational$crud$CreateUpdateDelete$$deleteDraft$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$org$orbeon$oxf$fr$relational$crud$CreateUpdateDelete$$deleteDraftOnSaveData$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$org$orbeon$oxf$fr$relational$crud$CreateUpdateDelete$$store$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$org$orbeon$oxf$fr$relational$crud$CreateUpdateDelete$$store$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$org$orbeon$oxf$fr$relational$crud$CreateUpdateDelete$$store$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$$anonfun$param$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$Row$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete$Row.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CreateUpdateDelete.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\CRUD.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\DataPart$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\DataPart.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\FlatView$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\FlatView$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\FlatView$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\FlatView$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\FlatView$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\FlatView$$anonfun$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\FlatView$$anonfun$collectControls$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\FlatView$$anonfun$collectControls$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\FlatView$$anonfun$collectControls$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\FlatView$$anonfun$extractPathsCols$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\FlatView$$anonfun$extractPathsCols$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\FlatView$$anonfun$extractPathsCols$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\FlatView$$anonfun$org$orbeon$oxf$fr$relational$crud$FlatView$$descendantControls$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\FlatView$$anonfun$topLevelSections$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\FlatView$$anonfun$xmlToSQLId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\FlatView$$anonfun$xmlToSQLId$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\FlatView$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\FlatView$Col$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\FlatView$Col.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\FlatView.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Read$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Read$$anonfun$get$1$$anonfun$apply$1$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Read$$anonfun$get$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Read$$anonfun$get$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Read$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Read.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Request$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\Request.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\RequestReader$$anonfun$3$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\RequestReader$$anonfun$3$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\RequestReader$$anonfun$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\RequestReader$$anonfun$dataAndMetadataAsString$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\RequestReader$$anonfun$newTransformer$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\RequestReader$$anonfun$org$orbeon$oxf$fr$relational$crud$RequestReader$$newIdentityReceiver$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\RequestReader$$anonfun$org$orbeon$oxf$fr$relational$crud$RequestReader$$newIdentityReceiver$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\RequestReader$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\RequestReader$IdAtt$$anonfun$unapply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\RequestReader$IdAtt$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\RequestReader.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\RequestResponse$$anonfun$tableName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\RequestResponse$$anonfun$tableName$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\RequestResponse$$anonfun$tableName$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\RequestResponse$$anonfun$tableName$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\RequestResponse$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\crud\RequestResponse.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\ForDocument$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\ForDocument.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\Index$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\Index$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\Index$$anonfun$findIndexedControls$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\Index$$anonfun$findIndexedControls$1$$anonfun$apply$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\Index$$anonfun$findIndexedControls$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\Index$$anonfun$findIndexedControls$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\Index$$anonfun$findIndexedControlsAsXML$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\Index$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\Index$IndexedControl$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\Index$IndexedControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\Index.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\Next$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\Next.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor$$anon$1$$anonfun$readImpl$1$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor$$anon$1$$anonfun$readImpl$1$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor$$anon$1$$anonfun$readImpl$1$$anonfun$11$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor$$anon$1$$anonfun$readImpl$1$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor$$anon$1$$anonfun$readImpl$1$$anonfun$12$$anonfun$apply$2$$anonfun$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor$$anon$1$$anonfun$readImpl$1$$anonfun$12$$anonfun$apply$2$$anonfun$apply$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor$$anon$1$$anonfun$readImpl$1$$anonfun$12$$anonfun$apply$2$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor$$anon$1$$anonfun$readImpl$1$$anonfun$12$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor$$anon$1$$anonfun$readImpl$1$$anonfun$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor$$anon$1$$anonfun$readImpl$1$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor$$anon$1$$anonfun$readImpl$1$$anonfun$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor$$anon$1$$anonfun$readImpl$1$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor$$anon$1$$anonfun$readImpl$1$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor$$anon$1$$anonfun$readImpl$1$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor$$anon$1$$anonfun$readImpl$1$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor$$anon$1$$anonfun$readImpl$1$$anonfun$8.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor$$anon$1$$anonfun$readImpl$1$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor$$anon$1$$anonfun$readImpl$1$Value$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor$$anon$1$$anonfun$readImpl$1$Value$4$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor$$anon$1$$anonfun$readImpl$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor$$anon$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor$DocumentMetadata$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor$DocumentMetadata.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\PersistenceAPIProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\ReindexProcessor$$anonfun$start$1$$anonfun$apply$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\ReindexProcessor$$anonfun$start$1$$anonfun$apply$1$$anonfun$apply$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\ReindexProcessor$$anonfun$start$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\ReindexProcessor$$anonfun$start$1$FormIndexedControls$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\ReindexProcessor$$anonfun$start$1$FormIndexedControls$4$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\ReindexProcessor$$anonfun$start$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\ReindexProcessor.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\RelationalUtils$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\RelationalUtils.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\Specific$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\Specific.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\Unspecified$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\Unspecified.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\Version$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\relational\Version.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\ResourcesPatcher$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\ResourcesPatcher$$anonfun$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\ResourcesPatcher$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\ResourcesPatcher$$anonfun$org$orbeon$oxf$fr$ResourcesPatcher$$resourceElementsForLang$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\ResourcesPatcher$$anonfun$transform$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\ResourcesPatcher$$anonfun$transform$2$$anonfun$apply$1$$anonfun$apply$2$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\ResourcesPatcher$$anonfun$transform$2$$anonfun$apply$1$$anonfun$apply$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\ResourcesPatcher$$anonfun$transform$2$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\ResourcesPatcher$$anonfun$transform$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\ResourcesPatcher$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\ResourcesPatcher.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$11$$anonfun$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$11$$anonfun$13$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$11$$anonfun$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$11.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$15.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$16.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$17$$anonfun$18.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$17.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$19.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$20.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$21.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$22.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$23.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$24.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$25.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$26.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$7.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$asComponent$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$attrDefault$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$findSectionTemplateBindsAndResolver$1$1$$anonfun$apply$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$findSectionTemplateBindsAndResolver$1$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$findSectionTemplateBindsAndResolver$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$isBindTypeAnyURI$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$isControlAttachment$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$oneValueSimpleType$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$org$orbeon$oxf$fr$schema$SchemaGenerator$$findComponentBindNodes$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$org$orbeon$oxf$fr$schema$SchemaGenerator$$findComponentNodeForSection$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$org$orbeon$oxf$fr$schema$SchemaGenerator$$findControlNodeForBind$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$org$orbeon$oxf$fr$schema$SchemaGenerator$$resolverForSectionComponent$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$$anonfun$xsElement$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$Attachment$2$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$Bind$2$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$Bind$2$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$Bind$2$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$Bind$2$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$Bind$2$$anonfun$org$orbeon$oxf$fr$schema$SchemaGenerator$Bind$$typeFromChildElem$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$Bind$2$$anonfun$typeFromBind$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$Bind$2$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$BindInfo$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$BindInfo$4$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$ItemsetTypeValues$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$ItemsetTypeValues$4$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$Libraries$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$Libraries.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$MaybeTyped$2$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$Repeated$2$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$RootBind$2$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$SchemaGenerationCase$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator$Selection$2$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\SchemaGenerator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\XFormsToSchema$Libraries$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\XFormsToSchema$Libraries.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\schema\XFormsToSchema.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\SimpleProcess$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\fr\SimpleProcess.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$$anon$2$$anonfun$content$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$$anon$2$$anonfun$content$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$$anon$2$$anonfun$headers$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$$anon$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$$anonfun$connect$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$$anonfun$connect$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$$anonfun$connect$3$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$$anonfun$connect$3$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$$anonfun$connect$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$$anonfun$connect$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$$anonfun$connect$5$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$$anonfun$connect$5$$anonfun$apply$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$$anonfun$connect$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$$anonfun$contentTypeFromContent$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$Private$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$Private$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$Private$$anonfun$12$$anon$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$Private$$anonfun$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$Private$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$Private$$anonfun$9$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$Private$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$Private$$anonfun$newHttpParams$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$Private$$anonfun$newHttpParams$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$Private$$anonfun$newProxyAuthState$1$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$Private$$anonfun$newProxyAuthState$1$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$Private$$anonfun$newProxyAuthState$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$Private$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$Private$JCIFSEngine$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient$Private$PreemptiveAuthHttpRequestInterceptor$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpClient.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpUrlConnection$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpUrlConnection$$anonfun$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpUrlConnection$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpUrlConnection$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpUrlConnection$$anonfun$addRequestProperty$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpUrlConnection$$anonfun$connect$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpUrlConnection$$anonfun$connect$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpUrlConnection$$anonfun$credentialsFromURL$1$1$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpUrlConnection$$anonfun$credentialsFromURL$1$1$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpUrlConnection$$anonfun$credentialsFromURL$1$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpUrlConnection$$anonfun$credentialsFromURL$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpUrlConnection$$anonfun$disconnect$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpUrlConnection$$anonfun$getHeaderField$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpUrlConnection$$anonfun$getHeaderField$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpUrlConnection$$anonfun$getHeaderFields$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpUrlConnection$$anonfun$getHeaderFields$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpUrlConnection$$anonfun$getInputStream$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpUrlConnection$$anonfun$getOutputStream$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpUrlConnection$$anonfun$getRequestProperties$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpUrlConnection$$anonfun$getRequestProperty$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpUrlConnection$$anonfun$getResponseCode$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\ApacheHttpUrlConnection.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\BufferedContent$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\BufferedContent$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\BufferedContent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\BufferedContentOrRedirect.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Content.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Credentials$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Credentials$$anonfun$getPrefix$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Credentials$$anonfun$getPrefix$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Credentials$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Credentials.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\EmptyInputStream$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\EmptyInputStream.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Headers$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Headers$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Headers$$anonfun$capitalizeCommonOrSplitHeader$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Headers$$anonfun$capitalizeSplitHeader$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Headers$$anonfun$firstDateHeaderIgnoreCase$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Headers$$anonfun$firstDateHeaderIgnoreCase$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Headers$$anonfun$firstHeaderIgnoreCase$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Headers$$anonfun$firstLongHeaderIgnoreCase$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Headers$$anonfun$firstLongHeaderIgnoreCase$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Headers$$anonfun$proxyAndCapitalizeHeaders$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Headers$$anonfun$proxyAndCombineRequestHeaders$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Headers$$anonfun$proxyCapitalizeAndCombineHeaders$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Headers$$anonfun$proxyHeaders$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Headers$$anonfun$proxyHeaders$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Headers$$anonfun$proxyHeaders$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Headers$$anonfun$proxyHeaders$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Headers$$anonfun$proxyHeaders$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Headers$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Headers.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\HttpClient.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\HttpClientSettings$$anonfun$booleanParamWithDefault$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\HttpClientSettings$$anonfun$booleanParamWithDefault$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\HttpClientSettings$$anonfun$intParam$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\HttpClientSettings$$anonfun$intParamWithDefault$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\HttpClientSettings$$anonfun$stringParamWithDefault$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\HttpClientSettings$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\HttpClientSettings.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\HttpResponse.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\PropertiesApacheHttpClient$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\PropertiesApacheHttpClient.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\PropertiesConnectionSettings$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\PropertiesConnectionSettings$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\PropertiesConnectionSettings.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Redirect$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Redirect$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\Redirect.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\StreamedContent$$anonfun$close$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\StreamedContent$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\StreamedContent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\http\StreamedContentOrRedirect.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\main\OPS.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\main\OXF.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\api\ExternalContext$Request.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\api\ExternalContext$RequestDispatcher.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\api\ExternalContext$Response.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\api\ExternalContext$Rewriter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\api\ExternalContext$Session$SessionListener.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\api\ExternalContext$Session.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\api\ExternalContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\api\FunctionLibrary$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\api\FunctionLibrary.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\api\PipelineContext$ContextListener.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\api\PipelineContext$ContextListenerAdapter.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\api\PipelineContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\api\PipelineEngine.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\api\ProcessorDefinition.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\api\TraceEntry.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\api\TransformerXMLReceiver.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\CommandLineExternalContext$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\CommandLineExternalContext$CommandLineRequest.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\CommandLineExternalContext$CommandLineResponse$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\CommandLineExternalContext$CommandLineResponse.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\CommandLineExternalContext.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$createProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$createProcessor$2$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$createProcessor$2$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$createProcessor$2$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$createProcessor$2$$anonfun$apply$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$createProcessor$2$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$createProcessor$2$$anonfun$connectInput$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$createProcessor$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$getDefinitionFromMap$1$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$getDefinitionFromMap$1$$anonfun$apply$8.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$getDefinitionFromMap$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$locationMessage$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$locationMessage$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$registerProcessors$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$runProcessor$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$runProcessor$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$runProcessor$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$runProcessor$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$runProcessor$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$runWithServletContext$1$$anonfun$apply$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$$anonfun$runWithServletContext$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$PropertiesMap$$anonfun$get$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$PropertiesMap$$anonfun$iterator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$PropertiesMap$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$RequestMap$$anon$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$RequestMap.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$ServletContextInitMap$$anonfun$iterator$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$ServletContextInitMap.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$SessionMap$$anon$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils$SessionMap.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\InitUtils.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\SimpleExternalContext$Request.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\SimpleExternalContext$Response.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\SimpleExternalContext$Session.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\pipeline\SimpleExternalContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\BufferedPortlet$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\BufferedPortlet$$anonfun$bufferedProcessAction$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\BufferedPortlet$$anonfun$bufferedRender$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\BufferedPortlet$$anonfun$org$orbeon$oxf$portlet$BufferedPortlet$$writeResponseWithParameters$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\BufferedPortlet$$anonfun$org$orbeon$oxf$portlet$BufferedPortlet$$writeResponseWithParameters$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\BufferedPortlet$$anonfun$org$orbeon$oxf$portlet$BufferedPortlet$$writeResponseWithParameters$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\BufferedPortlet$$anonfun$shortIdNamespace$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\BufferedPortlet$$anonfun$toJavaMap$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\BufferedPortlet$$anonfun$toScalaMap$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\BufferedPortlet$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\BufferedPortlet$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\BufferedPortlet$NamespaceMappings$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\BufferedPortlet$NamespaceMappings.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\BufferedPortlet$ResponseWithParameters$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\BufferedPortlet$ResponseWithParameters.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\BufferedPortlet.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\FormRunnerRequestFilter$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\FormRunnerRequestFilter$$anon$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\FormRunnerRequestFilter$$anon$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\FormRunnerRequestFilter$$anon$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\FormRunnerRequestFilter$$anon$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\FormRunnerRequestFilter$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\FormRunnerRequestFilter$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\FormRunnerRequestFilter$$anonfun$org$orbeon$oxf$portlet$liferay$FormRunnerRequestFilter$$getCombine$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\FormRunnerRequestFilter$CustomProperties$1$$anonfun$getProperties$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\FormRunnerRequestFilter$CustomProperties$1$$anonfun$getProperties$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\FormRunnerRequestFilter$CustomProperties$1$$anonfun$getProperty$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\FormRunnerRequestFilter$CustomProperties$1$$anonfun$getProperty$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\FormRunnerRequestFilter$CustomProperties$1$$anonfun$getPropertyNames$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\FormRunnerRequestFilter$CustomProperties$1$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\FormRunnerRequestFilter$CustomProperties$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\FormRunnerRequestFilter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferaySupport$$anonfun$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferaySupport$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferaySupport$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferaySupport$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferaySupport$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferaySupport$$anonfun$5$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferaySupport$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferaySupport$$anonfun$6$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferaySupport$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferaySupport$$anonfun$7$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferaySupport$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferaySupport$$anonfun$languageHeader$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferaySupport$$anonfun$userHeaders$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferaySupport$$anonfun$userHeaders$2$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferaySupport$$anonfun$userHeaders$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferaySupport$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferaySupport.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferayURL$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferayURL$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferayURL$$anonfun$org$orbeon$oxf$portlet$liferay$LiferayURL$$createPortletURL$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferayURL$$anonfun$org$orbeon$oxf$portlet$liferay$LiferayURL$$createPortletURL$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferayURL$$anonfun$wsrpToPortletURL$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferayURL$$anonfun$wsrpToPortletURL$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferayURL$$anonfun$wsrpToPortletURL$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferayURL$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\liferay\LiferayURL.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet$$anonfun$destroy$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet$$anonfun$destroy$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet$$anonfun$init$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet$$anonfun$init$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet$$anonfun$initParameters$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet$$anonfun$org$orbeon$oxf$portlet$OrbeonPortlet$$callService$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet$$anonfun$org$orbeon$oxf$portlet$OrbeonPortlet$$directServeResource$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet$$anonfun$processAction$1$$anonfun$apply$mcV$sp$2$$anonfun$apply$mcV$sp$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet$$anonfun$processAction$1$$anonfun$apply$mcV$sp$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet$$anonfun$processAction$1$$anonfun$apply$mcV$sp$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet$$anonfun$processAction$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet$$anonfun$render$1$$anonfun$apply$mcV$sp$1$$anonfun$apply$mcV$sp$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet$$anonfun$render$1$$anonfun$apply$mcV$sp$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet$$anonfun$render$1$$anonfun$apply$mcV$sp$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet$$anonfun$render$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet$$anonfun$serveResource$1$$anonfun$apply$mcV$sp$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet$$anonfun$serveResource$1$$anonfun$apply$mcV$sp$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet$$anonfun$serveResource$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet$AsyncContext$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet$AsyncContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortlet2Delegate.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonPortletDelegate.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$clientHeaders$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$destroy$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$doView$1$$anonfun$apply$1$$anonfun$apply$mcV$sp$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$doView$1$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$doView$1$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$doView$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$findServletRequest$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$getPreferenceOrRequested$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$init$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$init$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$liftedTree1$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$org$orbeon$oxf$portlet$OrbeonProxyPortlet$$contentFromRequest$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$org$orbeon$oxf$portlet$OrbeonProxyPortlet$$doViewAction$1$$anonfun$apply$2$$anonfun$apply$mcV$sp$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$org$orbeon$oxf$portlet$OrbeonProxyPortlet$$doViewAction$1$$anonfun$apply$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$org$orbeon$oxf$portlet$OrbeonProxyPortlet$$doViewAction$1$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$org$orbeon$oxf$portlet$OrbeonProxyPortlet$$doViewAction$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$paramsToSet$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$paramsToSet$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$paramsToSet$1$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$portalQuery$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$portalQuery$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$preferenceFromPortalQuery$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$processAction$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$serveResource$1$$anonfun$apply$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$serveResource$1$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$serveResource$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$userHeaders$1$1$$anonfun$apply$7$$anonfun$apply$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$userHeaders$1$1$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$$anonfun$userHeaders$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$PortletSettings$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet$PortletSettings.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\OrbeonProxyPortlet.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\Portlet2ExternalContext$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\Portlet2ExternalContext$BaseResponse.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\Portlet2ExternalContext$BufferedResponse.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\Portlet2ExternalContext$Request.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\Portlet2ExternalContext$RequestMap$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\Portlet2ExternalContext$RequestMap.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\Portlet2ExternalContext$Session.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\Portlet2ExternalContext$SessionMap$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\Portlet2ExternalContext$SessionMap.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\Portlet2ExternalContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\PortletEmbeddingContext$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\PortletEmbeddingContext$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\PortletEmbeddingContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\PortletEmbeddingContextWithResponse.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\processor\PortletPreferencesGenerator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\processor\PortletPreferencesGenerator.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\processor\PortletPreferencesSerializer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$$anonfun$doEdit$1$$anonfun$apply$mcV$sp$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$$anonfun$doEdit$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$$anonfun$doEdit$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$$anonfun$doEditAction$1$$anonfun$apply$mcV$sp$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$$anonfun$doEditAction$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$$anonfun$doEditAction$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$AppName$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$CheckboxControl$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$ControlType.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$DocumentId$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$EnableURLParameters$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$FormName$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$FormRunnerURL$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$InputControl$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$NameLabel$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$NameLabel$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$NameLabel.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$Page$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$Pref.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$ReadOnly$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$SelectControl$$anonfun$render$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$SelectControl$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$SelectControl.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$SendLiferayLanguage$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit$SendLiferayUser$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\ProxyPortletEdit.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\portlet\RequestFilter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\AbstractProcessor.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\barcode\BarcodeProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\CacheableInputReader.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\CacheProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\CacheProcessor$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\CacheProcessor$3$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\CacheProcessor$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\CacheProcessor$CachedValidity.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\CacheProcessor$State.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\CacheProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\AbstractRewrite$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\AbstractRewrite$NoRewriteState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\AbstractRewrite$RewriteState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\AbstractRewrite$State2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\AbstractRewrite.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\Converter$$anon$1$$anon$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\Converter$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\Converter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\ConverterBase$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\ConverterBase$Config.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\ConverterBase.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\FromXLSConverter$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\FromXLSConverter$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\FromXLSConverter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\HTMLConverter$HTMLFilterReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\HTMLConverter.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\HTMLRewrite.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\JFreeChartConverter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\PlainHTMLConverter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\PlainXHTMLConverter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\QNameConverter$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\QNameConverter$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\QNameConverter$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\QNameConverter$Config.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\QNameConverter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\SVGConverter.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\TextConverter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\TextConverterBase$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\TextConverterBase$FilterReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\TextConverterBase.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\ToXLSConverter.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\ToXMLConverter$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\ToXMLConverter$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\ToXMLConverter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\XHTMLRewrite.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\XHTMLServletRewrite$$anon$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\XHTMLServletRewrite.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\XMLConverter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\converter\XSLFOConverter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\DatabaseContext$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\DatabaseContext$Context.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\DatabaseContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\Datasource$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\Datasource.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\DebugProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\DebugProcessor.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\DelegationProcessor$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\DelegationProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\DelegationProcessor$OperationDefinition.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\DelegationProcessor$ServiceDefinition.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\DelegationProcessor.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\DOMSerializer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$$anon$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$$anon$3$$anonfun$getPasswordAuthentication$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$$anon$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$$anonfun$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$$anonfun$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$$anonfun$7.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$$anonfun$addRecipients$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$$anonfun$handlePart$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$$anonfun$handlePart$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$$anonfun$optionalValueTrim$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$$anonfun$start$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$$anonfun$start$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$$anonfun$valueFromElementOrProperty$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$ReadonlyDataSource.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$SimpleBinaryDataSource.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor$SimpleTextDataSource.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\EmailProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ErrorProcessor.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ExceptionCatcher$$anon$1$$anon$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ExceptionCatcher$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ExceptionCatcher.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\execute\ExecuteProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\execute\ExecuteProcessor$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\execute\ExecuteProcessor$Config.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\execute\ExecuteProcessor$State.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\execute\ExecuteProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\file\FileProcessor$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\file\FileProcessor$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\file\FileProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\BeanGenerator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\BeanGenerator$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\BeanGenerator$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\BeanGenerator$Config.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\BeanGenerator$State.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\BeanGenerator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\DirectoryScanner$EventListener.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\DirectoryScanner.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\DirectoryScannerProcessor$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\DirectoryScannerProcessor$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\DirectoryScannerProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\DirectoryScannerProcessor$Config.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\DirectoryScannerProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\DOMGenerator$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\DOMGenerator$DocKey.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\DOMGenerator$DOM4JSourceFactory.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\DOMGenerator$SourceFactory.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\DOMGenerator$TinyTreeSourceFactory.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\DOMGenerator$W3CSourceFactory.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\DOMGenerator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\ExceptionGenerator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\ExceptionGenerator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\KeyPairGenerator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\KeyPairGenerator.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\RequestGenerator$1$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\RequestGenerator$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\RequestGenerator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\RequestGenerator$Context.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\RequestGenerator$State.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\RequestGenerator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\RequestSecurityGenerator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\RequestSecurityGenerator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\SAXStoreGenerator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\SAXStoreGenerator.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\ServletIncludeGenerator$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\ServletIncludeGenerator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\ServletIncludeGenerator$Config.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\ServletIncludeGenerator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\SessionGenerator$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\SessionGenerator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\SessionGenerator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\TidyConfig.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\URLGenerator$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\URLGenerator$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\URLGenerator$Config.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\URLGenerator$ConfigURIReferences.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\URLGenerator$OXFResourceHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\URLGenerator$ResourceHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\URLGenerator$ResourceHandlerBase.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\URLGenerator$SystemResourceHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\URLGenerator$URLGeneratorState$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\URLGenerator$URLGeneratorState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\URLGenerator$URLResourceHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\URLGenerator.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\XLSGenerator$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\XLSGenerator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\generator\XLSGenerator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\GlobProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\IdentityProcessor$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\IdentityProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ImageServer$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ImageServer$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ImageServer$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ImageServer$4$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ImageServer$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ImageServer$Config.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ImageServer$ImageConfig.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ImageServer$ImageResponse.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ImageServer.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\impl\CacheableTransformerOutputImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\impl\DelegatingProcessorInput.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\impl\DependenciesProcessorInput$1$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\impl\DependenciesProcessorInput$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\impl\DependenciesProcessorInput$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\impl\DependenciesProcessorInput.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\impl\DigestState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\impl\DigestTransformerOutputImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\impl\DigestValidity.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\impl\ProcessorInputImpl.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\impl\ProcessorOutputImpl$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\impl\ProcessorOutputImpl$ConcreteRuntimeOutputFilter$ForwarderRuntimeOutputOutput.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\impl\ProcessorOutputImpl$ConcreteRuntimeOutputFilter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\impl\ProcessorOutputImpl$RuntimeOutputFilter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\impl\ProcessorOutputImpl$TopLevelOutputFilter.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\impl\ProcessorOutputImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\InstanceToParametersProcessor$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\InstanceToParametersProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\InstanceToParametersProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\JavaProcessor$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\JavaProcessor$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\JavaProcessor$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\JavaProcessor$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\JavaProcessor$Config.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\JavaProcessor$Sourcepath.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\JavaProcessor$State.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\JavaProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\JFreeChartProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\JFreeChartProcessor$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\JFreeChartProcessor$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\JFreeChartProcessor$ChartInfo.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\JFreeChartProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\LDAPProcessor$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\LDAPProcessor$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\LDAPProcessor$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\LDAPProcessor$Add.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\LDAPProcessor$Command.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\LDAPProcessor$CommandWithAttributes.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\LDAPProcessor$Config.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\LDAPProcessor$Delete.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\LDAPProcessor$Search.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\LDAPProcessor$Update.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\LDAPProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\NullProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\NullSerializer.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\OutputObjectCreator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$16.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$17.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$18.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$19.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$handleElements$1$$anonfun$apply$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$handleElements$1$$anonfun$pageNumberMatches$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$handleElements$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$handleField$1$$anonfun$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$handleField$1$$anonfun$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$handleField$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$handleField$2$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$handleField$2$$anonfun$15.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$handleField$2$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$handleField$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$handleGroup$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$handleImage$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$handleImage$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$handleImage$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$handleRepeat$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$isType1Font$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$readInput$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$readInput$1$$anonfun$apply$3$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$readInput$1$$anonfun$apply$3$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$readInput$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$readInput$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$stampGrid$1$$anonfun$apply$mcVF$sp$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$stampGrid$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$stampGrid$2$$anonfun$apply$mcVF$sp$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$stampGrid$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$stampGrid$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$stampGrid$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$stampGrid$5$$anonfun$apply$mcVF$sp$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$stampGrid$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$stampGrid$6$$anonfun$apply$mcVF$sp$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$$anonfun$stampGrid$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$ElementContext$$anonfun$20.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$ElementContext$$anonfun$21.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$ElementContext$$anonfun$22.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$ElementContext$$anonfun$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$ElementContext$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$ElementContext$$anonfun$resolveAVT$1$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$ElementContext$$anonfun$resolveAVT$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$ElementContext$$anonfun$resolveAVT$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$ElementContext$$anonfun$resolveFloat$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$ElementContext$$anonfun$resolveFloat$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$ElementContext$$anonfun$resolveString$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$ElementContext$$anonfun$resolveString$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$ElementContext$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$ElementContext.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$FontAttributes$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor$FontAttributes.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\PDFTemplateProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\XHTMLToPDFProcessor$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\XHTMLToPDFProcessor$1$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\XHTMLToPDFProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pdf\XHTMLToPDFProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\AggregatorProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\AggregatorProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\ast\ASTChoose.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\ast\ASTDebugSchema.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\ast\ASTDocumentHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\ast\ASTForEach.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\ast\ASTHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\ast\ASTHref.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\ast\ASTHrefAggregate.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\ast\ASTHrefId.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\ast\ASTHrefURL.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\ast\ASTHrefXPointer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\ast\ASTInput.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\ast\ASTInputOutput.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\ast\ASTNodeContainer$1IdInfoASTHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\ast\ASTNodeContainer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\ast\ASTOutput.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\ast\ASTParam.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\ast\ASTPipeline.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\ast\ASTProcessorCall.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\ast\ASTSimpleHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\ast\ASTStatement.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\ast\ASTWhen.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\ast\IdInfo.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\choose\AbstractChooseProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\choose\ConcreteChooseProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\choose\ConcreteChooseProcessor$State.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\choose\ConcreteChooseProcessor.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\foreach\AbstractForEachProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\foreach\ConcreteForEachProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\foreach\ConcreteForEachProcessor$ElementIterator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\foreach\ConcreteForEachProcessor$ForwardingProcessorOutput.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\foreach\ConcreteForEachProcessor$IterationProcessorOutput.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\foreach\ConcreteForEachProcessor$State.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\foreach\ConcreteForEachProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\functions\DecodeResourceURI.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineBlock.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineConfig.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineFunctionLibrary$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineFunctionLibrary.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineProcessor$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineProcessor$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineProcessor$1$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineProcessor$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineProcessor$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineProcessor$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineProcessor$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineProcessor$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineProcessor$InternalBottomInput.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineProcessor$InternalTopOutput$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineProcessor$InternalTopOutput$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineProcessor$InternalTopOutput$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineProcessor$InternalTopOutput.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineProcessor$State.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineReader$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineReader$1readCommonAttributes.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineReader$HrefResult.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\PipelineReader.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\TeeProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\TeeProcessor$State.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\TeeProcessor$TeeProcessorOutputImpl.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\pipeline\TeeProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\Processor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ProcessorFactory.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ProcessorFactoryRegistry.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ProcessorImpl$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ProcessorImpl$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ProcessorImpl$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ProcessorImpl$KeyValidity.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ProcessorImpl$ProcessorKey.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ProcessorImpl$ProcessorOutputImpl.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ProcessorImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ProcessorInput.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ProcessorInputOutput.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ProcessorInputOutputInfo.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ProcessorOutput.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ProcessorReader.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ProcessorUtils.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\RedirectProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\RegexpMatcher$$anonfun$writeXML$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\RegexpMatcher$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\RegexpMatcher$MatchResult$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\RegexpMatcher$MatchResult$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\RegexpMatcher$MatchResult.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\RegexpMatcher.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\RegexpProcessor$$anon$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\RegexpProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ResourceServer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\SAXInspectorProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\SAXInspectorProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\SAXLoggerProcessor$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\SAXLoggerProcessor$DebugXMLReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\SAXLoggerProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\SAXStoreSerializer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\SchedulerProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\SchedulerProcessor$Config.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\SchedulerProcessor$ProcessorTask.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\SchedulerProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\scope\ScopeGenerator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\scope\ScopeGenerator$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\scope\ScopeGenerator$State.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\scope\ScopeGenerator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\scope\ScopeProcessorBase$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\scope\ScopeProcessorBase$ContextConfig.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\scope\ScopeProcessorBase.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\scope\ScopeSerializer$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\scope\ScopeSerializer$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\scope\ScopeSerializer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\scope\ScopeStore.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\BinaryTextXMLReceiver$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\BinaryTextXMLReceiver$$anonfun$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\BinaryTextXMLReceiver$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\BinaryTextXMLReceiver$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\BinaryTextXMLReceiver$$anonfun$org$orbeon$oxf$processor$serializer$BinaryTextXMLReceiver$$getContentType$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\BinaryTextXMLReceiver$$anonfun$org$orbeon$oxf$processor$serializer$BinaryTextXMLReceiver$$getContentType$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\BinaryTextXMLReceiver$$anonfun$org$orbeon$oxf$processor$serializer$BinaryTextXMLReceiver$$getContentType$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\BinaryTextXMLReceiver$$anonfun$org$orbeon$oxf$processor$serializer$BinaryTextXMLReceiver$$getEncoding$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\BinaryTextXMLReceiver$$anonfun$org$orbeon$oxf$processor$serializer$BinaryTextXMLReceiver$$getEncoding$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\BinaryTextXMLReceiver$$anonfun$org$orbeon$oxf$processor$serializer$BinaryTextXMLReceiver$$getEncoding$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\BinaryTextXMLReceiver$$anonfun$parseSerializerPI$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\BinaryTextXMLReceiver$$anonfun$processingInstruction$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\BinaryTextXMLReceiver$$anonfun$startElement$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\BinaryTextXMLReceiver$$anonfun$startElement$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\BinaryTextXMLReceiver$$anonfun$startElement$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\BinaryTextXMLReceiver$$anonfun$startElement$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\BinaryTextXMLReceiver$$anonfun$startElement$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\BinaryTextXMLReceiver$$anonfun$startElement$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\BinaryTextXMLReceiver$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\BinaryTextXMLReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\CachedSerializer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\FileSerializer$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\FileSerializer$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\FileSerializer$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\FileSerializer$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\FileSerializer$Config.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\FileSerializer.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\HttpSerializer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\HttpSerializerBase$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\HttpSerializerBase$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\HttpSerializerBase$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\HttpSerializerBase$Config.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\HttpSerializerBase$ExtendedResultStoreOutputStream.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\HttpSerializerBase.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\BinarySerializer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\FileSerializer$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\FileSerializer$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\FileSerializer$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\FileSerializer$Config.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\FileSerializer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\HTMLSerializer$StripNamespaceXMLReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\HTMLSerializer.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\HttpBinarySerializer$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\HttpBinarySerializer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\HttpTextSerializer$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\HttpTextSerializer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\JFreeChartSerializer$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\JFreeChartSerializer$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\JFreeChartSerializer$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\JFreeChartSerializer$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\JFreeChartSerializer$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\JFreeChartSerializer$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\JFreeChartSerializer$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\JFreeChartSerializer$ChartConfig.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\JFreeChartSerializer$CustomLegend.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\JFreeChartSerializer$ExtendedPieDataset$Value.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\JFreeChartSerializer$ExtendedPieDataset.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\JFreeChartSerializer$ItemPaintCategoryDataset.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\JFreeChartSerializer$RestrictedNumberAxis.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\JFreeChartSerializer$Value.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\JFreeChartSerializer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\SerializerXMLReceiver.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\SVGSerializer$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\SVGSerializer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\TextSerializer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\XLSSerializer$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\XLSSerializer.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\XMLSerializer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\legacy\XSLFOSerializer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\store\ResultStore.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\store\ResultStoreOutputStream.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\URLSerializer$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\serializer\URLSerializer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ServletFilterGenerator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ServletFilterGenerator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ServletResponseWrapper$ByteArrayServletOutputStream.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\ServletResponseWrapper.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\SessionInvalidator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\SessionSerializer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\SignatureProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\SignatureProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\SignatureVerifierProcessor$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\SignatureVerifierProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\SimpleProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\SimpleProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\DatabaseDelegate.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\delegates\SQLProcessorGenericDelegate.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\delegates\SQLProcessorOracleJBoss6Delegate.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\delegates\SQLProcessorOracleJBoss7Delegate.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\delegates\SQLProcessorOracleJDBC4Delegate.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\delegates\SQLProcessorOracleTomcatDelegate.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\delegates\SQLProcessorStandardDelegate$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\delegates\SQLProcessorStandardDelegate.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\AttributeInterpreter$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\AttributeInterpreter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\ColumnIteratorInterpreter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\ConfigInterpreter.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\ConnectionInterpreter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\DatasourceInterpreter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\ExecuteInterpreter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\ForEachInterpreter$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\ForEachInterpreter.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\GetterInterpreter$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\GetterInterpreter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\NoResultsInterpreter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\QueryInterpreter$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\QueryInterpreter$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\QueryInterpreter$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\QueryInterpreter$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\QueryInterpreter$QueryParameter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\QueryInterpreter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\ResultSetInterpreter.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\RowIteratorInterpreter$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\RowIteratorInterpreter$Group.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\RowIteratorInterpreter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\TextInterpreter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\ValueOfCopyOfInterpreter$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\interpreters\ValueOfCopyOfInterpreter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\SQLInputProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\SQLOutputProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\SQLProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\SQLProcessor$2$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\SQLProcessor$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\SQLProcessor$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\SQLProcessor$Config.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\SQLProcessor$ForwardingContentHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\SQLProcessor$InterpreterContentHandler.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\SQLProcessor$RootInterpreter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\SQLProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\SQLProcessorInterpreterContext$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\SQLProcessorInterpreterContext$Context.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\SQLProcessorInterpreterContext$ExecutionContext.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\SQLProcessorInterpreterContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\SQLProcessorOracleDelegateBase$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\sql\SQLProcessorOracleDelegateBase.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\StreamInterceptor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\TagSoupProcessor$$anon$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\TagSoupProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\test\CacheViewProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\test\CacheViewProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\test\CounterProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\test\CounterProcessor.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\test\SleepProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\test\SleepProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\test\TestExternalContext$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\test\TestExternalContext$Request.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\test\TestExternalContext$Response.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\test\TestExternalContext$TestSession.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\test\TestExternalContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\test\TestScriptProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\test\TestScriptProcessor$ExecutionContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\test\TestScriptProcessor$OutputProcessor.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\test\TestScriptProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\SaxonXQueryProcessor$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\SaxonXQueryProcessor$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\SaxonXQueryProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\SaxonXQueryProcessor.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\TransformerURIResolver$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\TransformerURIResolver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\TraxTransformer$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\TraxTransformer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\URIResolverListener.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\XPathProcessor$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\XPathProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\XPathProcessor$Config.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\XPathProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\xslt\StringErrorListener.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\xslt\XSLT1Transformer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\xslt\XSLT2Transformer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\xslt\XSLTTransformer$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\xslt\XSLTTransformer$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\xslt\XSLTTransformer$1$3$OutputLocator.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\xslt\XSLTTransformer$1$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\xslt\XSLTTransformer$1$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\xslt\XSLTTransformer$1$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\xslt\XSLTTransformer$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\xslt\XSLTTransformer$StylesheetForwardingXMLReceiver$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\xslt\XSLTTransformer$StylesheetForwardingXMLReceiver$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\xslt\XSLTTransformer$StylesheetForwardingXMLReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\xslt\XSLTTransformer$TemplatesInfo.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\xslt\XSLTTransformer$URIReference.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\xslt\XSLTTransformer$URIReferences.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\xslt\XSLTTransformer$XSLTTransformerState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\transformer\xslt\XSLTTransformer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\URIProcessorOutputImpl$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\URIProcessorOutputImpl$DocumentInfo.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\URIProcessorOutputImpl$URIReference.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\URIProcessorOutputImpl$URIReferences.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\URIProcessorOutputImpl$URIReferencesState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\URIProcessorOutputImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\util\DigestCacheProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\validation\MSVValidationProcessor$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\validation\MSVValidationProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\validation\MSVValidationProcessor$2$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\validation\MSVValidationProcessor$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\validation\MSVValidationProcessor$3$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\validation\MSVValidationProcessor$3$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\validation\MSVValidationProcessor$3$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\validation\MSVValidationProcessor$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\validation\MSVValidationProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\validation\SchemaValidationException.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\xinclude\XIncludeProcessor$$anon$1$$anon$2$$anonfun$read$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\xinclude\XIncludeProcessor$$anon$1$$anon$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\xinclude\XIncludeProcessor$$anon$1$$anon$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\xinclude\XIncludeProcessor$$anon$1$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\xinclude\XIncludeProcessor$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\xinclude\XIncludeProcessor.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\xmldb\XMLDBDeleteProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\xmldb\XMLDBInsertProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\xmldb\XMLDBProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\xmldb\XMLDBProcessor$Config.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\xmldb\XMLDBProcessor$DatabaseReadXMLReceiver.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\xmldb\XMLDBProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\xmldb\XMLDBQueryProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\xmldb\XMLDBQueryProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\xmldb\XMLDBUpdateProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\XMLProcessorRegistry$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\XMLProcessorRegistry$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\XMLProcessorRegistry.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\XQuery\ObjectReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\XQuery\XQueryProcessor$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\XQuery\XQueryProcessor$1$1ConfigContainer$Config$JDBC.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\XQuery\XQueryProcessor$1$1ConfigContainer$Config$NameValuePair.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\XQuery\XQueryProcessor$1$1ConfigContainer$Config.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\XQuery\XQueryProcessor$1$1ConfigContainer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\XQuery\XQueryProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\XQuery\XQueryProcessor.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\zip\UnzipProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\zip\UnzipProcessor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\zip\ZipProcessor$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\zip\ZipProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\processor\zip\ZipProcessor.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\JPropertySet$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\JPropertySet$Property$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\JPropertySet$Property.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\JPropertySet$PropertyNode.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\JPropertySet.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\Properties.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertySet$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertySet$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertySet$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertySet$$anonfun$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertySet$$anonfun$getBoolean$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertySet$$anonfun$getBoolean$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertySet$$anonfun$getInteger$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertySet$$anonfun$getObject$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertySet$$anonfun$getProperty$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertySet$$anonfun$getProperty$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertySet$$anonfun$getPropertyValue$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertySet$$anonfun$getQName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertySet$$anonfun$getString$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertySet$$anonfun$getStringOrURIAsString$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertySet$$anonfun$org$orbeon$oxf$properties$PropertySet$$processNode$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertySet$$anonfun$org$orbeon$oxf$properties$PropertySet$$processNode$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertySet$$anonfun$org$orbeon$oxf$properties$PropertySet$$processNode$1$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertySet$$anonfun$org$orbeon$oxf$properties$PropertySet$$processNode$1$4$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertySet$$anonfun$org$orbeon$oxf$properties$PropertySet$$processNode$1$4$$anonfun$apply$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertySet$$anonfun$org$orbeon$oxf$properties$PropertySet$$processNode$1$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertySet$$anonfun$setProperty$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertySet$$anonfun$setProperty$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertySet.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertyStore$BooleanConverter.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertyStore$Converter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertyStore$DateConverter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertyStore$IntegerConverter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertyStore$NCNameConverter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertyStore$NMTOKENConverter.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertyStore$NMTOKENSConverter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertyStore$NonNegativeIntegerConverter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertyStore$QNameConverter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertyStore$StringConverter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertyStore$URIConverter.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\properties\PropertyStore.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\ClassLoaderResourceManagerFactory.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\ClassLoaderResourceManagerImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\ExpirationMap$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\ExpirationMap$MapEntry.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\ExpirationMap.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\FilesystemResourceManagerFactory.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\FilesystemResourceManagerImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\handler\DataHandler$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\handler\DataHandler$DataURLConnection.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\handler\DataHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\handler\DataURLDecoder$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\handler\DataURLDecoder$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\handler\DataURLDecoder$$anonfun$parseContentTypeParameters$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\handler\DataURLDecoder$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\handler\DataURLDecoder.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\handler\DecodedDataURL$$anonfun$asString$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\handler\DecodedDataURL$$anonfun$contentType$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\handler\DecodedDataURL$$anonfun$contentType$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\handler\DecodedDataURL.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\handler\HTTPHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\handler\OXFHandler$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\handler\OXFHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\handler\SystemHandler$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\handler\SystemHandler.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\PriorityResourceManagerFactory.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\PriorityResourceManagerImpl$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\PriorityResourceManagerImpl$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\PriorityResourceManagerImpl$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\PriorityResourceManagerImpl$12.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\PriorityResourceManagerImpl$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\PriorityResourceManagerImpl$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\PriorityResourceManagerImpl$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\PriorityResourceManagerImpl$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\PriorityResourceManagerImpl$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\PriorityResourceManagerImpl$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\PriorityResourceManagerImpl$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\PriorityResourceManagerImpl$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\PriorityResourceManagerImpl$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\PriorityResourceManagerImpl$Operation.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\PriorityResourceManagerImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\ResourceCache.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\ResourceManager.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\ResourceManagerBase$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\ResourceManagerBase$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\ResourceManagerBase.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\ResourceManagerFactoryFunctor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\ResourceManagerWrapper.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\ResourceNotFoundException.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\URLFactory$$anonfun$createURL$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\URLFactory$$anonfun$protocol$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\URLFactory$$anonfun$protocol$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\URLFactory$$anonfun$protocol$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\URLFactory$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\URLFactory.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\URLResourceManagerFactory.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\URLResourceManagerImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\WebAppResourceManagerFactory.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\resources\WebAppResourceManagerImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servicedirectory\ServiceDefinition.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servicedirectory\ServiceDirectory.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\BaseServletRequestWrapper$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\BaseServletRequestWrapper$$anonfun$extraQueryParametersIterator$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\BaseServletRequestWrapper$$anonfun$extraQueryParametersIterator$1$2$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\BaseServletRequestWrapper$$anonfun$extraQueryParametersIterator$1$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\BaseServletRequestWrapper$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\BaseServletRequestWrapper.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\FilterRequestWrapper$$anonfun$headersToRemove$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\FilterRequestWrapper.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\FilterResponseWrapper$$anon$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\FilterResponseWrapper$$anonfun$getCharacterEncoding$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\FilterResponseWrapper$$anonfun$resetBuffer$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\FilterResponseWrapper.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\FilterSettings$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\FilterSettings$$anonfun$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\FilterSettings$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\FilterSettings.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\FormRunnerRequestFilter$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\FormRunnerRequestFilter$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\FormRunnerRequestFilter$CustomHeaders$1$$anonfun$getHeader$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\FormRunnerRequestFilter$CustomHeaders$1$$anonfun$getHeader$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\FormRunnerRequestFilter$CustomHeaders$1$$anonfun$getHeaderNames$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\FormRunnerRequestFilter$CustomHeaders$1$$anonfun$getHeaders$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\FormRunnerRequestFilter$CustomHeaders$1$$anonfun$getHeaders$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\FormRunnerRequestFilter$CustomHeaders$1$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\FormRunnerRequestFilter$CustomHeaders$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\FormRunnerRequestFilter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\ForwardServletRequestWrapper.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OptionalBodyFilterRequestWrapper$$anon$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OptionalBodyFilterRequestWrapper$$anon$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OptionalBodyFilterRequestWrapper.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonServlet$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonServlet$$anonfun$destroy$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonServlet$$anonfun$destroy$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonServlet$$anonfun$init$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonServlet$$anonfun$init$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonServlet$$anonfun$initParameters$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonServlet$$anonfun$org$orbeon$oxf$servlet$OrbeonServlet$$acceptedMethods$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonServlet$$anonfun$org$orbeon$oxf$servlet$OrbeonServlet$$acceptedMethods$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonServlet$$anonfun$service$1$$anonfun$apply$mcV$sp$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonServlet$$anonfun$service$1$$anonfun$apply$mcV$sp$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonServlet$$anonfun$service$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonServlet$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonServlet.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonServletDelegate.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonServletFilter$$anonfun$destroy$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonServletFilter$$anonfun$destroy$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonServletFilter$$anonfun$doFilter$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonServletFilter$$anonfun$doFilter$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonServletFilter$$anonfun$init$1$$anonfun$apply$mcV$sp$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonServletFilter$$anonfun$init$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonServletFilter$$anonfun$init$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonServletFilter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonServletFilterDelegate.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonXFormsFilter$$anonfun$doFilter$1$$anonfun$3$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonXFormsFilter$$anonfun$doFilter$1$$anonfun$3$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonXFormsFilter$$anonfun$doFilter$1$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonXFormsFilter$$anonfun$doFilter$1$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonXFormsFilter$$anonfun$doFilter$1$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonXFormsFilter$$anonfun$doFilter$1$$anonfun$apply$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonXFormsFilter$$anonfun$doFilter$1$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonXFormsFilter$$anonfun$doFilter$1$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonXFormsFilter$$anonfun$doFilter$1$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonXFormsFilter$$anonfun$doFilter$1$$anonfun$getOrbeonDispatcher$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonXFormsFilter$$anonfun$doFilter$1$$anonfun$getOrbeonDispatcher$1$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonXFormsFilter$$anonfun$doFilter$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonXFormsFilter$$anonfun$init$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonXFormsFilter$$anonfun$init$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonXFormsFilter$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\OrbeonXFormsFilter.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\RequestEmptyBody$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\RequestEmptyBody.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\RequestFilter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\RequestPathQuery$$anonfun$getParameter$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\RequestPathQuery$$anonfun$getQueryString$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\RequestPathQuery$$anonfun$org$orbeon$oxf$servlet$RequestPathQuery$$parameters$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\RequestPathQuery$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\RequestPathQuery.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\RequestPrependHeaders$$anonfun$addedHeaderOption$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\RequestPrependHeaders$$anonfun$addedHeaderOption$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\RequestPrependHeaders$$anonfun$getDateHeader$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\RequestPrependHeaders$$anonfun$getDateHeader$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\RequestPrependHeaders$$anonfun$getHeader$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\RequestPrependHeaders$$anonfun$getHeaderNames$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\RequestPrependHeaders$$anonfun$getHeaders$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\RequestPrependHeaders$$anonfun$getHeaders$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\RequestPrependHeaders$$anonfun$getIntHeader$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\RequestPrependHeaders$$anonfun$getIntHeader$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\RequestPrependHeaders$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\RequestPrependHeaders.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\RequestRemoveHeaders$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\RequestRemoveHeaders.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\ServletExternalContext$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\ServletExternalContext$Request.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\ServletExternalContext$Response.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\ServletExternalContext$Session.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\ServletExternalContext$SessionListeners.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\ServletExternalContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\TokenSecurityFilter$$anonfun$authorized$1$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\TokenSecurityFilter$$anonfun$authorized$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\TokenSecurityFilter$$anonfun$authorized$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\servlet\TokenSecurityFilter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\Closure.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\DocumentContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\Append.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\Assign.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\Attribute.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\Choose.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\CopyOf.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\DynamicElement.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\Error.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\ForEach.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\Function.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\If.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\InsertAfter.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\InsertBefore.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\Message.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\Namespace.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\NodeSet.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\Param.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\Remove.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\StaticElement.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\Text.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\Update.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\Utils$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\Utils$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\Utils$1$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\Utils$1$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\Utils$1$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\Utils$1$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\Utils$1$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\Utils$1$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\Utils$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\Utils.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\ValueOf.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\Variable.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\statement\While.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\Statement.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\TemplatesHandlerImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\TemplatesImpl.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\TemplatesOperation.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\TransformerFactoryImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\TransformerImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\VariableContextImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\XUpdateConstants.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\transformer\xupdate\XUpdateDriver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\AttributesToMap$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\AttributesToMap$Attributeable.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\AttributesToMap.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Base64.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Base64XMLReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\CharacterAccumulator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\CoffeeScriptTask$$anonfun$execute$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\CoffeeScriptTask$$anonfun$execute$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\CoffeeScriptTask$$anonfun$execute$3$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\CoffeeScriptTask$$anonfun$execute$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\CoffeeScriptTask.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$12.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$15.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$16$$anonfun$apply$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$16$$anonfun$apply$11$$anonfun$apply$12.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$16$$anonfun$apply$11$$anonfun$apply$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$16$$anonfun$apply$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$16.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$17.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$18.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$19.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$22.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$23.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$24.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$25.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$26.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$5$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$5$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$8.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$buildSOAPHeadersLowerIfNeeded$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$buildSOAPHeadersLowerIfNeeded$2$$anonfun$apply$23.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$buildSOAPHeadersLowerIfNeeded$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$charsetSuffix$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$connect$1$$anonfun$9.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$connect$1$$anonfun$apply$mcV$sp$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$connect$1$$anonfun$apply$mcV$sp$2$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$connect$1$$anonfun$apply$mcV$sp$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$connect$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$connect$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$contentTypeHeader$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$contentTypeHeader$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$fromIncoming$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$jBuildConnectionHeadersLowerIfNeeded$1$$anonfun$apply$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$jBuildConnectionHeadersLowerIfNeeded$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$jBuildConnectionHeadersLowerIfNeeded$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$org$orbeon$oxf$util$Connection$$canForwardHeader$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$org$orbeon$oxf$util$Connection$$canForwardHeader$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$org$orbeon$oxf$util$Connection$$contentTypeFromPath$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$org$orbeon$oxf$util$Connection$$requestedSessionIdMatches$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$org$orbeon$oxf$util$Connection$$sessionCookieFromIncoming$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$org$orbeon$oxf$util$Connection$$sessionCookieFromIncoming$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$sessionCookieFromGuess$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$sessionCookieHeaderLower$1$$anonfun$20$$anonfun$apply$14$$anonfun$apply$15.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$sessionCookieHeaderLower$1$$anonfun$20$$anonfun$apply$14$$anonfun$apply$16.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$sessionCookieHeaderLower$1$$anonfun$20$$anonfun$apply$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$sessionCookieHeaderLower$1$$anonfun$20.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$sessionCookieHeaderLower$1$$anonfun$21$$anonfun$apply$17$$anonfun$apply$18.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$sessionCookieHeaderLower$1$$anonfun$21$$anonfun$apply$17$$anonfun$apply$19.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$sessionCookieHeaderLower$1$$anonfun$21$$anonfun$apply$17.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$sessionCookieHeaderLower$1$$anonfun$21.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$sessionCookieHeaderLower$1$$anonfun$apply$mcV$sp$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$sessionCookieHeaderLower$1$$anonfun$apply$mcV$sp$4$$anonfun$apply$20.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$sessionCookieHeaderLower$1$$anonfun$apply$mcV$sp$4$$anonfun$apply$21.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$sessionCookieHeaderLower$1$$anonfun$apply$mcV$sp$4$$anonfun$apply$22.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$sessionCookieHeaderLower$1$$anonfun$apply$mcV$sp$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$sessionCookieHeaderLower$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$sessionCookieHeaderLower$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$$anonfun$soapMediatypeWithContentType$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Connection.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult$$anonfun$4$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult$$anonfun$getHeaderIgnoreCase$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult$$anonfun$getHeaderIgnoreCase$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult$$anonfun$lastModifiedJava$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult$$anonfun$logResponseBody$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult$$anonfun$logResponseBody$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult$$anonfun$logResponseBody$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult$$anonfun$logResponseBody$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult$$anonfun$logResponseDetailsOnce$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult$$anonfun$logResponseDetailsOnce$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult$$anonfun$logResponseDetailsOnce$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult$$anonfun$logResponseDetailsOnce$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult$$anonfun$mediatypeOrDefault$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult$$anonfun$readStreamAsText$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult$$anonfun$readStreamAsText$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult$$anonfun$readTextResponseBody$1$$anonfun$applyOrElse$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult$$anonfun$readTextResponseBody$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult$$anonfun$tryWithSuccessConnection$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionResult.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionState$$anonfun$debugStore$1$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionState$$anonfun$debugStore$1$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionState$$anonfun$debugStore$1$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionState$$anonfun$debugStore$1$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionState$$anonfun$debugStore$1$$anonfun$apply$8.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionState$$anonfun$debugStore$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionState$$anonfun$loadHttpState$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionState$$anonfun$saveHttpState$1$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionState$$anonfun$saveHttpState$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionState$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionState$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ConnectionState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ContentHandlerOutputStream.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ContentHandlerWriter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\DateUtils$$anonfun$tryParseRFC1123$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\DateUtils$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\DateUtils.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\DynamicVariable$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\DynamicVariable$$anon$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\DynamicVariable$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\DynamicVariable.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Function1Adapter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ImageMetadata$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ImageMetadata$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ImageMetadata$$anonfun$3$$anonfun$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ImageMetadata$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ImageMetadata$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ImageMetadata$$anonfun$findImageMediatype$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ImageMetadata$$anonfun$findKnownMetadata$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ImageMetadata$$anonfun$findMetadata$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ImageMetadata$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ImageMetadata.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\IndentedLogger$Indentation.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\IndentedLogger$Operation.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\IndentedLogger.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\InternalHttpClient$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\InternalHttpClient$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\InternalHttpClient$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\InternalHttpClient$$anonfun$connect$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\InternalHttpClient$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\InternalHttpClient.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ISO9075.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\JMSUtils.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\JSON$$anonfun$quoteValue$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\JSON$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\JSON.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\LoggerFactory.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Logging$$anonfun$flattenTuples$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Logging$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Logging.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Mediatypes$$anonfun$getMimeType$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Mediatypes$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Mediatypes$Mapping$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Mediatypes$Mapping.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Mediatypes$MimeTypesContentHandler$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Mediatypes$MimeTypesContentHandler$DefaultState$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Mediatypes$MimeTypesContentHandler$NameState$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Mediatypes$MimeTypesContentHandler$PatternState$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Mediatypes$MimeTypesContentHandler$State.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Mediatypes$MimeTypesContentHandler.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Mediatypes.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anon$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anon$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$2$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$copyAndAdd$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$createFileItem$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$deleteFileItems$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$deleteFileItems$2$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$deleteFileItems$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$expectedSizeFromPart$1$1$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$expectedSizeFromPart$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$getUploadProgress$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$getUploadProgress$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$org$orbeon$oxf$util$Multipart$$expectedSizeFromRequest$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$org$orbeon$oxf$util$Multipart$$parseRequest$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$org$orbeon$oxf$util$Multipart$$parseRequest$1$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$org$orbeon$oxf$util$Multipart$$parseRequest$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$org$orbeon$oxf$util$Multipart$$parseRequest$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$org$orbeon$oxf$util$Multipart$$parseRequest$3$$anonfun$apply$3$$anonfun$apply$mcV$sp$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$org$orbeon$oxf$util$Multipart$$parseRequest$3$$anonfun$apply$3$$anonfun$apply$mcV$sp$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$org$orbeon$oxf$util$Multipart$$parseRequest$3$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$org$orbeon$oxf$util$Multipart$$parseRequest$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$org$orbeon$oxf$util$Multipart$$processStreamItem$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$org$orbeon$oxf$util$Multipart$$processStreamItem$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$org$orbeon$oxf$util$Multipart$$processStreamItem$1$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$org$orbeon$oxf$util$Multipart$$processStreamItem$default$3$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$parseMultipartRequest$1$$anon$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$parseMultipartRequest$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$$anonfun$removeUploadProgress$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$Completed$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$Interrupted$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$Interrupted.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$Reason.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$SizeReason$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$SizeReason.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$Started$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$UploadProgress$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$UploadProgress.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart$UploadState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Multipart.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\NetUtils$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\NetUtils$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\NetUtils$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\NetUtils$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\NetUtils$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\NetUtils$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\NetUtils.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\NumberUtils.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PathOps$$anonfun$decodeSimpleQuery$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PathOps$$anonfun$decodeSimpleQuery$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PathOps$$anonfun$decodeSimpleQuery$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PathOps$$anonfun$decodeSimpleQuery$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PathOps$$anonfun$decodeSimpleQuery$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PathOps$$anonfun$decodeSimpleQuery$6$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PathOps$$anonfun$decodeSimpleQuery$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PathOps$$anonfun$decodeSimpleQuery$7.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PathOps$$anonfun$encodeSimpleQuery$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PathOps$$anonfun$getFirstQueryParameter$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PathOps$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PathOps.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PipelineUtils.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PooledXPathExpression$$anonfun$evaluateAsExtent$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PooledXPathExpression$$anonfun$evaluateKeepItems$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PooledXPathExpression$$anonfun$evaluateKeepNodeInfo$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PooledXPathExpression$$anonfun$evaluateKeepNodeInfo$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PooledXPathExpression$$anonfun$evaluateSingleKeepItemOrNull$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PooledXPathExpression$$anonfun$evaluateSingleKeepNodeInfoOrNull$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PooledXPathExpression$$anonfun$evaluateToJavaReturnToPool$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PooledXPathExpression$$anonfun$iterateReturnJavaObjects$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PooledXPathExpression$$anonfun$prepareDynamicContext$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PooledXPathExpression$$anonfun$prepareDynamicContext$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PooledXPathExpression.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\PropertyContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$collectByErasedType$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$combineValues$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$combineValues$2$$anonfun$apply$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$combineValues$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$combineValues$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$copyReader$1$$anonfun$apply$10$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$copyReader$1$$anonfun$apply$10$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$copyReader$1$$anonfun$apply$10$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$copyReader$1$$anonfun$apply$10$$anonfun$apply$8.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$copyReader$1$$anonfun$apply$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$copyReader$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$copyReader$default$3$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$copyStream$1$$anonfun$apply$9$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$copyStream$1$$anonfun$apply$9$$anonfun$apply$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$copyStream$1$$anonfun$apply$9$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$copyStream$1$$anonfun$apply$9$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$copyStream$1$$anonfun$apply$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$copyStream$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$copyStream$default$3$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$nonEmptyOrNone$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$nonEmptyOrNone$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$stringOptionToSet$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$stringOptionToSet$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$$anonfun$useAndClose$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$anyToCollectable$$anonfun$collect$extension$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$anyToCollectable$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$anyToCollectable.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$BooleanWrapper$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$BooleanWrapper.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$IteratorExt$$anonfun$iterateWhile$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$IteratorExt$$anonfun$iterateWhileDefined$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$IteratorExt$$anonfun$iterateWhileDefined$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$IteratorExt$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$IteratorWrapper$$anonfun$nextOption$extension$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$IteratorWrapper$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$IteratorWrapper.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$OnFailurePF.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$OptionOps$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$OptionOps.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$PipeOps$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$PipeOps.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$TraversableLikeOps$$anonfun$groupByKeepOrder$extension$1$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$TraversableLikeOps$$anonfun$groupByKeepOrder$extension$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$TraversableLikeOps$$anonfun$groupByKeepOrder$extension$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$TraversableLikeOps$$anonfun$groupByKeepOrder$extension$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$TraversableLikeOps$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$TraversableLikeOps.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$TryOps$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils$TryOps.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\ScalaUtils.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\SecureUtils$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\SecureUtils$$anonfun$decryptIV$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\SecureUtils$$anonfun$encryptIV$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\SecureUtils$$anonfun$getPassword$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\SecureUtils$$anonfun$getPassword$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\SecureUtils$$anonfun$org$orbeon$oxf$util$SecureUtils$$preferredProviderOpt$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\SecureUtils$$anonfun$org$orbeon$oxf$util$SecureUtils$$preferredProviderOpt$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\SecureUtils$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\SecureUtils.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\SequenceReader.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\SoftReferenceObjectPool.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\StringBuilderWriter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\StringConversions.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\StringReplacer$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\StringReplacer$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\StringReplacer$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\StringReplacer$$anonfun$apply$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\StringReplacer$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\StringReplacer$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\StringReplacer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\SystemUtils.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\task\FilePersistStrategy$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\task\FilePersistStrategy$TaskFileFilter.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\task\FilePersistStrategy.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\task\Task.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\task\TaskPersistStrategy.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\task\TaskScheduler$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\task\TaskScheduler$RunTask.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\task\TaskScheduler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\TextXMLReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\TZXPathContext$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\TZXPathContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\URLFinder$$anonfun$findURLs$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\URLFinder$$anonfun$replaceURLs$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\URLFinder$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\URLFinder.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\URLRewriterUtils$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\URLRewriterUtils$PathMatcher.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\URLRewriterUtils.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\UserAgent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$$anonfun$baseMatchers$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$$anonfun$defaultPolicy$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$$anonfun$defaultPolicy$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$$anonfun$newMatchers$1$1$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$$anonfun$newMatchers$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$$anonfun$org$orbeon$oxf$util$Whitespace$$matchersForPolicy$1$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$$anonfun$org$orbeon$oxf$util$Whitespace$$matchersForPolicy$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$$anonfun$org$orbeon$oxf$util$Whitespace$$matchersForPolicy$1$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$$anonfun$policyMatcherFromProperties$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$$anonfun$whitespacePolicyAssociateIfPossible$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$$anonfun$whitespacePolicyAssociateIfPossible$1$2$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$$anonfun$whitespacePolicyAssociateIfPossible$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$$anonfun$whitespacePropertyDontAssociate$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$AnyElementChildOfMatcher$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$AnyElementChildOfMatcher.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$Collapse$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$ElementAttributeValueMatcher$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$ElementAttributeValueMatcher.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$ElementMatcher$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$ElementMatcher.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$Matcher.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$Normalize$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$Policy.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$PolicyMatcherImpl$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$PolicyMatcherImpl$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$PolicyMatcherImpl$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$PolicyMatcherImpl$$anonfun$fromCurrentElement$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$PolicyMatcherImpl$$anonfun$org$orbeon$oxf$util$Whitespace$PolicyMatcherImpl$$fromParentElement$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$PolicyMatcherImpl$$anonfun$org$orbeon$oxf$util$Whitespace$PolicyMatcherImpl$$fromParentElement$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$PolicyMatcherImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace$Preserve$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\Whitespace.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\WriterOutputStream.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XLSUtils$Handler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XLSUtils.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPath$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPath$$anon$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPath$$anon$5$$anon$3$$anonfun$convert$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPath$$anon$5$$anon$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPath$$anon$5$$anon$4$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPath$$anon$5$$anon$4$$anonfun$convert$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPath$$anon$5$$anon$4$$anonfun$convert$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPath$$anon$5$$anon$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPath$$anon$5$$anonfun$getJPConverter$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPath$$anon$5$$anonfun$getPJConverter$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPath$$anon$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPath$$anon$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPath$$anon$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPath$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPath$$anonfun$evaluateAsString$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPath$$anonfun$evaluateSingle$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPath$$anonfun$evaluateSingle$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPath$$anonfun$isXPath2Expression$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPath$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPath$CompiledExpression$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPath$CompiledExpression.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPath$FunctionContext.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPath.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPathCache$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPathCache$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPathCache$$anonfun$configurationOrDefault$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPathCache$$anonfun$evaluate$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPathCache$$anonfun$evaluateAsAvt$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPathCache$$anonfun$evaluateAsAvt$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPathCache$$anonfun$evaluateAsExtent$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPathCache$$anonfun$evaluateAsString$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPathCache$$anonfun$evaluateAsString$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPathCache$$anonfun$evaluateKeepItems$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPathCache$$anonfun$evaluateSingle$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPathCache$$anonfun$evaluateSingleKeepItems$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPathCache$$anonfun$getXPathExpression$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPathCache$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPathCache$XPathCachePoolableObjectFactory$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPathCache$XPathCachePoolableObjectFactory$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPathCache$XPathCachePoolableObjectFactory$$anonfun$makeObject$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPathCache$XPathCachePoolableObjectFactory$$anonfun$makeObject$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPathCache$XPathCachePoolableObjectFactory.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPathCache$XPathContext$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPathCache$XPathContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\util\XPathCache.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\HttpRedirectException$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\HttpRedirectException.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\HttpStatusCode.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\HttpStatusCodeException$$anonfun$toString$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\HttpStatusCodeException$$anonfun$toString$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\HttpStatusCodeException$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\HttpStatusCodeException.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\Orbeon$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\Orbeon$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\Orbeon$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\Orbeon.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\OrbeonServletContextListener$$anonfun$contextDestroyed$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\OrbeonServletContextListener$$anonfun$contextDestroyed$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\OrbeonServletContextListener$$anonfun$contextInitialized$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\OrbeonServletContextListener$$anonfun$contextInitialized$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\OrbeonServletContextListener.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\OrbeonServletContextListenerDelegate.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\OrbeonSessionListener$$anonfun$sessionCreated$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\OrbeonSessionListener$$anonfun$sessionCreated$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\OrbeonSessionListener$$anonfun$sessionDestroyed$1$$anonfun$apply$mcV$sp$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\OrbeonSessionListener$$anonfun$sessionDestroyed$1$$anonfun$apply$mcV$sp$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\OrbeonSessionListener$$anonfun$sessionDestroyed$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\OrbeonSessionListener$$anonfun$sessionDestroyed$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\OrbeonSessionListener.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\OrbeonSessionListenerDelegate.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\OrbeonWebApp$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\OrbeonWebApp$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\OrbeonWebApp.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\ParametersAndAttributes$$anon$1$$anonfun$iterator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\ParametersAndAttributes$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\ParametersAndAttributes$$anonfun$initParameters$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\ParametersAndAttributes$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\ParametersAndAttributes.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\PortletWebAppContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\ProcessorService$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\ProcessorService$$anonfun$service$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\ProcessorService$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\ProcessorService.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\RunMode$$anonfun$getRunMode$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\RunMode$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\RunMode.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\ServletPortlet$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\ServletPortlet$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\ServletPortlet$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\ServletPortlet$$anonfun$destroy$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\ServletPortlet$$anonfun$destroy$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\ServletPortlet$$anonfun$init$1$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\ServletPortlet$$anonfun$init$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\ServletPortlet$$anonfun$org$orbeon$oxf$webapp$ServletPortlet$$runInitDestroyListenerProcessor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\ServletPortlet$$anonfun$searchDefinition$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\ServletPortlet$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\ServletPortlet.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\ServletWebAppContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\SessionExpiredException$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\SessionExpiredException.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\TestWebAppContext$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\TestWebAppContext.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\WebAppContext$$anonfun$addListener$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\WebAppContext$$anonfun$removeListener$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\WebAppContext$$anonfun$webAppDestroyed$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\WebAppContext$$anonfun$webAppDestroyed$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\WebAppContext$$anonfun$webAppListenersOption$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\WebAppContext$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\WebAppContext$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\WebAppContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\WebAppExternalContext$$anonfun$session$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\WebAppExternalContext$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\WebAppExternalContext$SessionImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\WebAppExternalContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\WebAppListener.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\WebAppListeners$$anonfun$removeListener$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\webapp\WebAppListeners.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\RRRAction$$anonfun$resolve$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\RRRAction$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\RRRAction$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\RRRAction$ConcreteRebuildFunctions$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\RRRAction$ConcreteRecalculateFunctions$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\RRRAction$ConcreteRevalidateFunctions$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\RRRAction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\RRRFunctions.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsActionAction$$anonfun$execute$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsActionAction$$anonfun$execute$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsActionAction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsDeleteAction$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsDeleteAction$DeleteInfo.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsDeleteAction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsDispatchAction$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsDispatchAction$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsDispatchAction$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsDispatchAction$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsDispatchAction$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsDispatchAction$$anonfun$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsDispatchAction$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsDispatchAction$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsDispatchAction$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsDispatchAction$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsDispatchAction.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsInsertAction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsLoadAction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsMessageAction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsRebuildAction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsRebuildFunctions$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsRebuildFunctions.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsRecalculateAction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsRecalculateFunctions$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsRecalculateFunctions.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsRefreshAction$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsRefreshAction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsResetAction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsRevalidateAction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsRevalidateFunctions$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsRevalidateFunctions.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsSendAction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsSetfocusAction$$anonfun$execute$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsSetfocusAction$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsSetfocusAction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsSetindexAction$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsSetindexAction$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsSetindexAction$$anonfun$executeSetindexAction$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsSetindexAction$$anonfun$executeSetindexAction$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsSetindexAction$$anonfun$executeSetindexAction$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsSetindexAction$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsSetindexAction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsSetvalueAction$$anonfun$execute$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsSetvalueAction$$anonfun$execute$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsSetvalueAction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsToggleAction$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XFormsToggleAction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XXFormsHideAction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XXFormsInvalidateInstanceAction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XXFormsInvalidateInstancesAction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XXFormsJoinSubmissions.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XXFormsScriptAction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XXFormsSetvisitedAction$$anonfun$execute$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XXFormsSetvisitedAction$$anonfun$execute$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XXFormsSetvisitedAction$$anonfun$org$orbeon$oxf$xforms$action$actions$XXFormsSetvisitedAction$$applyToVisitable$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XXFormsSetvisitedAction.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XXFormsShowAction$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XXFormsShowAction$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\actions\XXFormsShowAction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\DynamicActionContext$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\DynamicActionContext.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAction$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAction$$anonfun$2$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAction$$anonfun$2$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAction$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAction$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAction$$anonfun$resolveBooleanAVT$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAction$$anonfun$resolveBooleanAVT$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAction$$anonfun$resolveControl$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAction$$anonfun$resolveControl$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAction$$anonfun$resolveStringAVT$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAction$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsActionInterpreter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsActions$$anonfun$1$$anonfun$applyOrElse$1$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsActions$$anonfun$1$$anonfun$applyOrElse$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsActions$$anonfun$1$$anonfun$applyOrElse$2$$anon$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsActions$$anonfun$1$$anonfun$applyOrElse$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsActions$$anonfun$1$$anonfun$applyOrElse$3$$anon$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsActions$$anonfun$1$$anonfun$applyOrElse$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsActions$$anonfun$1$$anonfun$applyOrElse$4$$anon$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsActions$$anonfun$1$$anonfun$applyOrElse$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsActions$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsActions$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsActions.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$5$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$delete$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$insert$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$insert$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$rebuild$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$recalculate$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$refresh$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$resolveAs$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$revalidate$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$send$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$send$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$send$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$sendThrowOnError$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$setfocus$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$setindex$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$setindex$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$setvalue$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$setvalue$1$$anonfun$org$orbeon$oxf$xforms$action$XFormsAPI$$anonfun$$onSuccess$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$setvalue$1$$anonfun$org$orbeon$oxf$xforms$action$XFormsAPI$$anonfun$$onSuccess$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$setvalue$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$show$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$toggle$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$topLevelInstance$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$topLevelModel$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$$anonfun$withContainingDocumentJava$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI$SubmitException.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\action\XFormsAPI.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\AVTLangRef$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\AVTLangRef.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\Bindings$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\Bindings$$anonfun$bindingsIncludesAreUpToDate$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\Bindings$$anonfun$debugOutOfDateBindingsIncludesJava$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\Bindings$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\Bindings.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenActionsAndVariablesTrait$$anonfun$findRelevantChildrenElements$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenActionsAndVariablesTrait$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenActionsAndVariablesTrait.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenActionsTrait$$anonfun$findRelevantChildrenElements$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenActionsTrait$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenActionsTrait.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenBuilderTrait$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenBuilderTrait$$anonfun$2$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenBuilderTrait$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenBuilderTrait$$anonfun$buildChildren$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenBuilderTrait$$anonfun$descendants$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenBuilderTrait$$anonfun$findAllChildrenElements$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenBuilderTrait$$anonfun$indexedElements$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenBuilderTrait$$anonfun$nestedChildrenBuilderTraits$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenBuilderTrait$$anonfun$nestedChildrenBuilderTraits$2$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenBuilderTrait$$anonfun$removeChild$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenBuilderTrait$$anonfun$toXMLContent$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenBuilderTrait$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenBuilderTrait.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenLHHAAndActionsTrait$$anonfun$findRelevantChildrenElements$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenLHHAAndActionsTrait$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenLHHAAndActionsTrait.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenLHHAItemsetsAndActionsTrait$$anonfun$findRelevantChildrenElements$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenLHHAItemsetsAndActionsTrait$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ChildrenLHHAItemsetsAndActionsTrait.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$10$$anon$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$13.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$15.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$16.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$17.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$18.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$19.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$20.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$21.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$22.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$23$$anon$8.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$23.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$24.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$25.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$26.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$27.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$28.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$29$$anon$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$29.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$3$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$30$$anon$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$30.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$31$$anon$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$31.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$32$$anon$10.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$32.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$33.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$34$$anon$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$34.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$35$$anon$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$35.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$36$$anon$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$36.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$6$$anon$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$7$$anon$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$8$$anon$7.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$$anonfun$create$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$GroupControl.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$InputControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$InputValueControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$SecretControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$SelectionControl$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$SelectionControl.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$TextareaControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$TriggerControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$UploadControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory$ValueControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ControlAnalysisFactory.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\ActionTrait$$anonfun$find$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\ActionTrait$$anonfun$find$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\ActionTrait$$anonfun$makeQName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\ActionTrait$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\ActionTrait$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\ActionTrait.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\AppearanceTrait$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\AppearanceTrait$$anonfun$encodeAndAppendAppearances$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\AppearanceTrait$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\AppearanceTrait$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\AppearanceTrait.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\AttributeControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\ComponentControl$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\ComponentControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\ContainerControl.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\CoreControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\FormatTrait$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\FormatTrait.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\LHHA$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\LHHA.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\LHHAAnalysis$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\LHHAAnalysis$$anon$3$$anon$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\LHHAAnalysis$$anon$3$$anonfun$startElement$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\LHHAAnalysis$$anon$3$$anonfun$startElement$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\LHHAAnalysis$$anon$3$$anonfun$startElement$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\LHHAAnalysis$$anon$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\LHHAAnalysis$$anonfun$hasLabelOrHintPlaceholder$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\LHHAAnalysis$$anonfun$hasLHHAPlaceholder$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\LHHAAnalysis$$anonfun$targetControl$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\LHHAAnalysis$$anonfun$targetControl$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\LHHAAnalysis$$anonfun$targetControl$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\LHHAAnalysis$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\LHHAAnalysis.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\OptionalSingleNode$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\OptionalSingleNode.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\OutputControl$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\OutputControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\RepeatControl$$anonfun$iteration$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\RepeatControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\RepeatIterationControl.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\RequiredSingleNode$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\RequiredSingleNode.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\RootControl$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\RootControl$$anonfun$findRelevantChildrenElements$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\RootControl$$anonfun$fromChildElements$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\RootControl$$anonfun$lang$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\RootControl$$anonfun$org$orbeon$oxf$xforms$analysis$controls$RootControl$$fromParentPart$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\RootControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\SelectAppearanceTrait$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\SelectAppearanceTrait.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\SelectionControlTrait$$anon$2$$anonfun$findNestedLHHValue$1$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\SelectionControlTrait$$anon$2$$anonfun$findNestedLHHValue$1$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\SelectionControlTrait$$anon$2$$anonfun$findNestedLHHValue$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\SelectionControlTrait$$anon$2$$anonfun$startElement$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\SelectionControlTrait$$anon$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\SelectionControlTrait$$anon$3$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\SelectionControlTrait$$anon$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\SelectionControlTrait$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\SelectionControlTrait$$anonfun$staticItemset$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\SelectionControlTrait$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\SelectionControlTrait.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\SelectionControlUtil$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\SelectionControlUtil$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\SelectionControlUtil$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\SelectionControlUtil$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\SelectionControlUtil.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\SingleNodeTrait$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\SingleNodeTrait.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\StaticLHHASupport$$anonfun$analyzeXPath$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\StaticLHHASupport$$anonfun$analyzeXPath$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\StaticLHHASupport$$anonfun$freeTransientState$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\StaticLHHASupport$$anonfun$hasLocal$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\StaticLHHASupport$$anonfun$lhhaValueAnalyses$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\StaticLHHASupport$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\StaticLHHASupport.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\TriggerAppearanceTrait$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\TriggerAppearanceTrait.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\ValueTrait$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\ValueTrait.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\VariableControl.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\ViewTrait$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\controls\ViewTrait.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\DumbXPathDependencies.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementAnalysis$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementAnalysis$$anon$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementAnalysis$$anon$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementAnalysis$$anonfun$attQNameSet$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementAnalysis$$anonfun$extensionAttributes$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementAnalysis$$anonfun$extensionAttributes$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementAnalysis$$anonfun$getAllAncestorsInScope$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementAnalysis$$anonfun$getBindingExpression$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementAnalysis$$anonfun$getClosestAncestorInScope$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementAnalysis$$anonfun$getClosestAncestorInScopeModel$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementAnalysis$$anonfun$lang$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementAnalysis$$anonfun$modelJava$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementAnalysis$$anonfun$nonRelevantExtensionAttributes$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementAnalysis$$anonfun$removeFromParent$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementAnalysis$$anonfun$toXML$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementAnalysis$$anonfun$toXMLAttributes$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementAnalysis$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementAnalysis$IteratorBase.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementAnalysis.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementDetails$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementDetails.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementEventHandlers$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementEventHandlers$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementEventHandlers$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementEventHandlers$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementEventHandlers$$anonfun$handlersForEvent$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementEventHandlers$$anonfun$handlersForPhase$1$1$$anonfun$apply$mcV$sp$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementEventHandlers$$anonfun$handlersForPhase$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementEventHandlers$$anonfun$hasPhantomHandler$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementEventHandlers$$anonfun$observersInAncestorParts$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementEventHandlers$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementEventHandlers.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementRepeats$$anonfun$ancestorRepeatInScope$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementRepeats$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ElementRepeats.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ExtractorProperties$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ExtractorProperties$$anonfun$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ExtractorProperties$$anonfun$3$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ExtractorProperties$$anonfun$3$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ExtractorProperties$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ExtractorProperties$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ExtractorProperties$$anonfun$addPropertiesIfAny$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ExtractorProperties$$anonfun$addPropertiesIfAny$2$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ExtractorProperties$$anonfun$addPropertiesIfAny$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ExtractorProperties$$anonfun$outputNonDefaultProperties$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ExtractorProperties$$anonfun$outputNonDefaultProperties$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ExtractorProperties$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ExtractorProperties.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\HeadState$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\HeadState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\IdGenerator$$anonfun$ids$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\IdGenerator$$anonfun$ids$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\IdGenerator$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\IdGenerator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\InstancePath$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\InstancePath.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\LangRef.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\LHHAState$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\LHHAState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\LiteralLangRef$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\LiteralLangRef.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\Marks$$anonfun$topLevelMarks$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\Marks$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\Marks.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\Metadata$$anonfun$apply$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\Metadata$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\Metadata$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\Metadata.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\BindTree$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\BindTree$$anonfun$allBindVariables$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\BindTree$$anonfun$analyzeBindsXPath$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\BindTree$$anonfun$analyzeBindsXPath$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\BindTree$$anonfun$analyzeBindsXPath$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\BindTree$$anonfun$bindsToXML$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\BindTree$$anonfun$destroy$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\BindTree$$anonfun$freeBindsTransientState$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\BindTree$BindAsVariable.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\BindTree.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Instance$$anonfun$componentForConstantInstances$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Instance$$anonfun$inlineContent$1$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Instance$$anonfun$inlineContent$1$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Instance$$anonfun$inlineContent$1$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Instance$$anonfun$inlineContent$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Instance$$anonfun$inlineContent$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Instance$$anonfun$inlineContent$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Instance$$anonfun$timeToLiveOrDefault$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Instance$$anonfun$timeToLiveOrDefault$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Instance$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Instance.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\InstanceMetadata$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\InstanceMetadata$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\InstanceMetadata$$anonfun$exposeXPathTypes$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\InstanceMetadata$$anonfun$exposeXPathTypes$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\InstanceMetadata$$anonfun$getAttributeEncode$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\InstanceMetadata$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\InstanceMetadata.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$$anonfun$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$$anonfun$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$$anonfun$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$$anonfun$15.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$$anonfun$16.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$$anonfun$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$$anonfun$findRelevantChildrenElements$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$$anonfun$getChildrenContext$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$BooleanMIP.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$Calculate$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$ComputedMIP.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$Constraint$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$Default$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$ExtMIP$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$ExtMIP.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$MIP.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$Readonly$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$Relevant$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$Required$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$StdMIP$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$StdMIP.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$StringMIP.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$Type$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$ValidateMIP.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model$XPathMIP.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Model.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelBinds$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelBinds$$anonfun$org$orbeon$oxf$xforms$analysis$model$ModelBinds$$isCustomMIP$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelBinds$$anonfun$org$orbeon$oxf$xforms$analysis$model$ModelBinds$$isCustomMIP$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelBinds$$anonfun$rebuildBinds$1$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelBinds$$anonfun$rebuildBinds$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelBinds$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelBinds$LazyConstant.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelBinds.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelEventHandlers$$anonfun$eventHandlers$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelEventHandlers$$anonfun$handlersToXML$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelEventHandlers$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelEventHandlers.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelInstances$$anonfun$defaultInstance$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelInstances$$anonfun$defaultInstanceStaticId$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelInstances$$anonfun$instances$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelInstances$$anonfun$outputInstanceList$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelInstances$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelInstances.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelSubmissions$$anonfun$submissions$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelSubmissions$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelSubmissions.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelVariables$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelVariables$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelVariables$$anonfun$8$$anon$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelVariables$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelVariables$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelVariables$$anonfun$analyzeVariablesXPath$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelVariables$$anonfun$freeVariablesTransientState$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelVariables$$anonfun$variablesToXML$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelVariables$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ModelVariables.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$11.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$13$$anonfun$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$15.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$16$$anonfun$apply$9.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$16.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$17.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$18$$anonfun$apply$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$18.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$19$$anonfun$apply$11.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$19.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$20.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$21.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$22.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$7.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$8$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$analyzeMIPs$1$$anonfun$apply$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$analyzeMIPs$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$analyzeMIPs$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$attributeCustomMIP$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$attributeCustomMIP$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$attributeCustomMIP$1$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$elementCustomMIPs$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$elementCustomMIPs$1$2$$anonfun$apply$7.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$elementCustomMIPs$1$2$$anonfun$apply$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$elementCustomMIPs$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$firstXPathMIPOrNull$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$freeTransientState$1$$anonfun$apply$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$freeTransientState$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$freeTransientState$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$fromAttribute$2$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$getXPathMIPs$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$iterateNestedIds$1$$anonfun$apply$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$iterateNestedIds$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$org$orbeon$oxf$xforms$analysis$model$StaticBind$$fromAttribute$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$org$orbeon$oxf$xforms$analysis$model$StaticBind$$fromNestedElement$1$1$$anonfun$apply$5$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$org$orbeon$oxf$xforms$analysis$model$StaticBind$$fromNestedElement$1$1$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$org$orbeon$oxf$xforms$analysis$model$StaticBind$$fromNestedElement$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$org$orbeon$oxf$xforms$analysis$model$StaticBind$$fromNestedElement$2$1$$anonfun$apply$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$org$orbeon$oxf$xforms$analysis$model$StaticBind$$fromNestedElement$2$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$org$orbeon$oxf$xforms$analysis$model$StaticBind$$fromNestedElementLegacy$1$1$$anonfun$apply$3$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$org$orbeon$oxf$xforms$analysis$model$StaticBind$$fromNestedElementLegacy$1$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$org$orbeon$oxf$xforms$analysis$model$StaticBind$$fromNestedElementLegacy$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$org$orbeon$oxf$xforms$analysis$model$StaticBind$$fromNestedElementsLegacy$1$1$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$org$orbeon$oxf$xforms$analysis$model$StaticBind$$fromNestedElementsLegacy$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$removeBind$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$toXMLContent$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$toXMLContent$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$toXMLContent$3$$anonfun$apply$15.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$toXMLContent$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$$anonfun$toXMLContent$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$MIP$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$MIP.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$TypeMIP.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$XPathMIP$$anonfun$analyzeXPath$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$XPathMIP$$anonfun$analyzeXPath$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind$XPathMIP.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\StaticBind.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\Submission.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ThrowawayInstance.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ValidationLevels$$anonfun$23.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ValidationLevels$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ValidationLevels$ErrorLevel$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ValidationLevels$InfoLevel$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ValidationLevels$LevelOrdering$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ValidationLevels$ValidationLevel.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ValidationLevels$WarningLevel$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\model\ValidationLevels.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\NamespaceMappings$$anonfun$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\NamespaceMappings$$anonfun$debugPrintNamespaces$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\NamespaceMappings$$anonfun$debugPrintNamespaces$2$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\NamespaceMappings$$anonfun$debugPrintNamespaces$2$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\NamespaceMappings$$anonfun$debugPrintNamespaces$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\NamespaceMappings$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\NamespaceMappings.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\NegativeAnalysis$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\NegativeAnalysis$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\NegativeAnalysis.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\NewXFormsAnnotator$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\NewXFormsAnnotator$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\NewXFormsAnnotator$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\NewXFormsAnnotator$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\NewXFormsAnnotator$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\NewXFormsAnnotator$$anonfun$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\NewXFormsAnnotator$$anonfun$org$orbeon$oxf$xforms$analysis$NewXFormsAnnotator$$newElementDetail$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\NewXFormsAnnotator$$anonfun$org$orbeon$oxf$xforms$analysis$NewXFormsAnnotator$$newElementDetail$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\NewXFormsAnnotator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$analyze$1$$anonfun$1$$anonfun$apply$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$analyze$1$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$analyze$1$$anonfun$2$$anonfun$apply$4$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$analyze$1$$anonfun$2$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$analyze$1$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$analyze$1$$anonfun$apply$mcV$sp$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$analyze$1$$anonfun$apply$mcV$sp$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$analyze$1$$anonfun$apply$mcV$sp$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$analyze$1$$anonfun$apply$mcV$sp$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$analyze$1$$anonfun$apply$mcV$sp$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$analyze$1$$anonfun$apply$mcV$sp$9.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$analyze$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$analyze$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$analyze$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$analyzeSubtree$1$$anonfun$apply$mcV$sp$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$analyzeSubtree$1$$anonfun$apply$mcV$sp$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$analyzeSubtree$1$$anonfun$apply$mcV$sp$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$analyzeSubtree$1$$anonfun$apply$mcV$sp$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$analyzeSubtree$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$analyzeSubtree$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$analyzeSubtree$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$extractNestedModels$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$extractNestedModels$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$$anonfun$getNamespaceMapping$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartAnalysisImpl.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$5$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$5$$anonfun$apply$2$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$5$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$analyzeControlsXPath$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$analyzeCustomControls$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$analyzeCustomControls$2$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$analyzeCustomControls$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$controlElement$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$controlsByName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$deindexControl$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$deindexTree$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$deindexTree$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$freeTransientState$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$getAttributeControl$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$getRepeatHierarchyString$1$$anonfun$7.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$getRepeatHierarchyString$1$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$getRepeatHierarchyString$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$getRepeatHierarchyString$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$getTopLevelControlElements$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$hasControlAppearance$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$hasControlByName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$repeats$1$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$repeats$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$$anonfun$repeats$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$AttributeDetails$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$AttributeDetails$4$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartControlsAnalysis.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis$$anonfun$10.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis$$anonfun$2$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis$$anonfun$4$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis$$anonfun$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis$$anonfun$deregisterEventHandler$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis$$anonfun$deregisterEventHandler$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis$$anonfun$getEventHandlers$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis$$anonfun$observerHasHandlerForEvent$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis$$anonfun$observerHasHandlerForEvent$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis$$anonfun$registerEventHandlers$1$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis$$anonfun$registerEventHandlers$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis$$anonfun$registerEventHandlers$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis$$anonfun$registerEventHandlers$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis$$anonfun$registerEventHandlers$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis$$anonfun$registerEventHandlers$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartEventHandlerAnalysis.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartModelAnalysis$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartModelAnalysis$$anonfun$analyzeModelsXPath$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartModelAnalysis$$anonfun$analyzeModelsXPath$2$$anonfun$apply$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartModelAnalysis$$anonfun$analyzeModelsXPath$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartModelAnalysis$$anonfun$deindexModel$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartModelAnalysis$$anonfun$deindexModel$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartModelAnalysis$$anonfun$findInstancePrefixedId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartModelAnalysis$$anonfun$freeTransientState$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartModelAnalysis$$anonfun$getDefaultModelForScope$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartModelAnalysis$$anonfun$getInstances$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartModelAnalysis$$anonfun$getModelByScopeAndBind$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartModelAnalysis$$anonfun$getModelByScopeAndBind$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartModelAnalysis$$anonfun$getModelsForScope$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartModelAnalysis$$anonfun$indexModel$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartModelAnalysis$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartModelAnalysis.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartXBLAnalysis$$anonfun$initializeScopes$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartXBLAnalysis$$anonfun$initializeScopes$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartXBLAnalysis$$anonfun$searchResolutionScopeByPrefixedId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartXBLAnalysis$$anonfun$searchResolutionScopeByPrefixedId$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartXBLAnalysis$$anonfun$unmapScopeIds$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartXBLAnalysis$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PartXBLAnalysis.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathAnalysis$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathAnalysis$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathAnalysis$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathAnalysis$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathAnalysis$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathAnalysis$$anonfun$buildPath$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathAnalysis$$anonfun$getDisplayPath$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathAnalysis$$anonfun$getInternalPath$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathAnalysis$$anonfun$mapSetToSet$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathAnalysis$$anonfun$org$orbeon$oxf$xforms$analysis$PathMapXPathAnalysis$$ancestorsWithFingerprint$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathAnalysis$$anonfun$org$orbeon$oxf$xforms$analysis$PathMapXPathAnalysis$$ancestorsWithFingerprint$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathAnalysis$$anonfun$org$orbeon$oxf$xforms$analysis$PathMapXPathAnalysis$$ancestorsWithFingerprint$1$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathAnalysis$$anonfun$org$orbeon$oxf$xforms$analysis$PathMapXPathAnalysis$$getArcs$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathAnalysis$$anonfun$org$orbeon$oxf$xforms$analysis$PathMapXPathAnalysis$$processNode$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathAnalysis$$anonfun$org$orbeon$oxf$xforms$analysis$PathMapXPathAnalysis$$reduceAncestorAxis$1$1$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathAnalysis$$anonfun$org$orbeon$oxf$xforms$analysis$PathMapXPathAnalysis$$reduceAncestorAxis$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathAnalysis$$anonfun$processPaths$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathAnalysis$$anonfun$reduceAncestorAxis$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathAnalysis$$anonfun$toXML$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathAnalysis$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathAnalysis$NodeArc$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathAnalysis$PrefixedIdStringLiteral$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathAnalysis.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathDependencies$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathDependencies$$anonfun$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathDependencies$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathDependencies$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathDependencies$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathDependencies$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathDependencies$$anonfun$7.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathDependencies$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathDependencies$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathDependencies$$anonfun$dependsOnOtherModel$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathDependencies$$anonfun$getModelState$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathDependencies$$anonfun$org$orbeon$oxf$xforms$analysis$PathMapXPathDependencies$$createFingerprintedPath$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathDependencies$$anonfun$org$orbeon$oxf$xforms$analysis$PathMapXPathDependencies$$requireUpdate$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathDependencies$$anonfun$refreshDone$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathDependencies$$anonfun$requireItemsetUpdate$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathDependencies$$anonfun$requireLHHAUpdate$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathDependencies$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathDependencies$ModelState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathDependencies$RefreshState$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathDependencies$UpdateResult$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathDependencies$UpdateResult.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PathMapXPathDependencies.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PreserveState$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\PreserveState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\RootState$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\RootState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ScopeModel$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ScopeModel.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ShadowChildrenBuilder$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ShadowChildrenBuilder$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ShadowChildrenBuilder$$anonfun$directlyNestedHandlers$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ShadowChildrenBuilder$$anonfun$directlyNestedHandlers$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ShadowChildrenBuilder$$anonfun$directlyNestedLHHA$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ShadowChildrenBuilder$$anonfun$directlyNestedLHHA$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ShadowChildrenBuilder$$anonfun$findRelevantChildrenElements$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ShadowChildrenBuilder$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\ShadowChildrenBuilder.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\SimpleElementAnalysis$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\SimpleElementAnalysis$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\SimpleElementAnalysis$$anonfun$computeBindingAnalysis$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\SimpleElementAnalysis$SimplePathMapContext$$anonfun$getInScopeContexts$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\SimpleElementAnalysis$SimplePathMapContext.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\SimpleElementAnalysis.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\State.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\StaticStateContext$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\StaticStateContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\StringAnalysis$$anon$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\StringAnalysis$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\StringAnalysis.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\TitleState$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\TitleState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\TransientState$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\TransientState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\VariableAnalysis$$anonfun$valueOrSelectAttribute$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\VariableAnalysis$$anonfun$valueOrSequenceElement$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\VariableAnalysis$$anonfun$variableScopesModelVariables$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\VariableAnalysis$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\VariableAnalysis.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\VariableAnalysisTrait$$anonfun$org$orbeon$oxf$xforms$analysis$VariableAnalysisTrait$$nestedAnalysis$1$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\VariableAnalysisTrait$$anonfun$org$orbeon$oxf$xforms$analysis$VariableAnalysisTrait$$nestedAnalysis$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\VariableAnalysisTrait$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\VariableAnalysisTrait.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\VariableTrait.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\XFormsAnnotator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\XFormsAnnotatorBase$$anonfun$doesClosestXHTMLRequireSeparatorAppearance$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\XFormsAnnotatorBase$$anonfun$doesClosestXHTMLRequireSeparatorAppearance$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\XFormsAnnotatorBase$StackElement$$anonfun$ancestors$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\XFormsAnnotatorBase$StackElement$$anonfun$ancestors$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\XFormsAnnotatorBase$StackElement$$anonfun$endElement$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\XFormsAnnotatorBase$StackElement$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\XFormsAnnotatorBase$StackElement.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\XFormsAnnotatorBase.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\XFormsExtractor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\XFormsExtractor$XMLElementDetails.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\XFormsExtractor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\XFormsExtractorBase.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\XFormsState$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\XFormsState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\XPathAnalysis$$anonfun$intersectsModels$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\XPathAnalysis$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\XPathAnalysis$ConstantXPathAnalysis.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\XPathAnalysis.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analysis\XPathDependencies.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analytics\NOPRequestStats$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analytics\NOPRequestStats.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analytics\RequestStats$$anonfun$getReporter$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analytics\RequestStats$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analytics\RequestStats.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analytics\RequestStatsImpl$$anonfun$addXPathStat$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analytics\RequestStatsImpl$$anonfun$afterUpdateResponse$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analytics\RequestStatsImpl$$anonfun$afterUpdateResponse$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analytics\RequestStatsImpl$$anonfun$afterUpdateResponse$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analytics\RequestStatsImpl$$anonfun$afterUpdateResponse$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analytics\RequestStatsImpl$$anonfun$afterUpdateResponse$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analytics\RequestStatsImpl$$anonfun$afterUpdateResponse$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analytics\RequestStatsImpl$$anonfun$afterUpdateResponse$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analytics\RequestStatsImpl$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analytics\RequestStatsImpl$XPathStats.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\analytics\RequestStatsImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindingContext$$anonfun$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindingContext$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindingContext$$anonfun$ancestorOrSelfInScope$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindingContext$$anonfun$ancestorOrSelfInScope$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindingContext$$anonfun$contextForId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindingContext$$anonfun$contextForId$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindingContext$$anonfun$currentBindingContextForModel$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindingContext$$anonfun$enclosingRepeatId$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindingContext$$anonfun$enclosingRepeatId$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindingContext$$anonfun$enclosingRepeatIterationBindingContext$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindingContext$$anonfun$enclosingRepeatIterationBindingContext$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindingContext$$anonfun$getInScopeVariables$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindingContext$$anonfun$getInScopeVariables$2$$anonfun$apply$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindingContext$$anonfun$getInScopeVariables$2$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindingContext$$anonfun$getInScopeVariables$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindingContext$$anonfun$getInScopeVariables$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindingContext$$anonfun$getInScopeVariables$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindingContext$$anonfun$instanceOrNull$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindingContext$$anonfun$repeatItems$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindingContext$$anonfun$repeatItems$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindingContext$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindingContext$AncestorIterator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindingContext.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$$anonfun$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$$anonfun$findAncestorOrSelfWithName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$$anonfun$findConcreteAncestorOrSelfIteration$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$$anonfun$findStaticAncestry$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$$anonfun$hasAncestorIteration$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$$anonfun$org$orbeon$oxf$xforms$BindVariableResolver$$nextNodes$1$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$$anonfun$org$orbeon$oxf$xforms$BindVariableResolver$$nextNodes$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$$anonfun$resolveAncestorOrSelf$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$$anonfun$resolveAncestorOrSelf$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$$anonfun$resolveClosestBind$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$$anonfun$resolveNotAncestorOrSelf$1$$anonfun$2$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$$anonfun$resolveNotAncestorOrSelf$1$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$$anonfun$resolveNotAncestorOrSelf$1$$anonfun$apply$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$$anonfun$resolveNotAncestorOrSelf$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$$anonfun$resolveSingle$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$$anonfun$resolveSingle$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\BindVariableResolver.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\Caches$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\Caches.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentLogging$$anonfun$getIndentedLogger$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentLogging$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentLogging.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentProperties$$anonfun$encodeItemValues$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentProperties$$anonfun$getForwardSubmissionHeaders$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentProperties$$anonfun$getTypeOutputFormat$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentProperties$$anonfun$hostLanguage$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentProperties$$anonfun$isClientStateHandling$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentProperties$$anonfun$isNoUpdates$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentProperties$$anonfun$isReadonlyAppearanceStaticSelect1Full$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentProperties$$anonfun$isReadonlyAppearanceStaticSelectFull$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentProperties$$anonfun$lhhacOrder$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentProperties$$anonfun$noscript$1$$anonfun$apply$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentProperties$$anonfun$noscript$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentProperties$$anonfun$staticReadonly$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentProperties$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentProperties$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentProperties$Memo$$anonfun$dynamicProperty$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentProperties$Memo$$anonfun$staticBooleanProperty$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentProperties$Memo$$anonfun$staticBooleanProperty$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentProperties$Memo$$anonfun$staticIntProperty$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentProperties$Memo$$anonfun$staticStringProperty$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentProperties$Memo$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentProperties.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentRequest$$anonfun$initializePathMatchers$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentRequest$$anonfun$initializeRequestInformation$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentRequest$$anonfun$initializeRequestInformation$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentRequest$$anonfun$initializeRequestInformation$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentRequest$$anonfun$initializeRequestInformation$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentRequest$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentRequest.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentRequestStats$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentRequestStats.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentTemplate$$anonfun$setTemplateIfNeeded$1$$anonfun$apply$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentTemplate$$anonfun$setTemplateIfNeeded$1$$anonfun$apply$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentTemplate$$anonfun$setTemplateIfNeeded$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentTemplate$$anonfun$setTemplateIfNeeded$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentTemplate$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ContainingDocumentTemplate.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\AjaxSupport$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\AjaxSupport$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\AjaxSupport$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\AjaxSupport$$anonfun$8.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\AjaxSupport$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\AjaxSupport$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\AjaxSupport.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlAjaxSupport$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlAjaxSupport$$anonfun$addAjaxAttributes$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlAjaxSupport$$anonfun$addAjaxExtensionAttributes$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlAjaxSupport$$anonfun$addAjaxExtensionAttributes$2$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlAjaxSupport$$anonfun$addAjaxExtensionAttributes$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlAjaxSupport$$anonfun$addAjaxExtensionAttributes$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlAjaxSupport$$anonfun$addAjaxExtensionAttributes$4$$anonfun$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlAjaxSupport$$anonfun$addAjaxExtensionAttributes$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlAjaxSupport$$anonfun$addAjaxExtensionAttributes$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlAjaxSupport$$anonfun$addAjaxLHHA$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlAjaxSupport$$anonfun$addAjaxLHHA$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlAjaxSupport$$anonfun$addAjaxLHHA$3$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlAjaxSupport$$anonfun$addAjaxLHHA$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlAjaxSupport$$anonfun$addAjaxLHHA$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlAjaxSupport$$anonfun$writeMIPsAsAttributes$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlAjaxSupport$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlAjaxSupport.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlBindingSupport$$anonfun$contextForBinding$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlBindingSupport$$anonfun$contextForBinding$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlBindingSupport$$anonfun$contextForBinding$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlBindingSupport$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlBindingSupport.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlEventSupport$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlEventSupport$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlEventSupport$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlEventSupport$$anonfun$performDefaultAction$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlEventSupport$$anonfun$performDefaultAction$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlEventSupport$$anonfun$performDefaultAction$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlEventSupport$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlEventSupport.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlExtensionAttributesSupport$$anonfun$addExtensionAttributesExceptClassAndAcceptForAjax$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlExtensionAttributesSupport$$anonfun$addExtensionAttributesExceptClassAndAcceptForAjax$2$$anonfun$apply$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlExtensionAttributesSupport$$anonfun$addExtensionAttributesExceptClassAndAcceptForAjax$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlExtensionAttributesSupport$$anonfun$addExtensionAttributesExceptClassAndAcceptForHandler$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlExtensionAttributesSupport$$anonfun$addExtensionAttributesExceptClassAndAcceptForHandler$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlExtensionAttributesSupport$$anonfun$addExtensionAttributesExceptClassAndAcceptForHandler$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlExtensionAttributesSupport$$anonfun$addExtensionAttributesExceptClassAndAcceptForHandler$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlExtensionAttributesSupport$$anonfun$addExtensionAttributesExceptClassAndAcceptForHandler$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlExtensionAttributesSupport$$anonfun$evaluatedExtensionAttributes$1$$anonfun$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlExtensionAttributesSupport$$anonfun$evaluatedExtensionAttributes$1$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlExtensionAttributesSupport$$anonfun$evaluatedExtensionAttributes$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlExtensionAttributesSupport$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlExtensionAttributesSupport$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlExtensionAttributesSupport.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlLHHASupport$$anonfun$compareLHHA$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlLHHASupport$$anonfun$evaluateNonRelevantLHHA$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlLHHASupport$$anonfun$lhhaProperty$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlLHHASupport$$anonfun$markLHHADirty$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlLHHASupport$$anonfun$updateLHHACopy$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlLHHASupport$$anonfun$updateLHHACopy$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlLHHASupport$$anonfun$updateLHHACopy$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlLHHASupport$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlLHHASupport.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlLocalSupport$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlLocalSupport$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlLocalSupport$XFormsControlLocal.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlLocalSupport.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$10$$anonfun$apply$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$10$$anonfun$apply$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$5$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$6$$anonfun$apply$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$7$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$8$$anonfun$apply$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$8.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$9$$anonfun$apply$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$addFileMetadataAttributes$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$addFileMetadataAttributes$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$addFileMetadataAttributes$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$compareFileMetadata$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$evaluateFileMetadata$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$humanReadableFileSize$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$humanReadableFileSize$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$iterateProperties$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$markFileMetadataDirty$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$progress$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$setInfoValue$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$setInfoValue$1$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$setInfoValue$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$$anonfun$updateFileMetadataCopy$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$Evaluator$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$Evaluator.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata$FileMetadataProperty.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\FileMetadata.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$$anonfun$addListener$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$$anonfun$findOuterInstanceDetailsDynamic$1$$anonfun$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$$anonfun$findOuterInstanceDetailsDynamic$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$$anonfun$findOuterInstanceDetailsXBL$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$$anonfun$mirrorListener$1$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$$anonfun$mirrorListener$1$$anonfun$3$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$$anonfun$mirrorListener$1$$anonfun$3$$anonfun$apply$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$$anonfun$mirrorListener$1$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$$anonfun$mirrorListener$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$$anonfun$mirrorListener$1$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$$anonfun$mirrorListener$1$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$$anonfun$mirrorListener$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$$anonfun$removeListener$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$$anonfun$toInnerInstanceNode$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$$anonfun$toInnerInstanceNode$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$$anonfun$toOuterInstanceNodeDynamic$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$$anonfun$toOuterInstanceNodeXBL$1$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$$anonfun$toOuterInstanceNodeXBL$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$InstanceDetails$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$InstanceDetails.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$ListenerCycleDetector$$anonfun$wrap$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror$ListenerCycleDetector.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\InstanceMirror.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\MutableItemsetProperty.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsActionControl$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsActionControl.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsCaseControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsGroupControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$$anon$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$$anon$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$$anon$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$$anon$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$$anon$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$$anon$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$$anon$8.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$$anon$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$$anonfun$format$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$$anonfun$getFirstValueUseFormat$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$$anonfun$getJavaScriptInitialization$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$$anonfun$getReadonlyValue$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$$anonfun$getSecondValueUseFormat$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$$anonfun$org$orbeon$oxf$xforms$control$controls$XFormsInputControl$$parseForNoscript$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$$anonfun$translateExternalValue$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$$anonfun$unformat$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$$anonfun$unformatTransform$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$ParsePattern.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$PlaceHolderInfo$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl$PlaceHolderInfo.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsInputControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsOutputControl$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsOutputControl$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsOutputControl$$anonfun$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsOutputControl$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsOutputControl$$anonfun$evaluateValue$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsOutputControl$$anonfun$format$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsOutputControl$$anonfun$getNonRelevantEscapedExternalValue$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsOutputControl$$anonfun$getRelevantEscapedExternalValue$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsOutputControl$$anonfun$getRelevantEscapedExternalValue$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsOutputControl$$anonfun$proxyValueIfNeeded$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsOutputControl$$anonfun$proxyValueIfNeeded$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsOutputControl$$anonfun$proxyValueIfNeeded$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsOutputControl$$anonfun$proxyValueIfNeeded$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsOutputControl$$anonfun$proxyValueIfNeeded$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsOutputControl$$anonfun$proxyValueIfNeeded$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsOutputControl$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsOutputControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRangeControl.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$13.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$14$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$14$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$14$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$14$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$14$$anonfun$apply$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$15$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$15$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$15$$anonfun$apply$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$15.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$16.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$17.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$18.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$19.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$2$$anonfun$apply$mcVI$sp$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$2$$anonfun$apply$mcVI$sp$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$2$$anonfun$apply$mcVI$sp$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$20.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$4$$anonfun$apply$mcZI$sp$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$4$$anonfun$apply$mcZI$sp$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$binding$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$binding$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$binding$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$buildChildren$1$$anonfun$apply$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$buildChildren$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$buildChildren$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$currentIndexes$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$findAllRepeatedControls$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$findIndexes$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$findNodeIndexes$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$getSize$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$getSize$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$initialIndexesJava$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$org$orbeon$oxf$xforms$control$controls$XFormsRepeatControl$$indexOfItem$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$org$orbeon$oxf$xforms$control$controls$XFormsRepeatControl$$search$1$1$$anonfun$apply$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$org$orbeon$oxf$xforms$control$controls$XFormsRepeatControl$$search$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$org$orbeon$oxf$xforms$control$controls$XFormsRepeatControl$$suffixForRepeats$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$$anonfun$updateSequenceForInsertDelete$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$RefreshInfo$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$RefreshInfo.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$XFormsRepeatControlLocal$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl$XFormsRepeatControlLocal.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatIterationControl$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatIterationControl$$anonfun$updateEffectiveId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsRepeatIterationControl.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSecretControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelect1Control$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelect1Control$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelect1Control$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelect1Control$$anonfun$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelect1Control$$anonfun$gatherEvents$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelect1Control$$anonfun$getGroupName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelect1Control$$anonfun$getItemset$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelect1Control$$anonfun$mustEncodeValues$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelect1Control$$anonfun$translateExternalValue$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelect1Control$$anonfun$translateExternalValue$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelect1Control$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelect1Control.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelectControl$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelectControl$$anonfun$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelectControl$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelectControl$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelectControl$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelectControl$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelectControl$$anonfun$7.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelectControl$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelectControl$$anonfun$translateExternalValue$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelectControl$$anonfun$translateExternalValue$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelectControl$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSelectControl.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSubmitControl$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSubmitControl$$anonfun$performDefaultAction$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSubmitControl$$anonfun$performDefaultAction$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSubmitControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSwitchControl$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSwitchControl$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSwitchControl$$anonfun$findDefaultSelectedCaseId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSwitchControl$$anonfun$findDefaultSelectedCaseId$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSwitchControl$$anonfun$findDefaultSelectedCaseId$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSwitchControl$$anonfun$focusableControls$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSwitchControl$$anonfun$getChildrenCases$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSwitchControl$$anonfun$getSelectedCaseEffectiveId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSwitchControl$$anonfun$org$orbeon$oxf$xforms$control$controls$XFormsSwitchControl$$isDefaultSelected$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSwitchControl$$anonfun$outputAjaxDiff$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSwitchControl$$anonfun$outputAjaxDiff$2$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSwitchControl$$anonfun$outputAjaxDiff$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSwitchControl$$anonfun$selectedCase$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSwitchControl$$anonfun$setSelectedCase$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSwitchControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSwitchControlLocal$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsSwitchControlLocal.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsTextareaControl$$anonfun$sanitizeForMediatype$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsTextareaControl$$anonfun$sanitizeForMediatype$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsTextareaControl$$anonfun$sanitizeForMediatype$1$3$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsTextareaControl$$anonfun$sanitizeForMediatype$1$3$$anonfun$apply$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsTextareaControl$$anonfun$sanitizeForMediatype$1$3$$anonfun$cleanWithTagSoup$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsTextareaControl$$anonfun$sanitizeForMediatype$1$3$$anonfun$cleanWithTagSoup$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsTextareaControl$$anonfun$sanitizeForMediatype$1$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsTextareaControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsTriggerControl$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsTriggerControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$$anonfun$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$$anonfun$acceptValue$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$$anonfun$deleteFileIfPossible$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$$anonfun$deleteFileIfPossible$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$$anonfun$deleteFileIfPossible$1$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$$anonfun$deleteFileIfPossible$1$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$$anonfun$deleteFileIfPossible$1$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$$anonfun$deleteFileIfPossible$1$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$$anonfun$handleSubmittedFiles$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$$anonfun$handleSubmittedFiles$2$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$$anonfun$handleSubmittedFiles$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$$anonfun$iterateFileElement$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$$anonfun$iterateFileElement$2$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$$anonfun$iterateFileElement$2$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$$anonfun$iterateFileElement$2$$anonfun$8.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$$anonfun$iterateFileElement$2$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$$anonfun$iterateFileElement$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$$anonfun$iterateFileElement$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$$anonfun$iterateFileElement$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsUploadControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsVariableControl$$anonfun$evaluateImpl$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsVariableControl$$anonfun$evaluateImpl$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XFormsVariableControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XMLCleaner.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsAttributeControl$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsAttributeControl$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsAttributeControl$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsAttributeControl$$anonfun$evaluateValue$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsAttributeControl$$anonfun$getExternalValueHandleSrc$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsAttributeControl$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsAttributeControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsComponentRootControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDialogControl$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDialogControl$XXFormsDialogControlLocal.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDialogControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$12.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$13$$anonfun$apply$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$8$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$8.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$bindingContextForChild$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$changeListener$1$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$changeListener$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$composeListeners$1$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$composeListeners$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$findBindChange$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$groupChanges$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$groupChanges$2$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$groupChanges$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$org$orbeon$oxf$xforms$control$controls$XXFormsDynamicControl$$gatherRelevantSwitchState$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$processBindsUpdates$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$processBindsUpdates$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$processFullUpdate$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$processFullUpdate$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$processFullUpdate$3$$anonfun$apply$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$processFullUpdate$3$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$processFullUpdate$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$processXBLUpdates$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$processXBLUpdates$2$$anonfun$apply$1$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$processXBLUpdates$2$$anonfun$apply$1$$anonfun$apply$mcV$sp$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$processXBLUpdates$2$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$$anonfun$processXBLUpdates$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$Nested$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl$Nested.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsDynamicControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsRootControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\controls\XXFormsTextControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$buildChildren$1$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$buildChildren$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$createSubTree$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$createTree$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$findEffectiveControlId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$findEffectiveControlId$2$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$findEffectiveControlId$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$findEffectiveControlId$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$findRepeatedControlsForTarget$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$isRestoringDynamicState$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$org$orbeon$oxf$xforms$control$Controls$$buildTree$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$org$orbeon$oxf$xforms$control$Controls$$buildTree$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$org$orbeon$oxf$xforms$control$Controls$$buildTree$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$org$orbeon$oxf$xforms$control$Controls$$visitSiblings$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$resolveObjectById$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$restoringControls$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$restoringInstanceControls$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$restoringInstancesJava$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$updateBindings$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$updateBindings$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$$anonfun$withDynamicStateToRestoreJava$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$AncestorOrSelfIterator.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$BindingUpdater$$anonfun$startVisitControl$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$BindingUpdater.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$ControlsIterator$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$ControlsIterator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$XFormsControlVisitorAdapter.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls$XFormsControlVisitorListener.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Controls.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlXMLDumpSupport$$anonfun$toXML$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlXMLDumpSupport$$anonfun$toXML$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlXMLDumpSupport$$anonfun$toXML$3$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlXMLDumpSupport$$anonfun$toXML$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlXMLDumpSupport$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlXMLDumpSupport.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlXPathSupport$$anonfun$evaluateAsString$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlXPathSupport$$anonfun$evaluateAsString$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlXPathSupport$$anonfun$evaluateAvt$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlXPathSupport$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ControlXPathSupport.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\ExternalCopyable.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Focus$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Focus$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Focus$$anonfun$containers$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Focus$$anonfun$dispatchFocusIns$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Focus$$anonfun$dispatchFocusIns$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Focus$$anonfun$focusWithEvents$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Focus$$anonfun$focusWithEvents$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Focus$$anonfun$focusWithEvents$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Focus$$anonfun$hiddenCases$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Focus$$anonfun$isFocusWithinContainer$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Focus$$anonfun$isHidden$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Focus$$anonfun$org$orbeon$oxf$xforms$control$Focus$$dispatchFocusOuts$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Focus$$anonfun$org$orbeon$oxf$xforms$control$Focus$$dispatchFocusOuts$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Focus$$anonfun$org$orbeon$oxf$xforms$control$Focus$$removeFocus$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Focus$$anonfun$removeFocusPartially$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Focus$$anonfun$updateFocusWithEvents$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Focus$$anonfun$updateFocusWithEvents$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Focus$$anonfun$updateFocusWithEvents$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Focus$$anonfun$updateFocusWithEvents$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Focus$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\Focus.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\FocusableTrait$$anonfun$focusableControls$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\FocusableTrait$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\FocusableTrait.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\LHHASupport$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\LHHASupport$$anonfun$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\LHHASupport$$anonfun$gatherActiveAlerts$1$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\LHHASupport$$anonfun$gatherActiveAlerts$1$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\LHHASupport$$anonfun$gatherActiveAlerts$1$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\LHHASupport$$anonfun$gatherActiveAlerts$1$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\LHHASupport$$anonfun$gatherActiveAlerts$1$$anonfun$7.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\LHHASupport$$anonfun$gatherActiveAlerts$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\LHHASupport$$anonfun$gatherActiveAlerts$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\LHHASupport$$anonfun$nonEmptyOption$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\LHHASupport$$anonfun$org$orbeon$oxf$xforms$control$LHHASupport$$alertsMatchingAny$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\LHHASupport$$anonfun$org$orbeon$oxf$xforms$control$LHHASupport$$alertsMatchingLevel$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\LHHASupport$$anonfun$org$orbeon$oxf$xforms$control$LHHASupport$$alertsMatchingValidations$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\LHHASupport$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\LHHASupport$LHHAProperty.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\LHHASupport$NullLHHAProperty.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\LHHASupport.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\LHHAValue$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\LHHAValue.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\MutableAlertProperty$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\MutableAlertProperty$$anonfun$2$$anonfun$apply$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\MutableAlertProperty$$anonfun$2$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\MutableAlertProperty$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\MutableAlertProperty$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\MutableAlertProperty.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\MutableLHHAProperty$$anonfun$evaluateOne$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\MutableLHHAProperty.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\MutableLHHProperty.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\NoLHHATrait$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\NoLHHATrait.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\VisitableTrait$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\VisitableTrait.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsComponentControl$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsComponentControl$$anonfun$buildChildren$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsComponentControl$$anonfun$buildChildren$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsComponentControl$$anonfun$destroyMirrorListenerIfNeeded$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsComponentControl$$anonfun$findMirrorInstance$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsComponentControl$$anonfun$findMirrorInstance$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsComponentControl$$anonfun$initializeMirrorListenerIfNeeded$1$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsComponentControl$$anonfun$initializeMirrorListenerIfNeeded$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsComponentControl$$anonfun$initializeModels$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsComponentControl$$anonfun$initializeModels$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsComponentControl$$anonfun$initializeModels$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsComponentControl$$anonfun$innerRootControl$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsComponentControl$$anonfun$org$orbeon$oxf$xforms$control$XFormsComponentControl$$createMirrorListener$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsComponentControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsContainerControl$$anonfun$children$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsContainerControl$$anonfun$focusableControls$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsContainerControl$$anonfun$getBackCopy$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsContainerControl$$anonfun$iterationRemoved$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsContainerControl$$anonfun$toXML$1$$anonfun$apply$mcV$sp$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsContainerControl$$anonfun$toXML$1$$anonfun$apply$mcV$sp$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsContainerControl$$anonfun$toXML$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsContainerControl$$anonfun$updateEffectiveId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsContainerControl$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsContainerControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControl$$anon$1$$anonfun$startElement$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControl$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControl$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControl$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControl$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControl$$anonfun$buildChildren$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControl$$anonfun$getCommonJavaScriptInitialization$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControl$$anonfun$preceding$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControl$$anonfun$updateEffectiveId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControl$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControl$ControlProperty$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControl$ControlProperty.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControl$ImmutableControlProperty.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControl$MutableControlProperty$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControl$MutableControlProperty.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControl.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$1$$anonfun$applyOrElse$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$12.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$15.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$16.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$17.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$18.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$19.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$20.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$21.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$22.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$23.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$24.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$25$$anon$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$25.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$26.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$27$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$27.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$9.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$$anonfun$createXFormsControl$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsControlFactory.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsNoSingleNodeContainerControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeContainerControl.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl$$anonfun$addAjaxCustomMIPs$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl$$anonfun$addAjaxMIPs$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl$$anonfun$addAjaxMIPs$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl$$anonfun$boundNode$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl$$anonfun$customMIPsClasses$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl$$anonfun$diff$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl$$anonfun$diff$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl$$anonfun$diff$1$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl$$anonfun$diff$1$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl$$anonfun$getBuiltinTypeName$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl$$anonfun$getBuiltinTypeName$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl$$anonfun$getTypeLocalName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl$$anonfun$isRelevant$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl$$anonfun$readBinding$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl$$anonfun$readBinding$2$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl$$anonfun$readBinding$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl$$anonfun$readBinding$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl$$anonfun$readBinding$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl$$anonfun$readBinding$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl$$anonfun$readBinding$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl$$anonfun$writeMIPs$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl$$anonfun$writeMIPs$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsSingleNodeControl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsValueComponentControl.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsValueControl$$anonfun$getEscapedExternalValue$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsValueControl$$anonfun$getValueUseFormat$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsValueControl$$anonfun$getValueUseFormat$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsValueControl$$anonfun$toXML$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsValueControl$$anonfun$valueWithDefaultFormat$1$$anonfun$apply$1$$anonfun$apply$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsValueControl$$anonfun$valueWithDefaultFormat$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsValueControl$$anonfun$valueWithDefaultFormat$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsValueControl$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsValueControl$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsValueControl.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsValueControlBase.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\control\XFormsValueFocusableControlBase.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ControlIndex.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ControlTree$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ControlTree$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ControlTree$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ControlTree$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ControlTree.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\DeferredActionContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\ErrorInfo.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$8.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$allQuickReturnEvents$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$assertSessionExists$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$checkAllowedExternalEvents$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$checkAllowedExternalEvents$1$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$combineValueEvents$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$errorDocument$1$$anonfun$apply$mcV$sp$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$errorDocument$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$eventResponse$1$1$$anonfun$apply$mcV$sp$2$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$eventResponse$1$1$$anonfun$apply$mcV$sp$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$eventResponse$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$eventResponse$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$eventResponse$1$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$extractLocalEvents$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$filterEvents$1$1$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$filterEvents$1$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$filterEvents$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$getValueChangeIds$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$getValueChangeIds$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$handleQuickReturnEvents$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$handleQuickReturnEvents$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$handleQuickReturnEvents$3$$anonfun$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$handleQuickReturnEvents$3$$anonfun$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$handleQuickReturnEvents$3$$anonfun$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$handleQuickReturnEvents$3$$anonfun$apply$7$$anonfun$apply$8.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$handleQuickReturnEvents$3$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$handleQuickReturnEvents$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$handleQuickReturnEvents$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$handleQuickReturnEvents$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$hasHeartBeat$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$hasOther$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$hasUploadProgress$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$org$orbeon$oxf$xforms$event$ClientEvents$$decodeServerEvents$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$org$orbeon$oxf$xforms$event$ClientEvents$$safelyCreateAndMapEvent$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$org$orbeon$oxf$xforms$event$ClientEvents$$safelyCreateAndMapEvent$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$org$orbeon$oxf$xforms$event$ClientEvents$$safelyCreateAndMapEvent$3$$anonfun$standardProperties$1$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$org$orbeon$oxf$xforms$event$ClientEvents$$safelyCreateAndMapEvent$3$$anonfun$standardProperties$1$1$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$org$orbeon$oxf$xforms$event$ClientEvents$$safelyCreateAndMapEvent$3$$anonfun$standardProperties$1$1$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$org$orbeon$oxf$xforms$event$ClientEvents$$safelyCreateAndMapEvent$3$$anonfun$standardProperties$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$org$orbeon$oxf$xforms$event$ClientEvents$$safelyCreateAndMapEvent$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$processEvent$1$$anonfun$apply$mcV$sp$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$processEvent$1$$anonfun$apply$mcV$sp$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$processEvent$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$processEvent$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$processEvent$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$processEvents$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$reorderNoscriptEvents$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$warn$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$$anonfun$warn$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$Activation$2$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$EventCategory$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$EventGroupingKey$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$EventGroupingKey$4$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$LocalEvent$$anonfun$properties$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$LocalEvent$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$LocalEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$Other$2$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$SelectBlank$2$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents$ValueChange$2$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ClientEvents.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$$anonfun$dispatchEvent$1$$anonfun$apply$mcV$sp$1$$anonfun$ancestorObservers$lzycompute$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$$anonfun$dispatchEvent$1$$anonfun$apply$mcV$sp$1$$anonfun$ancestorObservers$lzycompute$1$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$$anonfun$dispatchEvent$1$$anonfun$apply$mcV$sp$1$$anonfun$apply$mcV$sp$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$$anonfun$dispatchEvent$1$$anonfun$apply$mcV$sp$1$$anonfun$apply$mcV$sp$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$$anonfun$dispatchEvent$1$$anonfun$apply$mcV$sp$1$$anonfun$apply$mcV$sp$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$$anonfun$dispatchEvent$1$$anonfun$apply$mcV$sp$1$$anonfun$apply$mcV$sp$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$$anonfun$dispatchEvent$1$$anonfun$apply$mcV$sp$1$$anonfun$org$orbeon$oxf$xforms$event$Dispatch$$anonfun$$anonfun$$doPhase$1$1$$anonfun$apply$2$$anonfun$apply$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$$anonfun$dispatchEvent$1$$anonfun$apply$mcV$sp$1$$anonfun$org$orbeon$oxf$xforms$event$Dispatch$$anonfun$$anonfun$$doPhase$1$1$$anonfun$apply$2$$anonfun$apply$4$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$$anonfun$dispatchEvent$1$$anonfun$apply$mcV$sp$1$$anonfun$org$orbeon$oxf$xforms$event$Dispatch$$anonfun$$anonfun$$doPhase$1$1$$anonfun$apply$2$$anonfun$apply$4$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$$anonfun$dispatchEvent$1$$anonfun$apply$mcV$sp$1$$anonfun$org$orbeon$oxf$xforms$event$Dispatch$$anonfun$$anonfun$$doPhase$1$1$$anonfun$apply$2$$anonfun$apply$4$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$$anonfun$dispatchEvent$1$$anonfun$apply$mcV$sp$1$$anonfun$org$orbeon$oxf$xforms$event$Dispatch$$anonfun$$anonfun$$doPhase$1$1$$anonfun$apply$2$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$$anonfun$dispatchEvent$1$$anonfun$apply$mcV$sp$1$$anonfun$org$orbeon$oxf$xforms$event$Dispatch$$anonfun$$anonfun$$doPhase$1$1$$anonfun$apply$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$$anonfun$dispatchEvent$1$$anonfun$apply$mcV$sp$1$$anonfun$org$orbeon$oxf$xforms$event$Dispatch$$anonfun$$anonfun$$doPhase$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$$anonfun$dispatchEvent$1$$anonfun$apply$mcV$sp$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$$anonfun$dispatchEvent$1$$anonfun$apply$mcV$sp$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$$anonfun$dispatchEvent$1$$anonfun$apply$mcV$sp$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$$anonfun$dispatchEvent$1$$anonfun$apply$mcV$sp$8.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$$anonfun$dispatchEvent$1$$anonfun$apply$mcV$sp$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$$anonfun$dispatchEvent$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$$anonfun$org$orbeon$oxf$xforms$event$Dispatch$$callNativeListeners$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$$anonfun$org$orbeon$oxf$xforms$event$Dispatch$$eventLogging$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\Dispatch.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$11.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$9.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$appendSuffixes$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$att$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$grandParent$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$grandParentPrefixedId$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$handleEvent$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$ignoringHandler$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$ignoringHandler$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$org$orbeon$oxf$xforms$event$EventHandlerImpl$$unknownTargetId$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$org$orbeon$oxf$xforms$event$EventHandlerImpl$$unknownTargetId$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$parentPrefixedId$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$resolveHandler$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$$anonfun$resolveHandler$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\EventHandlerImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\DOMActivateEvent.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\DOMFocusInEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\DOMFocusOutEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\InstanceEvent$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\InstanceEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\KeypressEvent$$anon$1$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\KeypressEvent$$anon$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\KeypressEvent$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\KeypressEvent$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\KeypressEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\LinkEvent$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\LinkEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$7$$anonfun$apply$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$8$$anonfun$apply$10$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$8$$anonfun$apply$10.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$body$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$body$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$headerElements$1$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$headerElements$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$headers$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$headersDocument$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$headersDocument$2$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$headersDocument$2$$anonfun$apply$3$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$headersDocument$2$$anonfun$apply$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$headersDocument$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$newPropertyName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$org$orbeon$oxf$xforms$event$events$SubmitResponseEvent$$warn$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$tryToReadBody$1$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$tryToReadBody$1$$anonfun$apply$7.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$tryToReadBody$1$$anonfun$apply$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$tryToReadBody$1$$anonfun$org$orbeon$oxf$xforms$event$events$SubmitResponseEvent$$anonfun$$tryText$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$tryToReadBody$1$$anonfun$tryXML$1$1$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$tryToReadBody$1$$anonfun$tryXML$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$$anonfun$tryToReadBody$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\SubmitResponseEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsDeleteEvent$$anonfun$$init$$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsDeleteEvent.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsDeselectEvent$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsDeselectEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsDisabledEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsEnabledEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsFocusEvent$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsFocusEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsHelpEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsHintEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsInsertEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsInvalidEvent.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsLinkErrorEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsLinkExceptionEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsModelConstructDoneEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsModelConstructEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsModelDestructEvent.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsOptionalEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsReadonlyEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsReadwriteEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsReadyEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsRebuildEvent.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsRecalculateEvent$$anonfun$applyDefaults$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsRecalculateEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsRefreshEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsRequiredEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsResetEvent.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsRevalidateEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsScrollFirstEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsScrollLastEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsSelectEvent$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsSelectEvent.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsSubmitDoneEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsSubmitErrorEvent$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsSubmitErrorEvent$ErrorType.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsSubmitErrorEvent$NoData$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsSubmitErrorEvent$ParseError$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsSubmitErrorEvent$ResourceError$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsSubmitErrorEvent$SubmissionInProgress$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsSubmitErrorEvent$TargetError$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsSubmitErrorEvent$ValidationError$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsSubmitErrorEvent$XXFormsInternalError$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsSubmitErrorEvent$XXFormsPendingUploads$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsSubmitErrorEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsSubmitEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsSubmitSerializeEvent$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsSubmitSerializeEvent$$anonfun$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsSubmitSerializeEvent$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsSubmitSerializeEvent$$anonfun$submissionBodyAsString$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsSubmitSerializeEvent$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsSubmitSerializeEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsUIEvent$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsUIEvent$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsUIEvent$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsUIEvent$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsUIEvent$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsUIEvent$$anonfun$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsUIEvent$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsUIEvent$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsUIEvent$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsUIEvent$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsUIEvent$$anonfun$9.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsUIEvent$$anonfun$newPropertyName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsUIEvent$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsUIEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsValidEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsValueChangeEvent$$anonfun$properties$1$$anonfun$applyOrElse$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsValueChangeEvent$$anonfun$properties$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsValueChangeEvent$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XFormsValueChangeEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsActionErrorEvent$$anonfun$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsActionErrorEvent$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsActionErrorEvent$$anonfun$2$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsActionErrorEvent$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsActionErrorEvent$$anonfun$3$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsActionErrorEvent$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsActionErrorEvent$$anonfun$4$$anonfun$apply$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsActionErrorEvent$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsActionErrorEvent$$anonfun$5$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsActionErrorEvent$$anonfun$5$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsActionErrorEvent$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsActionErrorEvent$$anonfun$6$$anonfun$apply$7.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsActionErrorEvent$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsActionErrorEvent$$anonfun$org$orbeon$oxf$xforms$event$events$XXFormsActionErrorEvent$$rootLocationOpt$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsActionErrorEvent$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsActionErrorEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsBindingErrorEvent.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsBlurEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsConstraintsChangedEvent$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsConstraintsChangedEvent$$anonfun$properties$2$$anonfun$applyOrElse$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsConstraintsChangedEvent$$anonfun$properties$2$$anonfun$applyOrElse$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsConstraintsChangedEvent$$anonfun$properties$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsConstraintsChangedEvent$$anonfun$validationsForLevel$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsConstraintsChangedEvent$$anonfun$validationsForLevel$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsConstraintsChangedEvent$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsConstraintsChangedEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsDialogCloseEvent.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsDialogOpenEvent$$anonfun$constrainToViewport$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsDialogOpenEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsDndEvent$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsDndEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsIndexChangedEvent$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsIndexChangedEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsInstanceInvalidate.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsInvalidEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsIterationMovedEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsLoadEvent$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsLoadEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsNodesetChangedEvent$$anonfun$$init$$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsNodesetChangedEvent$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsNodesetChangedEvent$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsNodesetChangedEvent$$anonfun$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsNodesetChangedEvent$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsNodesetChangedEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsReadyEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsRepeatActivateEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsReplaceEvent.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsSetindexEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsUnvisitedEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsUploadCancelEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsUploadDoneEvent$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsUploadDoneEvent.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsUploadErrorEvent$$anonfun$reasonToProperties$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsUploadErrorEvent$$anonfun$reasonToProperties$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsUploadErrorEvent$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsUploadErrorEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsUploadProgressEvent.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsUploadStartEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsValidEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsValueChangedEvent$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsValueChangedEvent$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsValueChangedEvent$$anonfun$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsValueChangedEvent$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsValueChangedEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsValueEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsVisitedEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\events\XXFormsXPathErrorEvent.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ListenersTrait$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ListenersTrait$$anonfun$getListeners$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ListenersTrait$$anonfun$removeListener$1$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ListenersTrait$$anonfun$removeListener$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ListenersTrait$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\ListenersTrait.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsCustomEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$10.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$15.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$16.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$getAttribute$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$getAttribute$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$getAttribute$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$org$orbeon$oxf$xforms$event$XFormsEvent$$repeatAncestors$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$property$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$property$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$propertyOrDefault$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$propertyOrDefault$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$propertyOrDefault$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$$anonfun$warnDeprecatedIfNeeded$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$Bubbling$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$Capture$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$Phase.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent$Target$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvent.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$13.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$15.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$16.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$17.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$18.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$19.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$20.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$21.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$22.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$23.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$24.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$25.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$26.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$27.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$28.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$29.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$30.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$31.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$32.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$33.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$34.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$35.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$36.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$37.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$38.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$39.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$40.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$41.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$42.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$43.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$44.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$45.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$46.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$47.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$48.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$49.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$50.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$51.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$52.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$53.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$54.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$55.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$56.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$57.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$58.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$59.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$60.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$61.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$62.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$63.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventFactory.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventObserver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEvents.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\event\XFormsEventTarget.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\AddToPathMap$$anonfun$addToPathMap$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\AddToPathMap$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\AddToPathMap.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Aggregate.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Bind.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\BooleanFromString.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Choose.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Context.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\CountNonEmpty.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Current.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\DaysFromDate.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\DaysToDate.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Digest.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Event.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\exforms\EXFormsMIP$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\exforms\EXFormsMIP$$anonfun$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\exforms\EXFormsMIP$$anonfun$evaluateItem$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\exforms\EXFormsMIP$$anonfun$evaluateItem$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\exforms\EXFormsMIP$$anonfun$org$orbeon$oxf$xforms$function$exforms$EXFormsMIP$$get$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\exforms\EXFormsMIP$$anonfun$org$orbeon$oxf$xforms$function$exforms$EXFormsMIP$$get$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\exforms\EXFormsMIP$$anonfun$org$orbeon$oxf$xforms$function$exforms$EXFormsMIP$$get$1$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\exforms\EXFormsMIP.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\exforms\EXFormsSort.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\FunctionSupport$$anonfun$asIterator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\FunctionSupport$$anonfun$asIterator$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\FunctionSupport$$anonfun$booleanArgument$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\FunctionSupport$$anonfun$booleanArgument$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\FunctionSupport$$anonfun$booleanArgumentOpt$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\FunctionSupport$$anonfun$booleanOptToItem$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\FunctionSupport$$anonfun$itemArgumentOpt$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\FunctionSupport$$anonfun$itemArgumentOrContextOpt$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\FunctionSupport$$anonfun$itemArgumentsOpt$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\FunctionSupport$$anonfun$itemArgumentsOrContextOpt$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\FunctionSupport$$anonfun$itemSeqOptToIterator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\FunctionSupport$$anonfun$itemSeqOptToIterator$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\FunctionSupport$$anonfun$relevantControl$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\FunctionSupport$$anonfun$resolveStaticOrAbsoluteId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\FunctionSupport$$anonfun$stringArgumentOpt$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\FunctionSupport$$anonfun$stringArgumentOrContextOpt$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\FunctionSupport$$anonfun$stringArgumentOrContextOpt$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\FunctionSupport$$anonfun$stringIteratorToSequenceIterator$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\FunctionSupport$$anonfun$stringOptToItem$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\FunctionSupport$$anonfun$stringSeqOptToIterator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\FunctionSupport$$anonfun$stringSeqOptToIterator$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\FunctionSupport$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\FunctionSupport.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Hmac.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\If.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Index.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Instance$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Instance$$anonfun$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Instance$$anonfun$findDynamic$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Instance$$anonfun$org$orbeon$oxf$xforms$function$Instance$$findStatic$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Instance.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\IsCardNumber.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Last.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\LocalDate.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\LocalDateTime.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\MatchSimpleAnalysis$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\MatchSimpleAnalysis.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Months.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Now.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Power.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Property$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Property$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Property$$anonfun$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Property$$anonfun$evaluateItem$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Property$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Property.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Random.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\Seconds.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\SecondsFromDateTime.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\SecondsToDateTime.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\ValidSupport$$anonfun$isTreeValid$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\ValidSupport$$anonfun$isValid$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\ValidSupport$$anonfun$isValid$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\ValidSupport$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\ValidSupport.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsAttribute$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsAttribute$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsAttribute$$anonfun$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsAttribute$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsAttribute.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsElement$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsElement$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsElement$$anonfun$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsElement.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsFunction$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsFunction$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsFunction$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsFunction$$anonfun$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsFunction$$anonfun$context$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsFunction$$anonfun$copyStaticContextIfNeeded$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsFunction$$anonfun$copyStaticContextIfNeeded$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsFunction$$anonfun$copyStaticContextIfNeeded$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsFunction$$anonfun$getContainingDocument$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsFunction$$anonfun$getSourceEffectiveId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsFunction$$anonfun$getSourceEffectiveId$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsFunction$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsFunction$Context$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsFunction$Context.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsFunction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XFormsValid.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\ClassSupport$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\ClassSupport.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\ExistentialFunction$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\ExistentialFunction$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\ExistentialFunction$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\ExistentialFunction$$anonfun$evaluateItem$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\ExistentialFunction$$anonfun$evaluateItem$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\ExistentialFunction$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\ExistentialFunction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\RequestFunction$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\RequestFunction$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\RequestFunction$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\RequestFunction$$anonfun$iterate$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\RequestFunction$$anonfun$iterate$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\RequestFunction$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\RequestFunction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsAbsoluteId$$anonfun$evaluateItem$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsAbsoluteId.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsAVTValue$$anonfun$evaluateItem$1$$anonfun$apply$1$$anonfun$apply$2$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsAVTValue$$anonfun$evaluateItem$1$$anonfun$apply$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsAVTValue$$anonfun$evaluateItem$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsAVTValue$$anonfun$evaluateItem$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsAVTValue.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsBinding$$anonfun$iterate$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsBinding.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsBindingContext$$anonfun$iterate$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsBindingContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsCallXPL.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsCase$$anonfun$evaluateItem$1$$anonfun$apply$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsCase$$anonfun$evaluateItem$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsCase$$anonfun$evaluateItem$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsCase.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsCases$$anonfun$iterate$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsCases$$anonfun$iterate$2$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsCases$$anonfun$iterate$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsCases$$anonfun$iterate$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsCases.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsClasses.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsClientId.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsComponentContext$$anonfun$iterate$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsComponentContext$$anonfun$iterate$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsComponentContext$$anonfun$iterate$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsComponentContext.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsControlElement$$anonfun$evaluateItem$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsControlElement.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsCreateDocument.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsCustomMIP$$anonfun$evaluateItem$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsCustomMIP$$anonfun$evaluateItem$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsCustomMIP.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsDecodeISO9075.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsDocBase64$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsDocBase64.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsDocumentId.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsEncodeISO9075.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsEvaluateAVT.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsEvaluateBindProperty$$anonfun$evaluateItem$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsEvaluateBindProperty.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsExists.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsExtractDocument$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsExtractDocument$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsExtractDocument.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsFocusable$$anonfun$evaluateItem$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsFocusable.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsForall.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsFormatMessage$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsFormatMessage$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsFormatMessage$$anonfun$addToPathMap$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsFormatMessage.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsFormURLEncode.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsGetPortletMode.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsGetRemoteUser.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsGetRequestAttribute.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsGetRequestHeader$$anonfun$fromRequest$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsGetRequestHeader.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsGetRequestMethod.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsGetRequestParameter$$anonfun$fromRequest$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsGetRequestParameter$$anonfun$fromRequest$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsGetRequestParameter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsGetRequestPath.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsGetScopeAttribute.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsGetSessionAttribute.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsGetVariable.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsGetWindowState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsHasClass.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsImageMetadata$$anonfun$evaluateItem$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsImageMetadata$$anonfun$evaluateItem$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsImageMetadata$$anonfun$org$orbeon$oxf$xforms$function$xxforms$XXFormsImageMetadata$$findMetadata$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsImageMetadata.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsIndex.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsInstance$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsInstance$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsInstance$$anonfun$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsInstance$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsInstance$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsInstance$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsInstance$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsInstance$$anonfun$findAbsolute$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsInstance$$anonfun$findInAncestorScopes$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsInstance$$anonfun$findInAncestorScopes$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsInstance$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsInstance.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsInvalidBinds$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsInvalidBinds$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsInvalidBinds.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsIsUserInRole.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsItemset$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsItemset$$anonfun$fromComponentControl$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsItemset$$anonfun$fromComponentControl$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsItemset.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsLang$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsLang$$anonfun$addXMLLangDependency$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsLang$$anonfun$evaluateItem$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsLang$$anonfun$evaluateItem$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsLang$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsLang.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsLHHA$$anonfun$evaluateControlItem$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsLHHA$$anonfun$evaluateItem$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsLHHA$$anonfun$evaluateItem$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsLHHA$$anonfun$evaluateItem$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsLHHA$$anonfun$evaluateItem$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsLHHA.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsListInstances$$anonfun$iterate$1$$anonfun$applyOrElse$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsListInstances$$anonfun$iterate$1$$anonfun$applyOrElse$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsListInstances$$anonfun$iterate$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsListInstances.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsListModels$$anonfun$iterate$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsListModels$$anonfun$iterate$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsListModels.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsListVariables$$anonfun$iterate$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsListVariables.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsMIPFunction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsMutableDocument.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsPendingUploads.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsPropertiesStartsWith.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsProperty.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsRepeatCurrent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsRepeatItems.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsRepeatPosition.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsResource$$anonfun$1$$anonfun$apply$1$$anonfun$apply$2$$anonfun$apply$3$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsResource$$anonfun$1$$anonfun$apply$1$$anonfun$apply$2$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsResource$$anonfun$1$$anonfun$apply$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsResource$$anonfun$1$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsResource$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsResource$$anonfun$addInstanceDependency$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsResource$$anonfun$addToPathMap$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsResource$$anonfun$findInstance$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsResource$$anonfun$org$orbeon$oxf$xforms$function$xxforms$XXFormsResource$$findResourceElementForLang$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsResource$$anonfun$org$orbeon$oxf$xforms$function$xxforms$XXFormsResource$$findResourceElementForLang$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsResource$$anonfun$org$orbeon$oxf$xforms$function$xxforms$XXFormsResource$$findResourceElementForLang$1$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsResource$$anonfun$org$orbeon$oxf$xforms$function$xxforms$XXFormsResource$$findResourcesElement$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsResource.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsRewriteResourceURI.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsRewriteServiceURI.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsSetRequestAttribute.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsSetScopeAttribute$StringValueWithEquals.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsSetScopeAttribute.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsSetSessionAttribute.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsSort$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsSort.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsSplit$$anonfun$iterate$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsSplit.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsType.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsValue$$anonfun$evaluateItem$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsValue.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsVisited$$anonfun$evaluateItem$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\xxforms\XXFormsVisited.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\function\XXFormsValid.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\InstanceCaching$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\InstanceCaching$$anonfun$writeAttributes$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\InstanceCaching$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\InstanceCaching.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\InstanceData$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\InstanceData.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Item$$anonfun$externalValue$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Item$$anonfun$externalValue$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Item$$anonfun$iterateLHHA$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Item$$anonfun$iterateLHHA$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Item$$anonfun$iterateLHHA$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Item$$anonfun$iterateLHHA$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Item$$anonfun$javaScriptHelp$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Item$$anonfun$javaScriptHint$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Item$$anonfun$javaScriptLabel$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Item$$anonfun$javaScriptLabel$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Item$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Item.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\ItemContainer$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\ItemContainer$$anonfun$allItemsIterator$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\ItemContainer$$anonfun$childrenIterator$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\ItemContainer$$anonfun$pruneNonRelevantChildren$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\ItemContainer$$anonfun$pruneNonRelevantChildren$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\ItemContainer$$anonfun$visit$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\ItemContainer$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\ItemContainer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Itemset$$anon$1$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Itemset$$anon$1$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Itemset$$anon$1$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Itemset$$anon$1$$anonfun$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Itemset$$anon$1$$anonfun$startItem$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Itemset$$anon$1$$anonfun$startItem$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Itemset$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Itemset$$anon$2$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Itemset$$anon$2$$anonfun$startItem$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Itemset$$anon$2$$anonfun$startItem$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Itemset$$anon$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Itemset$$anonfun$jSelectedItems$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Itemset$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\Itemset.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\ItemsetListener.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\XFormsItemUtils$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\itemset\XFormsItemUtils.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\EXFormsFunctions$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\EXFormsFunctions$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\EXFormsFunctions.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XFormsDeprecatedFunctions$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XFormsDeprecatedFunctions$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XFormsDeprecatedFunctions$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XFormsDeprecatedFunctions.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XFormsEnvFunctions$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XFormsEnvFunctions$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XFormsEnvFunctions.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XFormsFunctionLibrary$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XFormsFunctionLibrary.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XFormsFunnyFunctions$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XFormsFunnyFunctions$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XFormsFunnyFunctions.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XFormsIndependentFunctions$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XFormsIndependentFunctions$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XFormsIndependentFunctions.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XFormsXXFormsEnvFunctions$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XFormsXXFormsEnvFunctions$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XFormsXXFormsEnvFunctions.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XSLTFunctions$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XSLTFunctions$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XSLTFunctions.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XXFormsEnvFunctions$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XXFormsEnvFunctions$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XXFormsEnvFunctions.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XXFormsIndependentFunctions$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XXFormsIndependentFunctions$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\library\XXFormsIndependentFunctions.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\Loggers$$anonfun$getIndentedLogger$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\Loggers$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\Loggers.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\MapSet$$anonfun$combine$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\MapSet$$anonfun$combine$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\MapSet$$anonfun$foreach$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\MapSet$$anonfun$foreach$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\MapSet$$anonfun$intersects$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\MapSet$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\MapSet$EmptyMapSet$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\MapSet.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindIteration$$anonfun$9.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindIteration$$anonfun$applyBinds$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindIteration$$anonfun$findChildBindByStaticId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindIteration.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$7$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$8$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$8.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$ancestorOrSelfBindNodes$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$ancestorOrSelfBindNodes$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$collectAllCustomMIPs$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$collectFailedValidationsForAllLevels$1$$anonfun$apply$1$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$collectFailedValidationsForAllLevels$1$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$collectFailedValidationsForAllLevels$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$collectFailedValidationsForAllLevels$1$$anonfun$apply$3$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$collectFailedValidationsForAllLevels$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$collectFailedValidationsForAllLevels$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$collectFailedValidationsForAllLevels$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$collectFailedValidationsForHighestLevel$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$collectFailedValidationsForLevel$1$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$collectFailedValidationsForLevel$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$failedValidations$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$failedValidationsForAllLevels$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$failedValidationsForAllLevels$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$failedValidationsForAllLevelsPrioritizeRequired$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$failedValidationsForHighestLevel$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$failedValidationsForHighestLevel$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$failedValidationsForHighestLevelPrioritizeRequired$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$highestValidationLevel$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$org$orbeon$oxf$xforms$model$BindNode$$constraintLevel$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$org$orbeon$oxf$xforms$model$BindNode$$prioritizeRequired$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$org$orbeon$oxf$xforms$model$BindNode$$prioritizeRequired$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$$anonfun$typeOrRequiredLevel$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\BindNode.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\DataModel$$anonfun$findInstanceEffectiveId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\DataModel$$anonfun$getValue$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\DataModel$$anonfun$jSetValueIfChanged$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\DataModel$$anonfun$jSetValueIfChanged$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\DataModel$$anonfun$logValueChange$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\DataModel$$anonfun$setValue$default$3$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\DataModel$$anonfun$setValue$default$4$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\DataModel$$anonfun$setValueIfChanged$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\DataModel$$anonfun$setValueIfChanged$default$3$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\DataModel$$anonfun$setValueIfChanged$default$4$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\DataModel$$anonfun$visitElementJava$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\DataModel$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\DataModel$DisallowedNodeReason$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\DataModel$NodeVisitor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\DataModel$ReadonlyNodeReason$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\DataModel$Reason.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\DataModel.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\RuntimeBind$$anonfun$1$$anonfun$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\RuntimeBind$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\RuntimeBind$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\RuntimeBind$$anonfun$applyBinds$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\RuntimeBind$$anonfun$getOrCreateBindNode$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\RuntimeBind.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\model\XFormsModelAction.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\msv\FieldMatcher.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\msv\FieldsMatcher.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\msv\IDConstraintChecker.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\msv\KeyValue.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\msv\Matcher.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\msv\MatcherBundle.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\msv\PathMatcher$SinglePathMatcher.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\msv\PathMatcher.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\msv\SelectorMatcher.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\Namespaces$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\Namespaces.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\PartAnalysis$$anonfun$elementInParent$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\PartAnalysis$$anonfun$repeatDepthAcrossParts$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\PartAnalysis$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\PartAnalysis.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\PartGlobalOps$$anonfun$appendClasses$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\PartGlobalOps$$anonfun$getAlerts$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\PartGlobalOps$$anonfun$getControlElement$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\PartGlobalOps$$anonfun$getControlPosition$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\PartGlobalOps$$anonfun$getLHH$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\PartGlobalOps$$anonfun$hasBinding$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\PartGlobalOps$$anonfun$hasLHHA$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\PartGlobalOps$$anonfun$isValueControl$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\PartGlobalOps$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\PartGlobalOps.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\PartStaticAnalysisOps.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ControlsComparator$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ControlsComparator$$anonfun$$init$$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ControlsComparator$$anonfun$$init$$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ControlsComparator$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ControlsComparator$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ControlsComparator$$anonfun$diffChildren$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ControlsComparator$$anonfun$diffChildren$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ControlsComparator$$anonfun$diffChildren$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ControlsComparator$$anonfun$diffChildren$4$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ControlsComparator$$anonfun$diffChildren$4$$anonfun$2$$anonfun$apply$mcV$sp$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ControlsComparator$$anonfun$diffChildren$4$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ControlsComparator$$anonfun$diffChildren$4$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ControlsComparator$$anonfun$diffChildren$4$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ControlsComparator$$anonfun$diffChildren$4$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ControlsComparator$$anonfun$diffChildren$4$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ControlsComparator$$anonfun$diffChildren$4$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ControlsComparator$$anonfun$diffChildren$4$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ControlsComparator$$anonfun$diffChildren$4$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ControlsComparator$$anonfun$diffChildren$4$ControlWithMark$2$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ControlsComparator$$anonfun$diffChildren$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ControlsComparator$$anonfun$diffChildren$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ControlsComparator$$anonfun$org$orbeon$oxf$xforms$processor$ControlsComparator$$processFullUpdateForContent$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ControlsComparator.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\HandlerContext$RepeatContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\HandlerContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\HandlerSupport$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\HandlerSupport.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\NullElementHandler.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\NullHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\OutputInterceptor$Listener.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\OutputInterceptor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XFormsBaseHandler$LHHAC.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XFormsBaseHandler.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XFormsControlLifecycleHandlerDelegate.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsBaseHandlerXHTML.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsCaseHandler$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsCaseHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsControlLifecyleHandler.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsGroupDefaultHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsGroupFieldsetHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsGroupHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsGroupInternalHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsGroupSeparatorHandler$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsGroupSeparatorHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsInputHandler$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsInputHandler$$anonfun$getForEffectiveId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsInputHandler$$anonfun$getForEffectiveId$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsInputHandler$$anonfun$getSecondInputEffectiveId$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsInputHandler$$anonfun$handleControlStart$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsInputHandler$$anonfun$handleControlStart$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsInputHandler$$anonfun$handleControlStart$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsInputHandler$$anonfun$isBoolean$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsInputHandler$$anonfun$isDateMinimal$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsInputHandler$$anonfun$isDateTime$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsInputHandler$$anonfun$org$orbeon$oxf$xforms$processor$handlers$xhtml$XFormsInputHandler$$getFirstInputEffectiveId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsInputHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsLHHAHandler$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsLHHAHandler.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsOutputDefaultHandler$$anonfun$handleControlStart$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsOutputDefaultHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsOutputDownloadHandler$$anonfun$handleControlStart$3$$anonfun$apply$1$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsOutputDownloadHandler$$anonfun$handleControlStart$3$$anonfun$apply$1$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsOutputDownloadHandler$$anonfun$handleControlStart$3$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsOutputDownloadHandler$$anonfun$handleControlStart$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsOutputDownloadHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsOutputHandler$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsOutputHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsOutputHTMLHandler$$anonfun$handleControlStart$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsOutputHTMLHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsOutputImageHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsOutputTextHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsRangeHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsRepeatHandler$$anon$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsRepeatHandler$$anonfun$handleControlStart$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsRepeatHandler$$anonfun$handleControlStart$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsRepeatHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsSecretHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsSelect1Handler$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsSelect1Handler$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsSelect1Handler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsSelect1InternalHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsSelectHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsTextareaHandler.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsTriggerFullHandler$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsTriggerFullHandler$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsTriggerFullHandler$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsTriggerFullHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsTriggerHandler.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsTriggerMinimalHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsUploadHandler$$anonfun$handleControlStart$1$$anonfun$apply$mcV$sp$1$$anonfun$apply$mcV$sp$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsUploadHandler$$anonfun$handleControlStart$1$$anonfun$apply$mcV$sp$1$$anonfun$apply$mcV$sp$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsUploadHandler$$anonfun$handleControlStart$1$$anonfun$apply$mcV$sp$1$$anonfun$apply$mcV$sp$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsUploadHandler$$anonfun$handleControlStart$1$$anonfun$apply$mcV$sp$1$$anonfun$outputSpan$1$1$$anonfun$apply$mcV$sp$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsUploadHandler$$anonfun$handleControlStart$1$$anonfun$apply$mcV$sp$1$$anonfun$outputSpan$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsUploadHandler$$anonfun$handleControlStart$1$$anonfun$apply$mcV$sp$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsUploadHandler$$anonfun$handleControlStart$1$$anonfun$apply$mcV$sp$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsUploadHandler$$anonfun$handleControlStart$1$$anonfun$apply$mcV$sp$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsUploadHandler$$anonfun$handleControlStart$1$$anonfun$apply$mcV$sp$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsUploadHandler$$anonfun$handleControlStart$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XFormsUploadHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLBodyHandler$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLBodyHandler$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLBodyHandler$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLBodyHandler$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLBodyHandler$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLBodyHandler$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLBodyHandler$AnyMatcher.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLBodyHandler$AppearanceMatcher.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLBodyHandler$Matcher.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLBodyHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLElementHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$10.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$gatherJavascriptControls$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$gatherJavascriptControls$2$$anonfun$apply$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$gatherJavascriptControls$2$$anonfun$apply$5$$anonfun$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$gatherJavascriptControls$2$$anonfun$apply$5$$anonfun$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$gatherJavascriptControls$2$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$gatherJavascriptControls$2$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$gatherJavascriptControls$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$heartbeat$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$help$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$org$orbeon$oxf$xforms$processor$handlers$xhtml$XHTMLHeadHandler$$outputElement$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$outputConfigurationProperties$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$outputConfigurationProperties$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$outputCSSElement$1$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$outputCSSElement$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$outputCSSResources$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$outputCSSResources$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$outputJavaScriptInitialData$1$$anonfun$apply$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$outputJavaScriptInitialData$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$outputJavaScriptInitialData$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$outputJavaScriptResources$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$outputJavaScriptResources$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$outputJSElement$1$1$$anonfun$apply$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$outputJSElement$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$outputScriptDeclarations$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$outputScriptDeclarations$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$outputScriptDeclarations$3$$anonfun$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$outputScriptDeclarations$3$$anonfun$12.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$outputScriptDeclarations$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$outputScriptDeclarations$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$outputScripts$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$outputScripts$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$resourcesVersion$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$$anonfun$resourcesVersioned$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XHTMLHeadHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XXFormsAttributeHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XXFormsComponentHandler$$anon$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XXFormsComponentHandler$$anonfun$getForEffectiveId$1$$anonfun$apply$1$$anonfun$apply$2$$anonfun$apply$3$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XXFormsComponentHandler$$anonfun$getForEffectiveId$1$$anonfun$apply$1$$anonfun$apply$2$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XXFormsComponentHandler$$anonfun$getForEffectiveId$1$$anonfun$apply$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XXFormsComponentHandler$$anonfun$getForEffectiveId$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XXFormsComponentHandler$$anonfun$getForEffectiveId$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XXFormsComponentHandler$$anonfun$org$orbeon$oxf$xforms$processor$handlers$xhtml$XXFormsComponentHandler$$binding$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XXFormsComponentHandler$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XXFormsComponentHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XXFormsDialogHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XXFormsDynamicHandler$$anon$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XXFormsDynamicHandler$$anonfun$start$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XXFormsDynamicHandler$$anonfun$start$2$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XXFormsDynamicHandler$$anonfun$start$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XXFormsDynamicHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xhtml\XXFormsTextHandler.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XHTMLOutput$$anonfun$send$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XHTMLOutput$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XHTMLOutput.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xml\ElementHandlerXML.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xml\XFormsBaseHandlerXML.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xml\XFormsCaseHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xml\XFormsControlLifecyleHandlerXML.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xml\XFormsDefaultControlHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xml\XFormsGroupHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xml\XFormsRepeatHandler.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xml\XFormsSelectHandler$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\xml\XFormsSelectHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$11.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$applyMatchers$1$$anonfun$apply$mcV$sp$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$applyMatchers$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchAppearances$1$$anonfun$applyOrElse$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchAppearances$1$$anonfun$applyOrElse$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchAppearances$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchContainer$1$$anonfun$applyOrElse$10.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchContainer$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchDialog$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchFileMetadata$1$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchFileMetadata$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchItemset$1$$anonfun$applyOrElse$1$$anonfun$apply$mcV$sp$1$$anonfun$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchItemset$1$$anonfun$applyOrElse$1$$anonfun$apply$mcV$sp$1$$anonfun$apply$1$$anonfun$apply$mcV$sp$2$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchItemset$1$$anonfun$applyOrElse$1$$anonfun$apply$mcV$sp$1$$anonfun$apply$1$$anonfun$apply$mcV$sp$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchItemset$1$$anonfun$applyOrElse$1$$anonfun$apply$mcV$sp$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchItemset$1$$anonfun$applyOrElse$1$$anonfun$apply$mcV$sp$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchItemset$1$$anonfun$applyOrElse$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchItemset$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchLHHA$1$$anonfun$applyOrElse$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchLHHA$1$$anonfun$applyOrElse$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchLHHA$1$$anonfun$applyOrElse$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchLHHA$1$$anonfun$applyOrElse$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchLHHA$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchRepeat$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchSingleNode$1$$anonfun$applyOrElse$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchSingleNode$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchSwitchCase$1$$anonfun$applyOrElse$11.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchSwitchCase$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchValue$1$$anonfun$applyOrElse$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchValue$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$matchVisitable$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$$anonfun$send$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\handlers\XMLOutput.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\LoggingCacheTracer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\PipelineResponse$$anon$1$$anonfun$printWriter$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\PipelineResponse$$anon$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\PipelineResponse$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\PipelineResponse.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$$anon$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$$anonfun$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$$anonfun$3$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$$anonfun$4$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$$anonfun$media$lzycompute$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$$anonfun$org$orbeon$oxf$xforms$processor$ResourcesAggregator$$anon$$anon$$appendPreservedElement$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$$anonfun$org$orbeon$oxf$xforms$processor$ResourcesAggregator$$anon$$anon$$outputPreservedElement$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$$anonfun$outputCSS$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$$anonfun$outputJS$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$$anonfun$outputScriptCSSAsJSON$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$$anonfun$outputScriptCSSAsJSON$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$$anonfun$outputScriptCSSAsJSON$1$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$$anonfun$outputScriptCSSAsJSON$1$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$$anonfun$outputScriptCSSAsJSON$1$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$$anonfun$outputScriptCSSAsJSON$1$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$$anonfun$rel$lzycompute$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$HeadElement$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$HeadElement.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$InlineElement$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$InlineElement.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$ReferenceElement$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2$ReferenceElement.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1$$anon$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anonfun$aggregate$1$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anonfun$aggregate$1$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anonfun$aggregate$1$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anonfun$aggregate$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anonfun$aggregate$1$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anonfun$aggregate$1$$anonfun$namespace$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anonfun$aggregate$1$$anonfun$namespace$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$$anonfun$aggregate$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\ResourcesAggregator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\Upload$$anon$1$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\Upload$$anon$1$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\Upload$$anon$1$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\Upload$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\Upload.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsFeatures$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsFeatures$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsFeatures$11.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsFeatures$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsFeatures$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsFeatures$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsFeatures$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsFeatures$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsFeatures$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsFeatures$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsFeatures$8.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsFeatures$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsFeatures$ResourceConfig.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsFeatures.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$2$$anonfun$apply$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$cacheResources$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$cacheResources$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$cacheResources$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$cacheResources$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$cacheResources$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$cacheResources$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$cacheResources$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$cacheResources$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$computeCombinedLastModified$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$generateAndClose$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$inputStreamIterator$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$inputStreamIterator$1$2$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$inputStreamIterator$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$inputStreamIterator$2$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$logFailure$1$$anonfun$applyOrElse$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$logFailure$1$$anonfun$applyOrElse$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$logFailure$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$org$orbeon$oxf$xforms$processor$XFormsResourceRewriter$$generateCSS$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$org$orbeon$oxf$xforms$processor$XFormsResourceRewriter$$generateCSS$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$org$orbeon$oxf$xforms$processor$XFormsResourceRewriter$$generateJS$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$org$orbeon$oxf$xforms$processor$XFormsResourceRewriter$$generateJS$2$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$org$orbeon$oxf$xforms$processor$XFormsResourceRewriter$$generateJS$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$org$orbeon$oxf$xforms$processor$XFormsResourceRewriter$$lastModified$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$org$orbeon$oxf$xforms$processor$XFormsResourceRewriter$$lastModified$1$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$org$orbeon$oxf$xforms$processor$XFormsResourceRewriter$$rewriteBlock$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$org$orbeon$oxf$xforms$processor$XFormsResourceRewriter$$rewriteSelector$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$org$orbeon$oxf$xforms$processor$XFormsResourceRewriter$$tryInputStream$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$org$orbeon$oxf$xforms$processor$XFormsResourceRewriter$$tryInputStream$2$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$org$orbeon$oxf$xforms$processor$XFormsResourceRewriter$$tryReadCSS$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$org$orbeon$oxf$xforms$processor$XFormsResourceRewriter$$tryRewriteURL$1$1$$anonfun$applyOrElse$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$org$orbeon$oxf$xforms$processor$XFormsResourceRewriter$$tryRewriteURL$1$1$$anonfun$applyOrElse$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$org$orbeon$oxf$xforms$processor$XFormsResourceRewriter$$tryRewriteURL$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$org$orbeon$oxf$xforms$processor$XFormsResourceRewriter$$tryRewriteURL$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$$anonfun$rewriteCSS$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceRewriter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceServer$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceServer$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceServer$$anonfun$namespaceOpt$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceServer$$anonfun$namespaceOpt$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceServer$$anonfun$nsFromParameters$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceServer$$anonfun$serveCSSOrJavaScript$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceServer$$anonfun$serveCSSOrJavaScript$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceServer$$anonfun$serveCSSOrJavaScript$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceServer$$anonfun$serveCSSOrJavaScript$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceServer$$anonfun$serveCSSOrJavaScript$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceServer$$anonfun$serveCSSOrJavaScript$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceServer$$anonfun$serveCSSOrJavaScript$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceServer$$anonfun$serveDynamicResource$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceServer$$anonfun$serveDynamicResource$2$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceServer$$anonfun$serveDynamicResource$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceServer$$anonfun$serveDynamicResource$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceServer$$anonfun$serveDynamicResource$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceServer$$anonfun$testGetResources$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceServer$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceServer$DynamicResource$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceServer$DynamicResource.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsResourceServer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsServer$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsServer$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsServer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsToSomething$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsToSomething$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsToSomething$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsToSomething$Stage1CacheableState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsToSomething$Stage2CacheableState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsToSomething$Stage2TransientState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsToSomething$StaticStateBits$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsToSomething$StaticStateBits.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsToSomething.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsToXHTML$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsToXHTML$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsToXHTML.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsURIResolver$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\processor\XFormsURIResolver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\schema\MSVGrammarReaderController$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\schema\MSVGrammarReaderController$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\schema\MSVGrammarReaderController.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\schema\SchemaDependencies$$anonfun$areIncludesUnchanged$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\schema\SchemaDependencies.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\schema\SchemaInfo$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\schema\SchemaInfo.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\schema\SchemaKey$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\schema\SchemaKey.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\script\CoffeeScriptCompiler$$anonfun$compilerScope$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\script\CoffeeScriptCompiler$$anonfun$compilerScope$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\script\CoffeeScriptCompiler$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\script\CoffeeScriptCompiler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\script\ScriptInterpreter$ORBEON$Controls.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\script\ScriptInterpreter$ORBEON.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\script\ScriptInterpreter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\script\ServerScript.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\Script$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\Script.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\AnnotatedTemplate$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\AnnotatedTemplate.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\ControlState$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\ControlState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$$anonfun$1$$anonfun$apply$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$$anonfun$1$$anonfun$apply$4$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$$anonfun$1$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$$anonfun$apply$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$$anonfun$apply$11.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$$anonfun$apply$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$$anonfun$apply$13.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$$anonfun$apply$8.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$$anonfun$apply$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$$anonfun$debug$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$$anonfun$debug$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$$anonfun$decodeAnnotatedTemplate$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$$anonfun$decodeInstancesControls$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$$anonfun$org$orbeon$oxf$xforms$state$DynamicState$$instanceToXML$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$$anonfun$toXML$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$$anonfun$toXML$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$$anonfun$toXML$3$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$$anonfun$toXML$3$$anonfun$apply$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$$anonfun$toXML$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$$anonfun$toXML$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\DynamicState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\EhcacheStateStore$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\EhcacheStateStore$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\EhcacheStateStore$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\EhcacheStateStore.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\InstancesControls$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\InstancesControls.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\InstanceState$$anonfun$$init$$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\InstanceState$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\InstanceState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\JavaLongUTF$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\JavaLongUTF$StringFormat$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\JavaLongUTF.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsDocumentCache.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsOperations$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsOperations.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsProtocols$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsProtocols$ControlFormat$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsProtocols$Dom4jFormat$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsProtocols$DynamicStateFormat$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsProtocols$InstanceCachingFormat$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsProtocols$InstanceFormat$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsProtocols$JavaInputStream.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsProtocols$JavaOutputStream.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsProtocols$PathMatcherFormat$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsProtocols$QNameFormat$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsProtocols$SAXStoreFormat$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsProtocols$SerializableFormat$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsProtocols$SerializableFormat.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsProtocols.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsState$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsState.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsStateLifecycle$RequestParameters.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsStateLifecycle.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsStateManager$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsStateManager$RequestParametersImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsStateManager$SessionDocument.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsStateManager.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsStateStore.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsStateStoreFactory$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsStateStoreFactory.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsStaticStateCache$$anonfun$createCacheKey$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsStaticStateCache$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsStaticStateCache$CacheTracer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\state\XFormsStaticStateCache.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$abstractBindings$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$collectInParts$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$collectInPartsJ$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$collectInPartsReverse$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$containingScope$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$controlsByName$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$findClosestCommonAncestorRepeat$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$findControlAnalysis$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$findInParts$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$findInPartsOpt$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$getAncestorOrSelfRepeats$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$getAncestorRepeatIds$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$getAncestorRepeatIds$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$getAncestorRepeatIds$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$getAttributeControl$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$getBinding$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$getBindingId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$getGlobals$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$getInstances$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$getMark$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$getModelsForScope$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$getRepeatHierarchyString$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$getXBLScripts$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$getXBLStyles$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$hasAttributeControl$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$hasControlAppearance$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$hasControlByName$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$hasHandlerForEvent$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$hasHandlerForEvent$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$hasInputPlaceholder$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$isComponent$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$jBindingQNames$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$keypressHandlers$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$removePart$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$repeats$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$scopeForPrefixedId$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$scripts$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps$$anonfun$uniqueClientScripts$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\StaticStateGlobalOps.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\AllReplacer$ReplaceAllResponse.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\AllReplacer.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\AsynchronousSubmissionManager$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\AsynchronousSubmissionManager$AsynchronousSubmissions.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\AsynchronousSubmissionManager.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\BaseReplacer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\BaseSubmission$$anon$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\BaseSubmission$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\BaseSubmission$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\BaseSubmission$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\BaseSubmission$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\BaseSubmission.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\CacheableSubmission$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\CacheableSubmission$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\CacheableSubmission$ThrowableWrapper.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\CacheableSubmission.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\ClientGetAllSubmission.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\EchoSubmission.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\InstanceReplacer$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\InstanceReplacer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\LocalPortletSubmission$1$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\LocalPortletSubmission$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\LocalPortletSubmission$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\LocalPortletSubmission.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\NoneReplacer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\RedirectReplacer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\RegularSubmission$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\RegularSubmission.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\Replacer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\RequestDispatcherSubmission$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\RequestDispatcherSubmission$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\RequestDispatcherSubmission.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\Submission.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\SubmissionHeaders$$anonfun$evaluateHeaders$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\SubmissionHeaders$$anonfun$evaluateHeaders$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\SubmissionHeaders$$anonfun$existingHeaderValues$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\SubmissionHeaders$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\SubmissionHeaders.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\SubmissionProcess.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\SubmissionResult.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\SubmissionUtils$$anonfun$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\SubmissionUtils$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\SubmissionUtils$$anonfun$forwardResponseHeaders$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\SubmissionUtils$$anonfun$forwardResponseHeaders$2$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\SubmissionUtils$$anonfun$forwardResponseHeaders$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\SubmissionUtils$$anonfun$openGETConnection$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\SubmissionUtils$$anonfun$readByteArray$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\SubmissionUtils$$anonfun$readTinyTree$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\SubmissionUtils$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\SubmissionUtils.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\TextReplacer$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\TextReplacer$$anonfun$replace$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\TextReplacer$$anonfun$replace$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\TextReplacer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmission$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmission$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmission$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmission$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmission$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmission$SecondPassParameters.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmission$SerializationParameters.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmission$SubmissionParameters.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmission.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$$anon$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$$anon$3$$anonfun$visit$1$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$$anon$3$$anonfun$visit$1$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$$anon$3$$anonfun$visit$1$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$$anon$3$$anonfun$visit$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$$anon$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$$anonfun$annotateWithAlerts$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$$anonfun$controlsIterator$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$$anonfun$defaultSerialization$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$$anonfun$org$orbeon$oxf$xforms$submission$XFormsModelSubmissionBase$$annotateElementIfPossible$1$1$$anonfun$apply$2$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$$anonfun$org$orbeon$oxf$xforms$submission$XFormsModelSubmissionBase$$annotateElementIfPossible$1$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$$anonfun$org$orbeon$oxf$xforms$submission$XFormsModelSubmissionBase$$annotateElementIfPossible$1$1$$anonfun$apply$3$$anonfun$apply$4$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$$anonfun$org$orbeon$oxf$xforms$submission$XFormsModelSubmissionBase$$annotateElementIfPossible$1$1$$anonfun$apply$3$$anonfun$apply$4$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$$anonfun$org$orbeon$oxf$xforms$submission$XFormsModelSubmissionBase$$annotateElementIfPossible$1$1$$anonfun$apply$3$$anonfun$apply$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$$anonfun$org$orbeon$oxf$xforms$submission$XFormsModelSubmissionBase$$annotateElementIfPossible$1$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$$anonfun$org$orbeon$oxf$xforms$submission$XFormsModelSubmissionBase$$annotateElementIfPossible$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$$anonfun$pruneNonRelevantNodes$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$$anonfun$pruneNonRelevantNodes$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$$anonfun$requestedSerialization$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$Private$$anonfun$findNextNodeToDetach$1$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$Private$$anonfun$findNextNodeToDetach$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$Private$$anonfun$findNextNodeToDetach$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase$Private$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsModelSubmissionBase.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsSubmissionException.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsSubmissionUtils$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsSubmissionUtils$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsSubmissionUtils$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\submission\XFormsSubmissionUtils.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\Variable$RewrappingSequenceIterator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\Variable.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\VariableNameValue$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\VariableNameValue.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$$anonfun$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$$anonfun$5$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$$anonfun$5$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$$anonfun$5$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$$anonfun$5$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$$anonfun$6$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$$anonfun$7$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$$anonfun$8$$anonfun$apply$8.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$$anonfun$findOrCreate$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$$anonfun$newTransform$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$$anonfun$org$orbeon$oxf$xforms$xbl$AbstractBinding$$templateRootOption$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$$anonfun$transformConfig$1$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$$anonfun$transformConfig$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$$anonfun$transformQNameOption$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\AbstractBinding.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\BindingCache$$anonfun$get$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\BindingCache$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\BindingCache.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\BindingDescriptor$$anonfun$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\BindingDescriptor$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\BindingDescriptor$$anonfun$createDirectToDatatypeMappingsForAllBindings$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\BindingDescriptor$$anonfun$createDirectToDatatypeMappingsForAllBindings$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\BindingDescriptor$$anonfun$datatypeBindingPF$1$$anonfun$applyOrElse$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\BindingDescriptor$$anonfun$datatypeBindingPF$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\BindingDescriptor$$anonfun$directBindingPF$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\BindingDescriptor$$anonfun$findCurrentBinding$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\BindingDescriptor$$anonfun$findDatatypeDescriptor$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\BindingDescriptor$$anonfun$findDirectBindingForDatatypeBinding$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\BindingDescriptor$$anonfun$findFirstDirectBinding$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\BindingDescriptor$$anonfun$getAllDirectAndDatatypeDescriptors$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\BindingDescriptor$$anonfun$getAllDirectAndDatatypeDescriptors$2$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\BindingDescriptor$$anonfun$getAllDirectAndDatatypeDescriptors$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\BindingDescriptor$$anonfun$org$orbeon$oxf$xforms$xbl$BindingDescriptor$$findDirectDescriptor$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\BindingDescriptor$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\BindingDescriptor.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ConcreteBinding$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ConcreteBinding$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ConcreteBinding.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ContainerResolver$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ContainerResolver$$anonfun$containsBind$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ContainerResolver$$anonfun$findInstance$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ContainerResolver$$anonfun$findInstance$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ContainerResolver$$anonfun$findInstanceInDescendantOrSelf$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ContainerResolver$$anonfun$findInstanceInDescendantOrSelf$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ContainerResolver$$anonfun$fromConcreteRepeat$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ContainerResolver$$anonfun$getFirstControlEffectiveId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ContainerResolver$$anonfun$getInstanceForNode$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ContainerResolver$$anonfun$getInstanceForNode$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ContainerResolver$$anonfun$getObjectByEffectiveId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ContainerResolver$$anonfun$getObjectByEffectiveId$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ContainerResolver$$anonfun$getRepeatIndex$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ContainerResolver$$anonfun$getRepeatIndex$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ContainerResolver$$anonfun$resolveObjectById$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ContainerResolver$$anonfun$resolveObjectById$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ContainerResolver$class.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ContainerResolver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\CSSParser$$anonfun$toXPath$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\CSSParser$$anonfun$toXPath$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\CSSParser$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\CSSParser.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ModelContainer$$anonfun$addAllModels$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ModelContainer$$anonfun$addAllModels$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ModelContainer$$anonfun$allModels$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ModelContainer$$anonfun$allModels$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ModelContainer$$anonfun$destroyModels$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ModelContainer$$anonfun$initializeModels$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ModelContainer$$anonfun$initializeModels$2$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ModelContainer$$anonfun$initializeModels$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ModelContainer$$anonfun$restoreModelsState$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ModelContainer$$anonfun$restoreModelsState$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ModelContainer$$anonfun$searchContainedModels$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ModelContainer$$anonfun$searchContainedModels$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ModelContainer$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\ModelContainer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\RefreshSupport$$anonfun$needRebuildRecalculateRevalidate$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\RefreshSupport$$anonfun$rebuildRecalculateRevalidateIfNeeded$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\RefreshSupport$$anonfun$setDeferredFlagsForSetindex$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\RefreshSupport$$anonfun$startOutermostActionHandler$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\RefreshSupport$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\RefreshSupport.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\Scope.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\Transform$$anonfun$transformBoundElement$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\Transform$$anonfun$transformXBLDocument$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\Transform$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\Transform.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anon$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anon$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$10.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$11.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$12.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$14.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$15.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$16.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$17.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$5$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$5$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$9.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$annotateAndExtractSubtree$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$annotateAndExtractSubtree$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$annotateAndExtractSubtree$3$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$annotateAndExtractSubtree$3$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$annotateAndExtractSubtree$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$annotateSubtree1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$annotateSubtree1$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$annotateSubtree1$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$getBindingId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$org$orbeon$oxf$xforms$xbl$XBLBindings$$generateRawShadowTree$1$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$org$orbeon$oxf$xforms$xbl$XBLBindings$$generateRawShadowTree$1$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$org$orbeon$oxf$xforms$xbl$XBLBindings$$generateRawShadowTree$1$$anonfun$apply$8$$anonfun$13.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$org$orbeon$oxf$xforms$xbl$XBLBindings$$generateRawShadowTree$1$$anonfun$apply$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$org$orbeon$oxf$xforms$xbl$XBLBindings$$generateRawShadowTree$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$org$orbeon$oxf$xforms$xbl$XBLBindings$$registerXBLBindings$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$org$orbeon$oxf$xforms$xbl$XBLBindings$$withProcessAutomaticXBL$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$org$orbeon$oxf$xforms$xbl$XBLBindings$$withProcessAutomaticXBL$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$org$orbeon$oxf$xforms$xbl$XBLBindings$$withProcessAutomaticXBL$3$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$org$orbeon$oxf$xforms$xbl$XBLBindings$$withProcessAutomaticXBL$3$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$org$orbeon$oxf$xforms$xbl$XBLBindings$$withProcessAutomaticXBL$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$processElementIfNeeded$1$$anonfun$apply$2$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$processElementIfNeeded$1$$anonfun$apply$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$$anonfun$processElementIfNeeded$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$Global$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$Global.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings$ScopeExtractor.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLBindings.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLContainer$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLContainer$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLContainer$$anonfun$ancestorsIterator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLContainer$$anonfun$ancestorsIterator$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLContainer$$anonfun$findScopeRoot$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLContainer$$anonfun$findScopeRoot$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLContainer$$anonfun$partAnalysis$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLContainer$$anonfun$removeChild$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLContainer$$anonfun$updateEffectiveId$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLContainer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$$anonfun$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$$anonfun$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$$anonfun$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$$anonfun$automaticMappings$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$$anonfun$baselineResources$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$$anonfun$fromCache$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$$anonfun$getAutomaticXBLMappingPath$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$$anonfun$matchReferenceElements$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$$anonfun$orderedHeadElements$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$$anonfun$org$orbeon$oxf$xforms$xbl$XBLResources$$evaluate$2$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$$anonfun$org$orbeon$oxf$xforms$xbl$XBLResources$$evaluate$2$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$$anonfun$org$orbeon$oxf$xforms$xbl$XBLResources$$fromFileThenCache$1$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$$anonfun$org$orbeon$oxf$xforms$xbl$XBLResources$$fromFileThenCache$1$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$$anonfun$org$orbeon$oxf$xforms$xbl$XBLResources$$fromFileThenCache$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$$anonfun$org$orbeon$oxf$xforms$xbl$XBLResources$$getBinding$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$$anonfun$outputResources$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$$anonfun$outputResources$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$$anonfun$outputResources$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$HeadElement$$anonfun$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$HeadElement$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$HeadElement.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$InlineElement$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$InlineElement.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$ReferenceElement$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources$ReferenceElement.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLResources.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLTransformer$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\xbl\XBLTransformer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsCompressor$$anonfun$compressBytesMeasurePerformance$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsCompressor$$anonfun$compressBytesMeasurePerformance$2$$anonfun$apply$1$$anonfun$apply$mcV$sp$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsCompressor$$anonfun$compressBytesMeasurePerformance$2$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsCompressor$$anonfun$compressBytesMeasurePerformance$2$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsCompressor$$anonfun$compressBytesMeasurePerformance$2$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsCompressor$$anonfun$compressBytesMeasurePerformance$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsCompressor$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsCompressor$DeflaterGZIPOutputStream.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsCompressor$DeflaterPoolableObjectFactory$$anonfun$makeObject$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsCompressor$DeflaterPoolableObjectFactory$$anonfun$makeObject$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsCompressor$DeflaterPoolableObjectFactory$$anonfun$passivateObject$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsCompressor$DeflaterPoolableObjectFactory$$anonfun$passivateObject$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsCompressor$DeflaterPoolableObjectFactory.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsCompressor.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsConstants$DeploymentType.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsConstants$LHHA.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsConstants$XXBLScope.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsConstants.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsContainingDocument$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsContainingDocument$2$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsContainingDocument$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsContainingDocument$DelayedEvent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsContainingDocument$Load.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsContainingDocument$Message.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsContainingDocument$Script.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsContainingDocument.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsContainingDocumentBase$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsContainingDocumentBase.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsContextStack.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsControls$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsControls$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsControls$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsControls.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsDocumentLifecycle.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsError$$anonfun$handleNonFatalSetvalueError$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsError$$anonfun$handleNonFatalSetvalueError$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsError$$anonfun$handleNonFatalXFormsError$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsError$$anonfun$handleNonFatalXFormsError$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsError$$anonfun$outputAjaxErrors$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsError$$anonfun$outputNoscriptErrorPanel$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsError$$anonfun$outputNoscriptErrorPanel$2$$anonfun$6.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsError$$anonfun$outputNoscriptErrorPanel$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsError$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsError$ServerError$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsError$ServerError$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsError$ServerError$$anonfun$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsError$ServerError$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsError$ServerError$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsError$ServerError$$anonfun$collectSeq$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsError$ServerError$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsError$ServerError.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsError.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstance$$anon$1$$anonfun$addMIPInfo$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstance$$anon$1$$anonfun$addMIPInfo$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstance$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstance$$anonfun$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstance$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstance$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstance$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstance$$anonfun$contentAsString$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstance$$anonfun$contentAsString$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstance$$anonfun$logContent$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstance$$anonfun$logContent$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstance$$anonfun$performDefaultAction$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstance$$anonfun$performDefaultAction$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstance$$anonfun$updateRepeatNodesets$1$$anonfun$apply$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstance$$anonfun$updateRepeatNodesets$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstance$$anonfun$updateRepeatNodesets$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstance$$anonfun$wrapDocumentInfo$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstance$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstance.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstanceIndex$$anon$2$ElementOrdering$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstanceIndex$$anon$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstanceIndex$$anonfun$org$orbeon$oxf$xforms$XFormsInstanceIndex$$addId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstanceIndex$$anonfun$org$orbeon$oxf$xforms$XFormsInstanceIndex$$combineMappings$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstanceIndex$$anonfun$org$orbeon$oxf$xforms$XFormsInstanceIndex$$combineMappings$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstanceIndex$$anonfun$org$orbeon$oxf$xforms$XFormsInstanceIndex$$mappingsInSubtree$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstanceIndex$$anonfun$org$orbeon$oxf$xforms$XFormsInstanceIndex$$removeId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstanceIndex$$anonfun$updateIndexForDelete$1$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstanceIndex$$anonfun$updateIndexForDelete$1$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstanceIndex$$anonfun$updateIndexForDelete$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstanceIndex$$anonfun$updateIndexForInsert$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstanceIndex$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsInstanceIndex.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModel$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModel$InstanceLoader.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModel.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$6$$anonfun$apply$7.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$6$$anonfun$apply$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$doRecalculate$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$doRecalculate$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$doRecalculate$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$doRecalculateRevalidate$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$doRevalidate$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$doRevalidate$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$doRevalidate$3$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$doRevalidate$3$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$doRevalidate$3$$anonfun$apply$3$$anon$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$doRevalidate$3$$anonfun$apply$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$doRevalidate$3$$anonfun$apply$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$doRevalidate$3$$anonfun$apply$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$doRevalidate$3$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$doRevalidate$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$org$orbeon$oxf$xforms$XFormsModelBase$$createAndCommitValidationEvents$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$org$orbeon$oxf$xforms$XFormsModelBase$$createAndCommitValidationEvents$1$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase$$anonfun$org$orbeon$oxf$xforms$XFormsModelBase$$_schemaValidator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBase.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBinds$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBinds$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBinds$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBinds$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBinds$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBinds$BindRunner.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBinds.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$1$$anonfun$apply$4$$anonfun$apply$5.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$1$$anonfun$apply$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$evaluateAndSetCustomMIPs$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$evaluateAndSetCustomMIPs$2$$anonfun$apply$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$evaluateAndSetCustomMIPs$2$$anonfun$apply$7.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$evaluateAndSetCustomMIPs$2$$anonfun$apply$8.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$evaluateAndSetCustomMIPs$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$failedConstraintMIPs$1$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$failedConstraintMIPs$1$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$failedConstraintMIPs$1$$anonfun$apply$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$failedConstraintMIPs$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$handleMIPXPathException$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$handleMIPXPathException$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$iterateBinds$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$rebuild$1$$anonfun$apply$mcV$sp$1$$anon$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$rebuild$1$$anonfun$apply$mcV$sp$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$rebuild$1$$anonfun$apply$mcV$sp$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$rebuild$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$rebuild$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$rebuild$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$reporter$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$validateConstraint$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase$$anonfun$validateConstraint$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelBindsBase.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelSchemaValidator$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelSchemaValidator$ValidationContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsModelSchemaValidator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsObject.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsObjectResolver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsProperties$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsProperties$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsProperties$PropertyDefinition.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsProperties.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$$anonfun$add$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$$anonfun$add$1$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$$anonfun$createCacheKey$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$$anonfun$createCacheKey$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$$anonfun$find$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$$anonfun$find$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$$anonfun$find$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$$anonfun$find$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$$anonfun$find$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$$anonfun$find$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$$anonfun$findContentOrLoad$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$$anonfun$findContentOrLoad$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$$anonfun$findContentOrNull$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$$anonfun$org$orbeon$oxf$xforms$XFormsServerSharedInstancesCache$$loadAndCache$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$$anonfun$org$orbeon$oxf$xforms$XFormsServerSharedInstancesCache$$loadAndCache$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$$anonfun$org$orbeon$oxf$xforms$XFormsServerSharedInstancesCache$$loadAndCache$1$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$$anonfun$remove$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$$anonfun$remove$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$$anonfun$removeAll$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$$anonfun$removeAll$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$CacheEntry$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$CacheEntry.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$InstanceContent$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$InstanceContent.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache$Loader.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsServerSharedInstancesCache.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$$anonfun$booleanPropertyMaybeAsExpression$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$$anonfun$clientNonDefaultProperties$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$$anonfun$createFromDocument$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$$anonfun$createFromStaticStateBits$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$$anonfun$createPart$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$$anonfun$intPropertyMaybeAsExpression$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$$anonfun$nonDefaultPropertiesOnly$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$$anonfun$org$orbeon$oxf$xforms$XFormsStaticStateImpl$$create$1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$$anonfun$propertyAsString$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$$anonfun$propertyMaybeAsExpression$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$$anonfun$stringPropertyMaybeAsExpression$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$Annotator$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$Extractor$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$StaticStateDocument$$anonfun$2$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$StaticStateDocument$$anonfun$2$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$StaticStateDocument$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$StaticStateDocument$$anonfun$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$StaticStateDocument$$anonfun$getOrComputeDigest$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$StaticStateDocument$$anonfun$isClientStateHandling$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$StaticStateDocument$$anonfun$nonDefault$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$StaticStateDocument$$anonfun$template$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl$StaticStateDocument.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsStaticStateImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsUtils$LHHAElementVisitorListener$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsUtils$LHHAElementVisitorListener.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xforms\XFormsUtils.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\AttributesAndElementsIterator$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\AttributesAndElementsIterator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\DeferredXMLReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\DeferredXMLReceiverAdapter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\DeferredXMLReceiverImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\DigestContentHandler.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\ConstantLocator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\Dom4jUtils$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\Dom4jUtils$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\Dom4jUtils$DebugXML.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\Dom4jUtils$VisitorListener.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\Dom4jUtils.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\ExtendedLocationData$$anonfun$$init$$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\ExtendedLocationData$$anonfun$$init$$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\ExtendedLocationData$$anonfun$$init$$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\ExtendedLocationData$$anonfun$$init$$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\ExtendedLocationData$$anonfun$$init$$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\ExtendedLocationData$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\ExtendedLocationData$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\ExtendedLocationData$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\ExtendedLocationData$$anonfun$arrayToPairs$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\ExtendedLocationData$$anonfun$getParameters$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\ExtendedLocationData$$anonfun$parametersString$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\ExtendedLocationData$$anonfun$toString$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\ExtendedLocationData$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\ExtendedLocationData.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\LocationData.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\LocationDocumentResult.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\LocationDocumentSource.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\LocationSAXContentHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\LocationSAXWriter$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\LocationSAXWriter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\NonLazySAXContentHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\NonLazyUserDataDocument.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\NonLazyUserDataDocumentFactory.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\dom4j\NonLazyUserDataElement.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\Dom4j$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\Dom4j$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\Dom4j$$anonfun$compareTwoNodeSeqs$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\Dom4j$$anonfun$dom4jElementSeqToScalaElemSeq$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\Dom4j$$anonfun$filterOut$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\Dom4j$$anonfun$scalaElemSeqToDom4jElementSeq$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\Dom4j$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\Dom4j$AttributeOrdering$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\Dom4j$QNameOps$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\Dom4j$QNameOps.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\Dom4j$QNameOrdering$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\Dom4j.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\ElementFilterXMLReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\ElementHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\ElementHandlerContext.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\ElementHandlerController$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\ElementHandlerController$HandlerInfo.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\ElementHandlerController$HandlerMatcher.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\ElementHandlerController$Matcher.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\ElementHandlerController.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\EmbeddedDocumentXMLReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\ExceptionWrapperXMLReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\FilterReceiver$$anonfun$endElement$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\FilterReceiver$$anonfun$endElement$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\FilterReceiver$$anonfun$startElement$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\FilterReceiver$$anonfun$startElement$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\FilterReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\ForwardingXMLReader.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\ForwardingXMLReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\HTMLBodyXMLReceiver.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\HTMLFragmentSerializer.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\InspectingXMLReceiver$NameInfo.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\InspectingXMLReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\JXQName$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\JXQName.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\NamespaceCleanupXMLReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\NamespaceContext$Context$$anonfun$mappingsWithDefault$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\NamespaceContext$Context$$anonfun$prefixes$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\NamespaceContext$Context$$anonfun$prefixesForURI$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\NamespaceContext$Context$$anonfun$prefixesWithDefault$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\NamespaceContext$Context$$anonfun$uriForPrefix$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\NamespaceContext$Context$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\NamespaceContext$Context.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\NamespaceContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\NamespaceMapping.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\NamingConvention.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\OrbeonFunctionLibrary$$anonfun$getEntry$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\OrbeonFunctionLibrary$Arg$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\OrbeonFunctionLibrary$Arg.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\OrbeonFunctionLibrary$Fun$$anonfun$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\OrbeonFunctionLibrary$Fun$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\OrbeonFunctionLibrary$Fun$$anonfun$apply$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\OrbeonFunctionLibrary$Fun$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\OrbeonFunctionLibrary$FunctionName$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\OrbeonFunctionLibrary$FunctionName.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\OrbeonFunctionLibrary$Namespace$$anonfun$apply$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\OrbeonFunctionLibrary$Namespace$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\OrbeonFunctionLibrary.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\OutputLocator$$anonfun$currentLocator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\OutputLocator$$anonfun$getColumnNumber$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\OutputLocator$$anonfun$getColumnNumber$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\OutputLocator$$anonfun$getLineNumber$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\OutputLocator$$anonfun$getLineNumber$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\OutputLocator$$anonfun$getPublicId$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\OutputLocator$$anonfun$getSystemId$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\OutputLocator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\ProcessorOutputXMLReader.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\SaxonUtils$$anonfun$compareItemSeqs$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\SaxonUtils$$anonfun$compareValues$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\SaxonUtils$$anonfun$makeNCName$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\SaxonUtils$$anonfun$makeNCName$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\SaxonUtils$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\SaxonUtils.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\saxrewrite\DocumentRootState.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\saxrewrite\FragmentRootState.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\saxrewrite\State.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\saxrewrite\StatefulHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\SAXStore$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\SAXStore$Mark.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\SAXStore.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\SAXUtils.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\SchemaRepository.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\ShareableXPathStaticContext$$anonfun$issueWarning$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\ShareableXPathStaticContext$$anonfun$issueWarning$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\ShareableXPathStaticContext$NSResolver$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\ShareableXPathStaticContext$VariableBinding.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\ShareableXPathStaticContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\SimpleForwardingXMLReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\TeeXMLReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\TransformerHandlerWrapper.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\TransformerUtils.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\TransformerWrapper.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\URLLocator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\WhitespaceXMLReceiver$StackElement$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\WhitespaceXMLReceiver$StackElement.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\WhitespaceXMLReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\xerces\OrbeonParserConfiguration.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\xerces\XercesJAXPSAXParser$XercesDefaultValidationErrorHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\xerces\XercesJAXPSAXParser.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\xerces\XercesSAXParser.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\xerces\XercesSAXParserFactoryImpl.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XIncludeReceiver$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XIncludeReceiver$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XIncludeReceiver$$anonfun$ancestors$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XIncludeReceiver$$anonfun$ancestors$1$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XIncludeReceiver$$anonfun$findPending$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XIncludeReceiver$$anonfun$playEndPrefixMappings$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XIncludeReceiver$$anonfun$playEndPrefixMappings$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XIncludeReceiver$$anonfun$playStartPrefixMappings$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XIncludeReceiver$$anonfun$playStartPrefixMappings$2.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XIncludeReceiver$$anonfun$relevantContexts$1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XIncludeReceiver$$anonfun$relevantContexts$1$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XIncludeReceiver$$anonfun$startElement$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XIncludeReceiver$$anonfun$startElement$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XIncludeReceiver$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XIncludeReceiver$ElementContext$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XIncludeReceiver$ElementContext.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XIncludeReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XMLConstants.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XMLParsing$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XMLParsing$EntityResolver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XMLParsing$ErrorHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XMLParsing$ParserConfiguration.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XMLParsing$XMLFragmentReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XMLParsing.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XMLReaderToReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XMLReceiver.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XMLReceiverAdapter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XMLReceiverHelper$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XMLReceiverHelper$ElementInfo.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XMLReceiverHelper.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XMLReceiverSupport$$anonfun$addAttributes$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XMLReceiverSupport$$anonfun$element$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XMLReceiverSupport$$anonfun$element$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XMLReceiverSupport$$anonfun$processingInstruction$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XMLReceiverSupport$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XMLReceiverSupport.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XMLUtils.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XPathUtils$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XPathUtils$IteratorFilter.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XPathUtils.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XPathXMLReceiver$Expression.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XPathXMLReceiver$ExpressionSearchHandler.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XPathXMLReceiver$Handler1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\oxf\xml\XPathXMLReceiver.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\saxon\dom4j\TypedDocumentWrapper.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\saxon\dom4j\TypedNodeWrapper$TypedValueException.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\saxon\dom4j\TypedNodeWrapper.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\saxon\event\HTML1252Emitter.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\saxon\event\XML1252Emitter.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\saxon\expr\PathMap$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\saxon\expr\PathMap$PathMapArc.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\saxon\expr\PathMap$PathMapNode.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\saxon\expr\PathMap$PathMapNodeSet.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\saxon\expr\PathMap$PathMapRoot.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\saxon\expr\PathMap.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\saxon\number\Numberer_es.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\saxon\number\Numberer_fi.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\saxon\number\Numberer_no.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\saxon\number\Numberer_pl.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\saxon\number\Numberer_pt.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\saxon\number\Numberer_ru.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\saxon\number\Numberer_sv.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\DocumentAndElementsCollector.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\FSM$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\FSM$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\FSM$Event$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\FSM$Event.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\FSM$State$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\FSM$State.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\FSM.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$Atts$$anonfun$getIndex$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$Atts$$anonfun$getIndex$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$Atts$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$Atts.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$Characters$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$Characters.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$Comment$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$Comment.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$DocumentLocator$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$DocumentLocator.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$EndDocument$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$EndElement$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$EndElement.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$EndPrefixMapping$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$EndPrefixMapping.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$PI$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$PI.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$SAXEvent.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$StartDocument$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$StartElement$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$StartElement.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$StartPrefixMapping$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents$StartPrefixMapping.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXEvents.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXMachine$class.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\SAXMachine.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$$anon$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$$anon$3.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$$anonfun$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$$anonfun$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$$anonfun$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$$anonfun$4.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$$anonfun$5$$anon$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$$anonfun$5.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$$anonfun$6.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$$anonfun$asStringSequenceIterator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$$anonfun$hasNonEmptyChildNode$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$$anonfun$itemSeqToStringOption$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$$anonfun$org$orbeon$scaxon$XML$$prefixesForURIImpl$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$$anonfun$stringSeqToSequenceIterator$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$AndTest.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$AnyTest$.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$ExceptTest.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$LocalNameOnlyTest.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NameOnlyTest.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoOps$$anonfun$namespaceMappings$extension$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoOps$$anonfun$nonEmptyPrefixesForURI$extension$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoOps$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoOps.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoSeqOps$$anonfun$$bslash$bslash$extension$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoSeqOps$$anonfun$$div$at$extension0$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoSeqOps$$anonfun$$div$at$extension1$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoSeqOps$$anonfun$$div$at$extension2$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoSeqOps$$anonfun$$div$at$extension3$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoSeqOps$$anonfun$$div$extension$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoSeqOps$$anonfun$$eq$eq$eq$extension$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoSeqOps$$anonfun$ancestor$extension$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoSeqOps$$anonfun$ancestorOrSelf$extension$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoSeqOps$$anonfun$attValue$extension0$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoSeqOps$$anonfun$attValue$extension1$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoSeqOps$$anonfun$descendantOrSelf$extension$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoSeqOps$$anonfun$following$extension$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoSeqOps$$anonfun$followingSibling$extension$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoSeqOps$$anonfun$parent$extension$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoSeqOps$$anonfun$preceding$extension$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoSeqOps$$anonfun$precedingSibling$extension$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoSeqOps$$anonfun$self$extension$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoSeqOps$$anonfun$sibling$extension$1.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoSeqOps$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeInfoSeqOps.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeKindTestBase.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeLocalNameTest$$anonfun$test$1.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeLocalNameTest$$anonfun$test$2.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeLocalNameTest$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeLocalNameTest.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeQNameTest$$anonfun$test$3.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeQNameTest$$anonfun$test$4.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeQNameTest$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$NodeQNameTest.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$OrTest.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML$Test.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\scaxon\XML.class"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\classes\org\orbeon\xbl\SimpleCaptcha$.class;PROJECTROOT0_MARKER\build\classes\org\orbeon\xbl\SimpleCaptcha.class;PROJECTROOT0_MARKER\build\lib\mpn-app-cli.jar;PROJECTROOT0_MARKER\build\lib\mpn-app-form-builder.jar;PROJECTROOT0_MARKER\build\lib\mpn-app-form-runner.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\lib\mpn-app-resources-private.jar;PROJECTROOT0_MARKER\build\lib\mpn-app-resources-public.jar;PROJECTROOT0_MARKER\build\lib\mpn-app-xforms-filter.jar;PROJECTROOT0_MARKER\build\lib\mpn-app.jar;PROJECTROOT0_MARKER\build\lib\orbeon-embedding.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\commons-cli-1_0.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\activation-1.1.1.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\ant-1_6_5.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\ant-jsch-1_6_5.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\apache-mime4j-0.6.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\avalon-framework-4_2_0.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\axis_1_2_1-axis.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\axis_1_2_1-jaxrpc.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\axis_1_2_1-saaj.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\axis_1_2_1-wsdl4j-1.5.1.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\barcode4j-1.0.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\batic-dependency-xmlgraphics-commons-1.4.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\batik-all-1_7.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\castor-0_9_4_3-xml.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\commons-beanutils-1_5.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\commons-cli-1_0.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\commons-codec-1.6.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\commons-collections-3.2.1.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\commons-digester-1_5.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\commons-discovery-0.4.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\commons-fileupload-1.2.2.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\commons-io-2.0.1.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\commons-lang3-3.1.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\commons-pool-1.6.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\commons-validator-1.4.0.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\dom4j-1_6_1.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\ehcache-core-2.6.3.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\exist-1_4_1_dev_orbeon_20110104.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\exist-dependency-antlr-2.7.7.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\exist-dependency-jgroups-all-2.2.6.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\exist-dependency-jta-1.1.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\exist-dependency-lucene-core-2.9.2.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\exist-dependency-lucene-regex-2.9.2.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\exist-dependency-quartz-1.6.6.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\exist-dependency-resolver-1.2.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\exist-dependency-stax-api-1.0.1.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\exist-dependency-ws-commons-util-1.0.2.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\exist-dependency-xmldb.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\exist-dependency-xmlrpc-client-3.1.2.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\exist-dependency-xmlrpc-common-3.1.2.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\exist-dependency-xmlrpc-server-3.1.2.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\exist-lucene-module-1_4_1_dev_orbeon_20110104.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\exist-modules-1_4_1_dev_orbeon_20110104.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\exist-ngram-module-1_4_1_dev_orbeon_20110104.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\exist-optional-1_4_1_dev_orbeon_20110104.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\exist-xqj-1.0.1.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\flying-saucer-core-9.0.2-20140523.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\flying-saucer-dependency-itext-2.1.7.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\flying-saucer-pdf-9.0.2-20140523.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\fop-1_0.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\httpclient-4.3.5.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\httpcore-4.3.2.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\httpmime-4.3.5.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\itext-bcmail-jdk14-138.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\itext-bcprov-jdk14-138.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\jakarta-poi-1.11.0-dev-20030610.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\jaxen-1_1_beta_9.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\jcifs-1.3.14.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\jcl-over-slf4j-1.7.7.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\jfreechart-1.0.9.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\jfreechart-dependency-jcommon-1.0.12.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\jms-api-1_1.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\joda-time-2.1.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\jsch-0.1.42.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\jtidy-8.0-20060801.131059-3.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\log4j-1.2.17.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\mail-1_3_2.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\metadata-extractor-2.7.0.SNAPSHOT.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\metadata-extractor-dependency-xmpcore-5.1.2.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\mpn-app-form-builder.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\mpn-app-form-runner.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\mpn-app-resources-private.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\mpn-app-resources-public.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\mpn-app-xforms-filter.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\mpn-app.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\msv-20081113-orbeon.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\orbeon-errorified-20130923.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\parboiled-core-1.1.4.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\parboiled-scala_2.10-1.1.4.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\pdfbox-0_7_1.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\rhino-1.7R2.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\saxon-9-1-0-8_orbeon_20131113.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\saxpath-dev_orbeon.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\sbinary_2.10-0.4.1.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\scala-library-2.10.3.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\simplecaptcha-1.2.1.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\slf4j-api-1.7.7.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\slf4j-log4j12-1.7.7.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\spray-json_2.10-1.2.3.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\tagsoup-1.2.jar"
REM ARGS "-cp"
REM ARGS "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\xerces-2.11-orbeon.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\xqj2-0.0.1.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\lib\xqjapi.jar;PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\mpn-app-cli.jar"
REM ARGS "-source"
REM ARGS "1.7"
REM ARGS -exclude "PROJECTROOT0_MARKER\**\*.htm"
REM ARGS -exclude "PROJECTROOT0_MARKER\**\*.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\**\*.java"
REM ARGS -exclude "PROJECTROOT0_MARKER\**\*.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\**\*.ini"
REM ARGS -exclude "PROJECTROOT0_MARKER\**\*.jsp"
REM ARGS -exclude "PROJECTROOT0_MARKER\**\*.jspx"
REM ARGS -exclude "PROJECTROOT0_MARKER\**\*.tag"
REM ARGS -exclude "PROJECTROOT0_MARKER\**\*.tagx"
REM ARGS -exclude "PROJECTROOT0_MARKER\**\*.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\**\*.faces"
REM ARGS -exclude "PROJECTROOT0_MARKER\**\*.jsff"
REM ARGS -exclude "PROJECTROOT0_MARKER\**\*.php"
REM ARGS -exclude "PROJECTROOT0_MARKER\**\*.ctp"
REM ARGS -exclude "PROJECTROOT0_MARKER\**\*.sql"
REM ARGS -exclude "PROJECTROOT0_MARKER\**\*.pks"
REM ARGS -exclude "PROJECTROOT0_MARKER\**\*.pkh"
REM ARGS -exclude "PROJECTROOT0_MARKER\**\*.pkb"
REM ARGS -exclude "PROJECTROOT0_MARKER\**\*.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\**\*.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\**\*.xmi"
REM ARGS -exclude "PROJECTROOT0_MARKER\**\*.wsdd"
REM ARGS -exclude "PROJECTROOT0_MARKER\**\*.config"
REM ARGS -exclude "PROJECTROOT0_MARKER\build.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\third-party-licenses\cpl.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\tests\index.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\less\tests\buttons.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\less\tests\css-tests.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\less\tests\forms-responsive.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\less\tests\forms.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\less\tests\navbar-fixed-top.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\less\tests\navbar-static-top.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\less\tests\navbar.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\container-ariaplugin.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\container-ariaplugin_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\container-ariaplugin_log.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\container-effect.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\container-effect_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\container-effect_log.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\dialog-quickstart.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\dialog-quickstart_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\dialog-quickstart_log.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\index.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\keylistener.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\keylistener_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\keylistener_log.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\module.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\module_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\module_log.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\overlay.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\overlaymanager.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\overlaymanager_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\overlaymanager_log.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\overlay_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\overlay_log.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\panel-loading.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\panel-loading_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\panel-loading_log.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\panel-resize.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\panel-resize_source.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\panel.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\panelskin1.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\panelskin1_source.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\panelskin2.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\panelskin2_source.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\panel_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\panel_log.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\simpledialog-quickstart.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\simpledialog-quickstart_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\simpledialog-quickstart_log.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\tooltip-multi.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\tooltip-multi_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\tooltip-multi_log.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\tooltip.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\tooltip_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\tooltip_log.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\resize\anim_resize.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\resize\anim_resize_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\resize\eightway_resize.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\resize\eightway_resize_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\resize\ghost_resize.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\resize\ghost_resize_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\resize\grids_resize.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\resize\grids_resize_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\resize\index.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\resize\proxy_resize.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\resize\proxy_resize_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\resize\rte_resize.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\resize\rte_resize_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\resize\simple_resize.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\resize\simple_resize_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\resize\skinning_resize.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\customicons.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\customicons_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\customicons_log.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\default_tree.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\default_tree_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\default_tree_log.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\dynamic_tree.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\dynamic_tree_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\dynamic_tree_log.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\folder_style.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\folder_style_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\folder_style_log.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\index.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\menu_style.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\menu_style_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\menu_style_log.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\tv_edit.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\tv_edit_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\tv_highlight.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\tv_highlight_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\tv_markup.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\tv_markup_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\tv_tooltip.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\tv_tooltip_clean.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\tv_tooltip_log.html"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\classes\org\orbeon\oxf\xforms\msv\Messages.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\classes\org\orbeon\oxf\xforms\msv\Messages_ja.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\maven-archiver\pom.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\classes\content\Language-ext.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\classes\jboss-orbeon-example-roles.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\classes\jboss-orbeon-example-users.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\classes\org\orbeon\oxf\xforms\msv\Messages.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\classes\org\orbeon\oxf\xforms\msv\Messages_ja.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\liferay-plugin-package.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\StoreBean.java"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\DeepThoughtProcessor.java"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\DynamicOutputs.java"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\ListInputs.java"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\xforms\analysis\XPathAnalysisProcessor.java"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\classes\content\Language-ext.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\classes\jboss-orbeon-example-roles.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\classes\jboss-orbeon-example-users.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\liferay-plugin-package.properties"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\java-api\CallXSLT.java"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\java-properties\SystemProperties.java"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\classes\org\orbeon\oxf\xforms\script\coffee-script.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\classes\org\orbeon\oxf\xforms\script\coffee-script.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\assets\scripts\dateTime-Html-Format.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\assets\scripts\jquery.dataTables.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\assets\scripts\mpn-accordion.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\assets\scripts\mpn-overrides.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\assets\scripts\mpn-session.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\assets\scripts\mpn-table.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\orbeon\builder\resources\cell\action-icons-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\orbeon\builder\resources\cell\action-icons.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\orbeon\builder\resources\cell\control-resources-editor\actions-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\orbeon\builder\resources\cell\control-resources-editor\actions.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\orbeon\builder\resources\cell\control-resources-editor\events-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\orbeon\builder\resources\cell\control-resources-editor\events.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\orbeon\builder\resources\cell\control-resources-editor\placeholders-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\orbeon\builder\resources\cell\control-resources-editor\placeholders.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\orbeon\builder\resources\cell\events-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\orbeon\builder\resources\cell\events.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\orbeon\builder\resources\cell\placeholders-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\orbeon\builder\resources\cell\placeholders.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\orbeon\builder\resources\cell\static-upload-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\orbeon\builder\resources\cell\static-upload.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\orbeon\builder\resources\section-grid-repeat\grid-repeat-editor-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\orbeon\builder\resources\section-grid-repeat\grid-repeat-editor.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\orbeon\builder\resources\section-grid-repeat\position-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\orbeon\builder\resources\section-grid-repeat\position.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\orbeon\builder\resources\section-grid-repeat\section-editor-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\forms\orbeon\builder\resources\section-grid-repeat\section-editor.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\util\DeferredPortletLoader-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\util\DeferredPortletLoader.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\util\ExecutionQueue-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\util\FiniteStateMachine-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\util\FiniteStateMachine.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\util\fQuery-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\util\fQuery.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\util\String-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\util\String.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\action\Message-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\control\Calendar-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\control\Calendar.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\control\CalendarResources-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\control\Control-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\control\Placeholder-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\control\Placeholder.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\control\RTE-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\control\RTE.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\control\RTEConfig-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\control\RTEConfig.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\control\Tree-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\control\Upload-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\control\Upload.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\controls\Help-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\controls\Hint-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\controls\Placement-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\Document-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\Document.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\Form-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\Form.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\LoadingIndicator-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\LoadingIndicator.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\Page-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\server\AjaxServer\AjaxServerEvent-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\server\AjaxServer\AjaxServerEvent.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\server\AjaxServer\nextAjaxResponse-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\server\AjaxServer\nextAjaxResponse.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\server\AjaxServer-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\server\Server-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\orbeon\xforms\server\UploadServer-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\javascript\xforms-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\yui\button\button-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\yui\connection\connection-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\yui\container\container-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\yui\examples\treeview\assets\js\CheckOnClickNode-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\yui\examples\treeview\assets\js\TaskNode-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\ops\yui\treeview\treeview-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\xbl\fb\dialog-itemsets\dialog-itemsets-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\xbl\fb\dialog-itemsets\dialog-itemsets.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\xbl\orbeon\wpaint\wpaint-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\xbl\orbeon\wpaint\wpaint.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\apps\xforms-sandbox\samples\test-control-xhtml-area.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\apps\xforms-sandbox\samples\test-flat-repeat.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\apps\xforms-sandbox\samples\test-min-viewport-width.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\apps\xforms-sandbox\samples\test-placeholder.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\apps\xforms-sandbox\samples\test-type-date.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\apps\xforms-sandbox\samples\test-update-full.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\apps\xforms-sandbox\samples\unit-tests.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\forms\orbeon\builder\resources\cell\action-icons.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\forms\orbeon\builder\resources\cell\control-resources-editor\actions.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\forms\orbeon\builder\resources\cell\control-resources-editor\events.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\forms\orbeon\builder\resources\cell\control-resources-editor\placeholders.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\forms\orbeon\builder\resources\cell\events.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\forms\orbeon\builder\resources\cell\placeholders.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\forms\orbeon\builder\resources\cell\static-upload.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\forms\orbeon\builder\resources\section-grid-repeat\grid-repeat-editor.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\forms\orbeon\builder\resources\section-grid-repeat\position.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\forms\orbeon\builder\resources\section-grid-repeat\section-editor.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\ops\javascript\orbeon\util\DeferredPortletLoader.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\ops\javascript\orbeon\util\FiniteStateMachine.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\ops\javascript\orbeon\util\fQuery.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\ops\javascript\orbeon\util\String.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\ops\javascript\orbeon\xforms\control\Calendar.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\ops\javascript\orbeon\xforms\control\Placeholder.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\ops\javascript\orbeon\xforms\control\RTE.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\ops\javascript\orbeon\xforms\control\RTEConfig.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\ops\javascript\orbeon\xforms\control\Upload.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\ops\javascript\orbeon\xforms\Document.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\ops\javascript\orbeon\xforms\Form.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\ops\javascript\orbeon\xforms\LoadingIndicator.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\ops\javascript\orbeon\xforms\server\AjaxServer\AjaxServerEvent.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\ops\javascript\orbeon\xforms\server\AjaxServer\nextAjaxResponse.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\xbl\fb\dialog-itemsets\dialog-itemsets.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\js\xbl\orbeon\wpaint\wpaint.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\apps\xforms-sandbox\samples\test-control-xhtml-area-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\apps\xforms-sandbox\samples\test-control-xhtml-area.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\apps\xforms-sandbox\samples\test-flat-repeat-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\apps\xforms-sandbox\samples\test-flat-repeat.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\apps\xforms-sandbox\samples\test-min-viewport-width-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\apps\xforms-sandbox\samples\test-min-viewport-width.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\apps\xforms-sandbox\samples\test-placeholder-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\apps\xforms-sandbox\samples\test-placeholder.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\apps\xforms-sandbox\samples\test-type-date-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\apps\xforms-sandbox\samples\test-type-date.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\apps\xforms-sandbox\samples\test-update-full-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\apps\xforms-sandbox\samples\test-update-full.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\apps\xforms-sandbox\samples\unit-tests-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\apps\xforms-sandbox\samples\unit-tests.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\forms\orbeon\builder\resources\cell\action-icons-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\forms\orbeon\builder\resources\cell\action-icons.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\forms\orbeon\builder\resources\cell\control-resources-editor\actions-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\forms\orbeon\builder\resources\cell\control-resources-editor\actions.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\forms\orbeon\builder\resources\cell\control-resources-editor\events-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\forms\orbeon\builder\resources\cell\control-resources-editor\events.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\forms\orbeon\builder\resources\cell\control-resources-editor\placeholders-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\forms\orbeon\builder\resources\cell\control-resources-editor\placeholders.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\forms\orbeon\builder\resources\cell\events-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\forms\orbeon\builder\resources\cell\events.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\forms\orbeon\builder\resources\cell\placeholders-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\forms\orbeon\builder\resources\cell\placeholders.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\forms\orbeon\builder\resources\cell\static-upload-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\forms\orbeon\builder\resources\cell\static-upload.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\forms\orbeon\builder\resources\section-grid-repeat\grid-repeat-editor-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\forms\orbeon\builder\resources\section-grid-repeat\grid-repeat-editor.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\forms\orbeon\builder\resources\section-grid-repeat\position-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\forms\orbeon\builder\resources\section-grid-repeat\position.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\forms\orbeon\builder\resources\section-grid-repeat\section-editor-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\forms\orbeon\builder\resources\section-grid-repeat\section-editor.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\util\DeferredPortletLoader-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\util\DeferredPortletLoader.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\util\ExecutionQueue-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\util\FiniteStateMachine-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\util\FiniteStateMachine.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\util\fQuery-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\util\fQuery.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\util\String-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\util\String.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\action\Message-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\control\Calendar-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\control\Calendar.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\control\CalendarResources-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\control\Control-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\control\Placeholder-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\control\Placeholder.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\control\RTE-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\control\RTE.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\control\RTEConfig-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\control\RTEConfig.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\control\Tree-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\control\Upload-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\control\Upload.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\controls\Help-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\controls\Hint-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\controls\Placement-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\Document-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\Document.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\Form-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\Form.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\LoadingIndicator-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\LoadingIndicator.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\Page-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\server\AjaxServer\AjaxServerEvent-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\server\AjaxServer\AjaxServerEvent.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\server\AjaxServer\nextAjaxResponse-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\server\AjaxServer\nextAjaxResponse.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\server\AjaxServer-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\server\Server-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\orbeon\xforms\server\UploadServer-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\javascript\xforms-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\yui\button\button-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\yui\connection\connection-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\yui\container\container-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\yui\examples\treeview\assets\js\CheckOnClickNode-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\yui\examples\treeview\assets\js\TaskNode-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\ops\yui\treeview\treeview-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\xbl\fb\dialog-itemsets\dialog-itemsets-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\xbl\fb\dialog-itemsets\dialog-itemsets.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\xbl\orbeon\wpaint\wpaint-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\resources\xbl\orbeon\wpaint\wpaint.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-error-ajax.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-group-delimiters.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-keypress.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-message.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-xforms-controls.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\bootstrap-affix.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\bootstrap-alert.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\bootstrap-button.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\bootstrap-carousel.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\bootstrap-collapse.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\bootstrap-dropdown.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\bootstrap-modal.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\bootstrap-popover.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\bootstrap-scrollspy.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\bootstrap-tab.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\bootstrap-tooltip.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\bootstrap-transition.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\bootstrap-typeahead.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\tests\phantom.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\tests\server.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\tests\unit\bootstrap-affix.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\tests\unit\bootstrap-alert.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\tests\unit\bootstrap-button.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\tests\unit\bootstrap-carousel.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\tests\unit\bootstrap-collapse.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\tests\unit\bootstrap-dropdown.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\tests\unit\bootstrap-modal.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\tests\unit\bootstrap-phantom.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\tests\unit\bootstrap-popover.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\tests\unit\bootstrap-scrollspy.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\tests\unit\bootstrap-tab.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\tests\unit\bootstrap-tooltip.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\tests\unit\bootstrap-transition.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\tests\unit\bootstrap-typeahead.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\tests\vendor\jquery.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\js\tests\vendor\qunit.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\assets\containerariaplugin-min.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\assets\containerariaplugin.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\assets\js\CheckOnClickNode.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\assets\js\dpSyntaxHighlighter.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\assets\js\json.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\assets\js\key.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\assets\js\log.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\assets\js\TaskNode.js"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\apps\home\home.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\apps\search\view.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\apps\welcome\welcome.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\config\feedback.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\config\not-found.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\config\unauthorized.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\apps\unit-tests\pages\feature-event-properties.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\apps\unit-tests\pages\issue-0619.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\apps\unit-tests\pages\issue-0889.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\apps\unit-tests\pages\issue-1431.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\apps\unit-tests\pages\issue-1888.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\converters\hello3-view.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\418.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\po.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\fb\form-with-itemsets.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\fb\form-with-metadata.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\fb\template-for-repeated-sections.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\fb\template-with-alerts.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\fb\template-with-rowspans.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\fb\template-with-schema-nonamespace.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\fb\template-with-schema.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\fb\template-with-sections-grids.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\fb\template-with-sections-repeats.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\fr\form-with-alert-levels.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\fr\form-with-long-control-names.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\xforms\analysis\binds.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\xforms\analysis\form.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\xforms\analysis\lhha.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\xforms\analysis\mips.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\xforms\analysis\model-variables.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\xforms\analysis\plain.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\xforms\analysis\variables.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\xforms\state\client-cache.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\xforms\state\client-nocache.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\xforms\state\server-cache.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\xforms\state\server-nocache.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\bookshelf\form\form.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\contact\form\form.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\controls\form\form.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\library\form\form.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\w9\form\form.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\xforms-jsp\flickr-search\index.jsp"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\xforms-jsp\flickr-search\service-search.jsp"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\xforms-jsp\guess-the-number\index.jsp"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\forms\orbeon\dmv-14\form\form.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\opensign\sign.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\pfc-atm\anything-else-view.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\pfc-atm\enter-pin-view.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\pfc-atm\low-balance-view.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\pfc-atm\view-account-view.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\portlet-preferences\edit.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\portlet-preferences\view.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\sandbox-exist\view.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\sandbox-transformations\view.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-bookcast\view.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-calculator\calc.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-cart\view.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-espresso\espresso-order.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-flickr-resize\view.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-hello\view.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\action-load-target.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\action-load.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\action-script.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\action-setfocus.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\alert-multiple.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\alert.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\alternating-rows.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\autoresize-textarea.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\avt-load.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\avt-style.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\avt-zebra.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\avts.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\boolean-input.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\boolean-mips.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\bugs\bug-delete-detached.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\bugs\bug-disabled-value-changed.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\bugs\bug-early-evaluation-during-refresh.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\bugs\bug-empty-select-update.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\bugs\bug-id-clash.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\bugs\bug-insert-preceding.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\bugs\bug-nested-repeat-indexes.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\bugs\bug-ns-clash.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\bugs\bug-repeat-alert.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\bugs\bug-repeat-index-update-clash.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\bugs\bug-sort-repeat-events.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\bugs\bug-variable-scoping.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\bugs\bug-xbl-repeat-index.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\bugs\bug-xxforms-instance-scoping.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\buttons-rows.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\coffeescript-mergesort.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\custom-events.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\date.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\datetime-fix.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\dialog-dropdown.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\dialog.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\dirty-button.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\dispatch-delay.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\dispatch-repeat.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\dynamic-dropdown.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\dynamic-image-trigger.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\empty-nested-repeat.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\event-context.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\event-item-value.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\exclusive-checkboxes.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\exfsort.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\fibonacci.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\form-runner-oracle.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\group-invalid.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\group-relevant-select.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\group-relevant-trigger.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\group-relevant.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\group-tr.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\help-panel.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\help.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\hierarchy.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\alert-users-leaving-a-form-without-saving.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\call-service-incorrect-content-type.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\changing-itemsets.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\dynamic-controls.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\edit-details-in-dialog.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\edit-hierarchy.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\error-summary.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\external-validation.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\htmlarea.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\i18n.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\load-initial-form-data-pull.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\load-initial-form-data-push.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\navigation-main.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\navigation-search.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\readonly-input-textarea.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\repeat-insert.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\store-xml-in-the-session.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\summary-of-errors.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\tree-folders.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\upload-download-instance.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\xslt-from-xforms.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\incremental-calculate-bug.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\init-load.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\input-enter.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\input-javascript-1.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\insert-delete.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\insert-while-issue.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\instance-exception.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\itemset-submission.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\iterate-setindex-variables.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\javascript-activate-trigger.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\javascript-get-set-value.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\lhha-for.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\load-calculator.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\long-submission.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\map-geocode.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\master-detail.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\menu-fck.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\menu.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\message.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\models-calculate.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\multiple-models.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\noscript-checkboxes.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\output-download.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\output-formatting.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\output-html.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\output-image.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\output-rewrite.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\password-strength.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\performance-loading.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\po.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\random.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\readonly-copies.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\readonly-instance.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\repeat-action.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\repeat-binds.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\repeat-extension-attributes.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\repeat-groups.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\repeat-homogeneous.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\repeat-image.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\repeat-move.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\repeat-nested.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\repeat-output.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\repeat-position.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\repeat-relevance.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\repeat-select.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\repeat-select1-full.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\repeat-setfocus.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\repeat-table-cells.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\repeat-tree.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\repeat-xforms-ready.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\schema-types.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\select-relevant.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\select-repeat.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\select1-hiearchy.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\shopping-cart.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\single-node-binding.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\sort.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\style-iterations.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\submission-async.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\submission-error.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\submission-post.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\submission-protected.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\submission-replace-all-1.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\submission-replace-all-2.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\submission-serialize.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\switch-in-repeat.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\switch-nested.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\table-checkboxes.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\table-overflow.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\table-radiobuttons-deferred.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-bug-checkbox-update.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-calculate-index.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-control-xhtml-area.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-custom-mips.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-deferred-client-events.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-dialog.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-disabled-nested.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-do-update.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-error-ajax.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-error-warning.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-flat-repeat.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-group-delimiters.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-help-model.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-instance-invalidate.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-keypress.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-loading-indicator.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-message.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-min-viewport-width.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-orbeon-dom.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-output-update.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-placeholder.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-post-cache.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-readonly.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-repeat-setvalue.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-repeat.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-screen-reader.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-select-html-labels.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-switch-disabled.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-trigger-modal.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-type-date.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-underscore.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-update-full.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-upload-replace-instance.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-visual-relevance.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-visual-switchcase.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-xbl-binding-dispatch.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-xforms-controls.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\test-xhtml-area.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\tidy-html.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\toggle-select1.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\tree-update.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\tree.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\trigger-appearances.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\unit-tests.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\web-service-weather.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\while.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xbl-box-select.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xbl-composition-order.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xbl-currency.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xbl-databound-switch.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xbl-date.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xbl-datetime.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xbl-handlers.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xbl-html-ids.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xbl-map.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xbl-nested-repeats.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xbl-phone.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xbl-readonly.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xbl-repeat-date.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xbl-setindex2.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xbl-simple.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xbl-tutorial-davinci.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xbl-tutorial-input.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xbl-xslt-scope.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xbl-xslt.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xforms-copy.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xforms-functions.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xinclude.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xpath-expressions.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xpath-type-annotations.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xxf-dynamic-simple.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xxforms-evaluate.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\xxforms-functions.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\upload-view.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-todo\view.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-upload\view.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-translate\view.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-wizard-pfc\step1-firstname.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-wizard-pfc\step2-lastname.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-wizard-pfc\step3-age.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-wizard-pfc\step4-summary.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-wizard-switch\view.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xquery-the-web\view.xhtml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\style\bootstrap-src\Makefile"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\assets\get.php"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\assets\post.php"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\container\assets\somedata.php"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources-packaged\ops\yui\examples\treeview\assets\ysuggest_proxy.php"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\persistence\relational\ddl\db2-4_3-to-4_4.sql"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\persistence\relational\ddl\db2-4_3.sql"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\persistence\relational\ddl\db2-4_4-to-4_6.sql"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\persistence\relational\ddl\db2-4_4.sql"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\persistence\relational\ddl\db2-4_6.sql"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\persistence\relational\ddl\mysql-4_3-to-4_4.sql"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\persistence\relational\ddl\mysql-4_3.sql"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\persistence\relational\ddl\mysql-4_4-to-4_5.sql"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\persistence\relational\ddl\mysql-4_4.sql"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\persistence\relational\ddl\mysql-4_5-to-4_6.sql"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\persistence\relational\ddl\mysql-4_5.sql"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\persistence\relational\ddl\mysql-4_6.sql"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\persistence\relational\ddl\oracle-4_3-to-4_4.sql"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\persistence\relational\ddl\oracle-4_3.sql"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\persistence\relational\ddl\oracle-4_4-to-4_5.sql"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\persistence\relational\ddl\oracle-4_4.sql"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\persistence\relational\ddl\oracle-4_5-to-4_6.sql"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\persistence\relational\ddl\oracle-4_5.sql"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\persistence\relational\ddl\oracle-4_6.sql"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\persistence\relational\ddl\sqlserver-4_6.sql"
REM ARGS -exclude "PROJECTROOT0_MARKER\test\catalina_base\conf\server.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\antrun\build-main.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\classes\org\orbeon\oxf\processor\xmldb\future-example.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\classes\org\orbeon\oxf\xforms\xforms-types.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\classes\org\orbeon\oxf\xml\schemas\pipeline.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\classes\org\orbeon\oxf\xml\schemas\xbl-orbeon.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\classes\org\orbeon\oxf\xml\schemas\xforms-1_0-orbeon.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\classes\org\orbeon\oxf\xml\schemas\xhtml1-transitional-orbeon.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\classes\org\orbeon\oxf\xml\schemas\xinclude-orbeon.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\classes\org\orbeon\oxf\xml\schemas\xml-events-1.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\classes\org\orbeon\oxf\xml\schemas\xml-events-attribs-1.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\classes\org\orbeon\oxf\xml\schemas\XML-Events-Schema.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\classes\org\orbeon\oxf\xml\schemas\xml.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\classes\org\orbeon\oxf\xml\schemas\XMLSchema.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\classes\org\orbeon\oxf\xml\schemas\xslt-2_0.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\classes\org\orbeon\oxf\xml\schemas\xupdate.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\classes\org\orbeon\oxf\processor\xmldb\future-example.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\classes\org\orbeon\oxf\xforms\xforms-types.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\classes\org\orbeon\oxf\xml\schemas\pipeline.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\classes\org\orbeon\oxf\xml\schemas\xbl-orbeon.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\classes\org\orbeon\oxf\xml\schemas\xforms-1_0-orbeon.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\classes\org\orbeon\oxf\xml\schemas\xhtml1-transitional-orbeon.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\classes\org\orbeon\oxf\xml\schemas\xinclude-orbeon.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\classes\org\orbeon\oxf\xml\schemas\xml-events-1.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\classes\org\orbeon\oxf\xml\schemas\xml-events-attribs-1.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\classes\org\orbeon\oxf\xml\schemas\XML-Events-Schema.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\classes\org\orbeon\oxf\xml\schemas\xml.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\classes\org\orbeon\oxf\xml\schemas\XMLSchema.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\classes\org\orbeon\oxf\xml\schemas\xslt-2_0.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\classes\org\orbeon\oxf\xml\schemas\xupdate.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\dispatcher-servlet.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\jboss-scanning.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\jboss-web.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\liferay-display.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\liferay-portlet.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\portlet.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\apps\home\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\apps\search\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\apps\welcome\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\config\form-builder-permissions.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\config\license.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\config\log4j.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\config\processors-local.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\config\properties-local.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\page-flow-portlet-edit.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\page-flow-portlet.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\resources\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\sun-web.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\web.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\mpn\WEB-INF\weblogic.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\apps\unit-tests\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\config\log4j.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\config\properties-local.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\forms\cache-test\noscript-false-pdf-template-wizard-true\form\form.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\forms\cache-test\noscript-true-pdf-auto-wizard-false\data\15c4a18428496faa1212d86f58c62d9d3c51cf0d\data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\forms\cache-test\noscript-true-pdf-auto-wizard-false\data\6578e2e0e7911fd9ba284aefaea671cbfb814851\data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\forms\cache-test\noscript-true-pdf-auto-wizard-false\form\form.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\address-book-schema.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\b-1.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\b-2.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\bean-generator-config1.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\bean-generator-mapping1.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\c-1.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\c-2.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\d-1.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\d-2.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\document1.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\document2.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\document3.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\document4.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\document5.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\e-1.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\e-2.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\request1.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\request2.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\request3.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\request4.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\scope-generator-config1.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\scope-generator-config2.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\stylesheet-fragment1.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\tests-cache.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\url-generator-config1.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\cache\url-generator-config2.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\chapter03env.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\chapter03ord.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\comments.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\company.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\converters\claim-1.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\converters\tests-converters.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\converters\with-top-level-pi.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\docbase\chapter03prod.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\docbase\chapter03prod2.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\docbase\docs\abc.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\docbase\pipeline.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\email\example-1.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\email\example-2.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\email\example-3.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\exist-conf.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\form-attributes.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\form-builder\annotated.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\form-builder\deannotated.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\form-builder\template.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\form-builder\tests-form-builder.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\form.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\log4j.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\note.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\processor\file.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\properties-versioned-all.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\properties-versioned-orbeon.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\properties.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\recurse.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\sql\config-1.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\sql\config-2.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\sql\config-3.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\sql\config-4.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\sql\config-5.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\sql\config.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\sql\input.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\test-data\book-diderot.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\tests-email.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\tests-fr-fb.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\tests-java.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\tests-ldap.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\tests-matchers.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\tests-page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\tests-qname-converter.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\tests-sql.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\tests-transformations.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\tests-url-rewrite.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\tests-validation.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\tests-xpl.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\tests-xupdate.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\tests.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\url-generator\encoding-iso.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\url-generator\encoding-utf8.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\url-generator\included-1.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\url-generator\included-2.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\url-generator\included-3.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\url-generator\including.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\url-generator\tests-url-generator.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\url-rewrite\input-data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\url-rewrite\output-data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\ajax-request-with-external-entity.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\ajax-request.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\repeat-full-controls.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\repeat-model.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\sample-instance.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\schema-imported.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\schema-importing.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\tests-xforms-actions.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\tests-xforms-ajax.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\tests-xforms-components.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\tests-xforms-events.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\tests-xforms-focus.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\tests-xforms-functions.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\tests-xforms-itemset.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\tests-xforms-layout.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\tests-xforms-mips.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\tests-xforms-misc.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\tests-xforms-repeat.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\tests-xforms-submission.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\tests-xforms-validation.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\tests-xforms-variable.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\tests-xforms-xbl.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\tests-xforms-xpath-analysis.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-server\xforms-calculator-controls.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-test-schema.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xforms-validation.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xinclude\tests-xinclude.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xinclude\xinclude-to.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xinclude\xinclude1.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xinclude\xinclude2.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xinclude\xinclude3.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xinclude\xinclude4.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xinclude\xinclude5.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xinclude\xinclude6.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xinclude\xinclude7.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\ops\unit-tests\xinclude\xinclude8.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\default-request.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\processor\xinclude\include11.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\processor\xinclude\include12.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\processor\xinclude\include21.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\processor\xinclude\include22.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\processor\xinclude\include23.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\processor\xinclude\include31.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\processor\xinclude\include32.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\processor\xinclude\include41.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\processor\xinclude\include42.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\processor\xinclude\include43.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\test\anyuri-test-content.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\test\if-modified-since-request.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\util\url-rewriter-test-request-filter.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\util\url-rewriter-test-request-forward.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\util\url-rewriter-test-request.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\xforms\analysis\request.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\target\test-classes\org\orbeon\oxf\xforms\processor\test-form.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\pom.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\bookshelf\data\16ab5903c7f0deb74fdc51dbdf705375\data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\bookshelf\data\24565d3894e9d1P6O4RdT0f9a70f3d74\data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\bookshelf\data\3ecb36b2338bd4a37b063bc39a15138f\data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\bookshelf\data\3fb8620e26ad68404706c7a4e73d4baf\data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\bookshelf\data\5bba537614484bd9e33c97bfc7649889\data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\bookshelf\data\783db082af50ae6675b7ea411c1f0994\data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\bookshelf\data\891ce63e59c17348f6fda273afe28c2b\data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\bookshelf\data\9531a191c77b75c417e9874427fa21f7\data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\bookshelf\data\ad6f8583a9644c36aa1794eb69024a37\data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\bookshelf\data\c23140188670605bdde181c2a3476dae\data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\bookshelf\data\e8bfd3ba63fa12a8b59cdd5c08369a35\data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\bookshelf\data\fd5dfce7a236758e72910d333bf832f8\data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\builder\data\417b8b4473f6db9e0f94b05ccb9208be\data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\builder\data\51cbb050c39fa094efe721da690eb168\data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\builder\data\52c62a05a09601f37a121101468f9f98\data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\builder\data\669de95ea7bf7839c342b46328586046\data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\builder\data\b9d842b71560cf9278422f88a32bfaf7419a7b01\data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\contact\data\9eff349bfd95aab8d4d5e048bd25a815\data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\dmv-14\data\6b01fa4cd1605b8f736fac09be6cf9b2\data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\data\orbeon\fr\orbeon\w9\data\4a83b4cf2b905fbe105d7e57ddc5597b5e78c0a3\data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\dispatcher-servlet.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\exist-conf.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\jboss-scanning.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\jboss-web.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\liferay-display.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\liferay-portlet.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\portlet.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\sun-web.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\web.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\build\mpn-app-war\WEB-INF\weblogic.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\forms\orbeon\controls\service\countries.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\java-api\input.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\java-api\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\java-properties\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\opensign\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\pfc-atm\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\pfc-atm\see-you-again-view.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\portlet-preferences\page-flow-edit.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\portlet-preferences\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\sandbox-exist\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\sandbox-transformations\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\sandbox-transformations\parameters.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\sandbox-transformations\schema\input.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\sandbox-transformations\schema\transformation.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\sandbox-transformations\xpath\input.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\sandbox-transformations\xpath\transformation.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\sandbox-transformations\xpl\input.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\sandbox-transformations\xpl\transformation.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\sandbox-transformations\xquery\input.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\sandbox-transformations\xquery\transformation.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\sandbox-transformations\xslt\input.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\sandbox-transformations\xslt\transformation.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\sandbox-transformations\xupdate\input.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\sandbox-transformations\xupdate\transformation.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-bookcast\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-bookcast\sample-data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-bookcast\schema.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-calculator\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-cart\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-espresso\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-flickr-resize\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-hello\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\bugs\bug-events-data.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\external-validation-response.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\i18n-resources.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\howto\load-initial-form-data-pull-instance.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\include.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\samples\schema-types.xsd"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-sandbox\services\zip-flat.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-todo\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-upload\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-translate\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-wizard-pfc\initial-instance.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-wizard-pfc\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xforms-wizard-switch\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xquery-the-web\page-flow.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\xquery-the-web\parameters.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\persistence\exist\propagate-exist-error.xml"
REM ARGS -exclude "PROJECTROOT0_MARKER\src\resources\apps\fr\persistence\exist\search.xml"
REM ARGS "PROJECTROOT0_MARKER"
